; @(#)player.s 2008/03/09
;
; ICE Team free software group
;
; This file is part of JIIT64 Java Ice Team Tracker 64
; See README for copyright notice. 
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA

  .processor 6502

; Pattern searching for tune created with JITT64 editor 1.00/player 1.0
; JITT64_(E1.00_P1.0)
; 0A 09 14 14 00 00 AA BD ?? ?? 8D ?? ?? BD ?? ?? 8D END

; Pattern searching for tune created with JITT64 editor 1.01/player 1.1
; JITT64_(E1.01_P1.1)
; 0A 09 14 14 00 01 AA BD ?? ?? 8D ?? ?? BD ?? ?? 8D END

; Pattern searching for tune created with JITT64 editor 1.02/player 1.2
; JITT64_(E1.02_P1.2)
; 0A 09 14 14 00 02 AA BD ?? ?? 8D ?? ?? BD ?? ?? 8D END

; Pattern searching for tune created with JITT64 editor 1.03/player 1.3
; JITT64_(E1.03_P1.3)
; 0A 09 14 14 00 03 AA BD ?? ?? 8D ?? ?? BD ?? ?? 8D END

; passed at compile time as external definitions
; EX_SID
; EX_BASE
; EX_SPEED
; EX_CHIP
; NUM_TUNE  
; NUM_PAT
; NUM_INSTR
; A4_FREQ

; USE_INSTR_AD
; USE_INSTR_SR
; USE_INSTR_WAVE
; USE_INSTR_FREQ
; USE_INSTR_PULSE
; USE_INSTR_FILTER
; USE_INSTR_RES
; USE_INSTR_TYPE

; USE_CMD_TEMPO
; USE_CMD_AD
; USE_CMD_SR
; USE_CMD_VOLUME
; USE_CMD_ARP
; USE_CMD_PUP
; USE_CMD_PDN
; USE_CMD_TPO
; USE_CMD_VIB
; USE_CMD_SUP
; USE_CMD_SDN
; USE_CMD_FOUT
; USE_CMD_FTY
; USE_CMD_FRS
; USE_CMD_FCU
; USE_CMD_GSR

; USE_UOP
; USE_MZP

; address in zero page
ADDR_LOW   = $80
ADDR_HIGH  = $81
ADDR_LOW2  = $82
ADDR_HIGH2 = $83
TEMP       = $84
TEMP2      = $85

; // use more zeropages for improving speed
 .if USE_MZP=1
ADDR_LOWD  = $86
ADDR_HIGHD = $87
ADDR_LOWR  = $88
ADDR_HIGHR = $89
 .endif

PORT_MULT  = 2     ; portamento multiplier

; pattern special values
PAT_END  = 255
PAT_NULL = 254
PAT_KOFF = 253
PAT_KON  = 252
PAT_REST = 251

; commands value
CMD_STOP  = 0     ; set stop
CMD_TEMPO = 1     ; set tempo
CMD_AD    = 2     ; set attack/decay
CMD_SR    = 3     ; set sustain/release
CMD_VOL   = 4     ; set volume
CMD_ARP   = 5     ; set arpeggio
CMD_PUP   = 6     ; set portamento up
CMD_PDN   = 7     ; set portamento down
CMD_TPO   = 8     ; set tone portamento
CMD_VIB   = 9     ; set vibrato
CMD_SUP   = 10    ; set slide up
CMD_SDN   = 11    ; set slide down
CMD_AFO   = 12    ; set auto fade out
CMD_FTY   = 13    ; set filter type
CMD_FRE   = 14    ; set filter resonance
CMD_FCU   = 15    ; set filter cut off
CMD_GSR   = 16    ; set gate sustain/release

;================================
; Read the value of passed table
; pointer of voice x with the y
; index
;================================
 .MAC TBLR
      lda  {1}_L,x               ; [4*]
      sta  ADDR_LOW              ; [3]
      lda  {1}_H,x               ; [4*]
      sta  ADDR_HIGH             ; [3]
      lda  (ADDR_LOW),y          ; [5*] = 19*
 .ENDM

;================================
; Read the value of passed table
; pointer of voice x with the y
; index
;================================
 .MAC TBLR2
      lda  {1}_L,x
      sta  ADDR_LOW2
      lda  {1}_H,x
      sta  ADDR_HIGH2
      lda  (ADDR_LOW2),y
 .ENDM

 .if EX_SID=1
 .ORG EX_BASE-126

 .byte "PSID"
 .word $0200         ; version 2
 .word $7C00         ; data offset
 .word $0000         ; load address in cbm format
 .byte >pl_init
 .byte <pl_init
 .byte >pl_play
 .byte <pl_play
 .byte $00           ; number of tunes
 .byte NUM_TUNE      ; number of tunes
 .word $0100         ; default song
 .if EX_SPEED=1
 .word $0000         ; 1x VIC
 .word $0000
 .else;
 .word $FFFF         ; xx CIA
 .word $FFFF
 .endif

 .byte PSID_NAME
 .byte PSID_AUTHOR
 .byte PSID_COPYRIGHT
 .if EX_CHIP=1
 .word $1400
 .endif
 .if EX_CHIP=2
 .word $2400
 .endif
 .if EX_CHIP=3
 .word $3400
 .endif
 .word $0000
 .word $0000

  .byte <EX_BASE
  .byte >EX_BASE
 .endif

 .if EX_SID=2
 org 2049

  .byte $0b,$08,$e8,$03,$9e,"2061",0,0,0

  .org 2061

CHOUT    = $FFD2
SCREEN   = $E536    ; clean the screen with color
SET_COOR = $E50C 
STRING   = $AB1E

  jsr  pl_init
 
  lda  #$00
  sta  53280
  jsr  SCREEN 
  ;lda  #$01
  ;sta  53281
  
  ldx  #3
  ldy  #3
  jsr  SET_COOR
  lda  #<program
  ldy  #>program
  jsr  STRING                      ; write program name

  ldx  #5
  ldy  #3
  jsr  SET_COOR
  lda  #<rastertime
  ldy  #>rastertime
  jsr  STRING                      ; write rastertime string

  ldx  #6
  ldy  #3
  jsr  SET_COOR
  lda  #<rastertime2
  ldy  #>rastertime2
  jsr  STRING                      ; write rastertime string

  ldx  #7
  ldy  #3
  jsr  SET_COOR
  lda  #<rastertime3
  ldy  #>rastertime3
  jsr  STRING                      ; write rastertime string

  ldx  #20
  ldy  #3
  jsr  SET_COOR

  sei
  lda  #<raster0
  sta  $0314
  lda  #>raster0
  sta  $0315
 .if EX_SPEED=1
  lda  #0                          ;Set low bits of raster
  sta  $d012                       ;position
  lda  $d011
  and  #$7f                        ;Set high bit of raster
  sta  $d011                       ;position (0)
  lda  #$7f                        ;Set timer interrupt off
  sta  $dc0d

  lda  #$01                        ;Set raster interrupt on
  sta  $d01a
  lda  $dc0d                       ;Acknowledge timer interrupt
 .else
  lda  #$81                        ; Enable CIA 1 timer A interrupt
  sta  $dc0d
  ;lda  #$01
  ;sta  $dc0e
 .endif
  cli
  rts

;=================================
; input a=$12 output x= $31 "1" a= $32 "2"
;=================================
atoax:
      pha                      ; save A for lo-nibble fetch
      lsr
      lsr
      lsr
      lsr
      ora  #$30
      tax
      pla                      ;lo-nibble fetch
      and  #$0F
      ora  #$30
      cmp  #$3A
      bmi  skipatoax

      sec
      sbc  #57
skipatoax
      rts

program:
  .byte 5, "JITT64 PLAYER VER 1.03", 0
rastertime:
  .byte 5, "MAX RASTERTIME REACHED: ", 0
rastertime2:
  .byte 5, "AVG RASTERTIME REACHED: ", 0
rastertime3:
  .byte 5, "MIN RASTERTIME REACHED: ", 0

actualmin:
  .byte 255

actualmax:
  .byte 0

indexmax:
  .byte 0

summax:
  .byte 0, 0

actualraster:
  .byte 0

avgtable:
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0
  .byte 0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0,  0, 0, 0, 0

raster0:
  inc  53280
  jsr  pl_play
  dec  53280
                                   ; calculate rastertime
  lda  $d012
  sta  actualraster
                                   ; calculate max        
  cmp  actualmax
  bmi  skipMax

  sta  actualmax

skipMax:
  lda  actualmax
  jsr  atoax
  stx  $400+40*5+27
  sta  $400+40*5+28

                                   ; calculate average  
  ldy  indexmax  
  lda  summax+1
  sec
  sbc  avgtable,y
  sta  summax+1
  lda  summax
  sbc  #$00
  sta  summax

  lda  actualraster
  sta  avgtable,y
  clc
  adc  summax+1
  sta  summax+1
  lda  #$00
  adc  summax  
  sta  summax

  inc  indexmax

  lda  summax
  jsr  atoax
  stx  $400+40*6+27
  sta  $400+40*6+28
                                   ; calculate min
  lda  actualraster
  cmp  actualmin
  bcs  skipMin

  sta  actualmin

skipMin:
  lda  actualmin
  jsr  atoax
  stx  $400+40*7+27
  sta  $400+40*7+28 

  dec  $d019
  jmp  $ea31
 .endif

 .ORG EX_BASE

      ; Jump table

      jmp pl_init
      jmp pl_play

  ;.byte 10, 9, 20, 20, 0, 0    ; JITT editor ver 1.00, player ver 1.0
  ;.byte 10, 9, 20, 20, 0, 1    ; JITT editor ver 1.01, player ver 1.1
  ;.byte 10, 9, 20, 20, 0, 2    ; JITT editor ver 1.02, player ver 1.2
  .byte 10, 9, 20, 20, 0, 3     ; JITT editor ver 1.03, player ver 1.3

  ; if you modify the editor/player for your own use, please
  ; remove the below comment so we can pattern searching
  ; your modification. Thanks
  ; .byte 0

;=================================
; init routine
; A=tune to use
;=================================
pl_init:
      tax
                                  ; set pointers to the tracks of tune
      lda  tuneTrack1_L,x
      sta  tuneTrack_L
      lda  tuneTrack1_H,x
      sta  tuneTrack_H

      lda  tuneTrack2_L,x
      sta  tuneTrack_L+7
      lda  tuneTrack2_H,x
      sta  tuneTrack_H+7

      lda  tuneTrack3_L,x
      sta  tuneTrack_L+$e
      lda  tuneTrack3_H,x
      sta  tuneTrack_H+$e
                                  ; clear index position inside the track

      ldx  #$0e
loop_voice_init:

      lda  #0
      sta  trackIndex,x           ; clear track index
      sta  trackTransp,x          ; clear track transpose
      sta  trackRepeat,x          ; clear track repeat                                
      sta  trackRelStep,x         ; clear track step to reload                                  
      sta  trackSteps,x           ; clear current track step                                  
      sta  stopTrack,x            ; clear the stop to tracks
      sta  activeCommand,x        ; clear active command
      sta  actCommand2,x          ; clear active command 2
      sta  actCommand3,x          ; clear active command 3
      sta  alreadyInstr,x         ; clear already instr started

      jsr  pl_read_track

    .if USE_UOP=0
      txa                         ; loop to next voice  [2]
      sec                         ;                     [2]
      sbc  #$07                   ;                     [2]
      tax                         ;                     [2] =8
    .else 
      lda #$FF                    ;                     [2] 
      .byte $CB, $07              ; sax #$07            [2] =4
    .endif
      bpl  loop_voice_init

      lda  #15
      sta  shadow_VOL

    .if EX_SPEED=0               ; 0.5X
      lda  #$8F
      sta  $DC05
      lda  #$99
      sta  $DC04 
    .endif
    .if EX_SPEED=2               ; 2X
      lda  #$26
      sta  $DC05
      lda  #$63
      sta  $DC04 
    .endif
    .if EX_SPEED=3               ; 3X
      lda  #$19
      sta  $DC05
      lda  #$97
      sta  $DC04 
    .endif
    .if EX_SPEED=4               ; 4X
      lda  #$15
      sta  $DC05
      lda  #$A7
      sta  $DC04 
    .endif
      rts

;=================================
; play routine
; SID registers are output at the 
; begginning, so the one calculated
; the cycle before.
;=================================
pl_play:
      lda  shadow_FCL             ; put filter freq.
      sta  $D415
      lda  shadow_FCH
      sta  $D416

      lda  shadow_TYPE
      and  #$0F                   ; take the low nibble
      clc
      adc  shadow_RES
      sta  $D417

      lda  shadow_TYPE
      and  #$F0                   ; take the high nibble
      clc
      adc  shadow_VOL
      sta  $D418

      ldx  #$0e
loop_voice:
 .if USE_CMD_GSR=1
      lda  actCommand3,x          ; command 3 flag
      cmp  #1
      bne  skipC3

      lda  shadow_CTRL,x          ; CRTL
      and  #$FE
      sta  $D404,x                ; clear gate

      lda  #$00
      sta  actCommand3,x          ; clear command 3 flag
 .endif

skipC3:                           ; put shadow regs to sid registers

      lda  instr_HR,x             ; test for order in writing to sid
      and  #$20
      bne  diffOrder

      lda  shadow_FL,x
      sta  $D400,x
      lda  shadow_FH,x
      sta  $D401,x
      lda  shadow_PL,x
      sta  $D402,x
      lda  shadow_PH,x
      sta  $D403,x
      lda  shadow_CTRL,x          ; wave <-> ADSR order
      sta  $D404,x
      lda  shadow_AD,x
      sta  $D405,x
      lda  shadow_SR,x
      sta  $D406,x
      jmp  contAftOrder

diffOrder:
      lda  shadow_AD,x           ; ADSR <-> Wave order
      sta  $D405,x
      lda  shadow_SR,x
      sta  $D406,x
      lda  shadow_FL,x
      sta  $D400,x
      lda  shadow_FH,x
      sta  $D401,x
      lda  shadow_PL,x
      sta  $D402,x
      lda  shadow_PH,x
      sta  $D403,x
      lda  shadow_CTRL,x
      sta  $D404,x

contAftOrder:
    .if USE_UOP=0
      txa                         ; loop to next voice  [2]
      sec                         ;                     [2]
      sbc  #$07                   ;                     [2]
      tax                         ;                     [2] =8
    .else 
      lda #$FF                    ;                     [2] 
      .byte $CB, $07              ; sax #$07            [2] =4
    .endif
      bpl  loop_voice

;==========
; Now calculate new sound
;==========
      ldx  #$0e
loop_voice2:
      lda  shadow_FL,x            ; copy frequency for toneportamento
      sta  copy_FL,x
      lda  shadow_FH,x
      sta  copy_FH,x
    
      lda  stopTrack,x            ; skip player if track is finished
      bne  skipPlayer

      jsr  pl_play_voice          ; play the core of voice
      jsr  pl_play_command        ; play command of pattern
      jsr  pl_play_hr             ; play hr if this is the case      

skipPlayer:
    .if USE_UOP=0
      txa                         ; loop to next voice  [2]
      sec                         ;                     [2]
      sbc  #$07                   ;                     [2]
      tax                         ;                     [2] =8
    .else 
      lda #$FF                    ;                     [2] 
      .byte $CB, $07              ; sax #$07            [2] =4
    .endif
      bpl  loop_voice2     
      rts

;=================================
; play a HR if this is the case
;=================================
pl_play_hr:
      lda  hrActive,x             ; HR activated into this row?
      beq  skipPlayer

      lda  instr_HR,x             ; read HR of instrument
      and  #$0F
      sta  TEMP                   ; isolate the ticks
      inc  TEMP                   ; we check for minor of this

      ldy  pattDelay,x            ; read actual remaining delay ticks 
      beq  latest                 ; last ticks?
      cpy  TEMP
      bpl  exitPHR                ; no time for HR

      lda  hrActive,x
      bmi  fullHR

      lda  shadow_CTRL,x          ; put gate off
      and  #$FE
      sta  shadow_CTRL,x
      rts

fullHR:                           ; activate the full HR
      lda  instr_AD,x
      sta  shadow_AD,x
      lda  instr_SR,x
      sta  shadow_SR,x
      lda  instr_CTRL1,x
      sta  shadow_CTRL,x
      rts

latest:                           ; latest cicle before new note
      lda  instr_HR,x 
      and  #$80                   ; HR?
      beq  exitPHR                ; no, gate off, so skip

      lda  instr_CTRL2,x
      sta  shadow_CTRL,x          ; put control 2 to did

exitPHR:
      rts

;=================================
; Get the instrument used into the
; next row of pattern (following
; even the tracks logic)
; A=read instrument (0=no)
;=================================
get_next_instr:
      ldy  pattIndex,x            ; read pattern index
      iny                         ; increment it

      TBLR pattPoint1             ; read the value of note

      cmp  #PAT_END               ; end of pattern reached ?
      beq  readNPIT

      TBLR pattPoint2             ; read the value of instrument
      rts

readNPIT:

;=================================
; Simulate Read next pattern in track
;=================================
SPL_read_track:
      lda  trackIndex,x           ; read actual track index
SPL_read_track_:
      tay
SPL_read_track__:
      TBLR tuneTrack              ; read the value of track

                                  ; decode and manage the value
      cmp  #$DF
      bcs  isNotPattern_

;=======
; Pattern
;=======
      tay
      lda  pat_b2_low,y           ; read pattern of instrument
      sta  ADDR_LOW
      lda  pat_b2_high,y
      sta  ADDR_HIGH
      ldy  #1
      lda  (ADDR_LOW),y           ; read the value of instrument
      rts 

isNotPattern_:
      bne  isNotRepCmd_

;========
; Repeat cmd
;========
      iny
      jmp  SPL_read_track_        ; read and execute next command

isNotRepCmd_:
      cmp  #$FF                   ; restart command ?
      bne  isNotRestCmd_

;========
; Restart command
;========
      iny                         ; inc actual track index value 
      lda  (ADDR_LOW),y           ; read the value of track 
      cmp  #$FF                   ; no restart ?
      beq  notRestart_    

      ;sta  trackIndex,x          ; store new index pointer
      jmp  SPL_read_track_        ; read and execute next command

notRestart_:                       ; track is finished
      lda  #0
      rts

isNotRestCmd_:
      ;sec
      ;sbc  #$EF                   ; subtract the value of transpose 0
      ;sta  trackTransp,x
      ;inc  trackIndex,x           ; inc actual track index
      iny
      jmp  SPL_read_track__        ; go to execute next cmd

;=================================
; play the voice passed in X
; and decode the pattern values
;=================================
pl_play_voice:
      dec  pattDelay,x            ; decrement delay tempo for the pattern
      bpl  exitPV

      jsr  pl_play_pattern        ; play pattern

      lda  instr_HR,x             
      and  #$C0                   ; HR or gate off?
      sta  hrActive,x             ; suppose HR activated into this row
      beq  exitPV_                ; no, so exit and no HR

      jsr  get_next_instr         ; get the instrument into next row
      cmp  #0                     ; no instrument into next row?
      bne  exitPV        
                                  ; activated the HR/gate off into this row
exitPV_:
      lda  #0
      sta  hrActive,x             ; no HR activated into this row

exitPV:
      jsr  pl_intr_core           ; play instruction core
      rts

;=================================
; play the pattern
;=================================
pl_play_pattern:
      lda  #0
      sta  actCommand2,x          ; clear actual command 2

      lda  pattTempo,x            ; restore tempo with saved one
      sta  pattDelay,x

      inc  pattIndex,x            ; increment pattern index
      ldy  pattIndex,x            ; read index

      TBLR pattPoint1             ; read the value of note

      cmp  #PAT_END               ; end of pattern reached ?
      beq  nextPattInTrack

      cmp  #PAT_NULL              ; null value ?
      beq  executeB2

      cmp  #PAT_KON               ; key on ?
      bne  testKOff

      lda  #4
      sta  actCommand2,x          ; put key on command
      jmp  executeB2              ; execute byte 2

testKOff:
      cmp  #PAT_KOFF              ; key off ?
      bne  testRest

      lda  #8
      sta  actCommand2,x          ; put key off command
      jmp  executeB2              ; execute byte 2

testRest:
      cmp  #PAT_REST
      bne  isNote

      lda  #$10
      sta  actCommand2,x          ; put rest command
      jmp  executeB2              ; execute byte 2

isNote:
      clc
      adc  trackTransp,x          ; add the transpose for this pattern
      sta  actNote,x              ; store the value in actual note
      tay
      lda  frequencyLo,y
      sta  shadow_FL,x

      lda  frequencyHi,y
      sta  shadow_FH,x

      lda  #0
      sta  activeCommand,x        ; stop all pattern command
      jmp  executeB2              ; execute byte 2

exitPP:
      rts

nextPattInTrack:
      jsr  pl_read_track

      lda  stopTrack,x            ; if no more track, exit
      bne  exitPP

      jmp  pl_play_pattern

;=================================
; execute byte 2 (instruction)
;=================================
executeB2:
      ldy  pattIndex,x            ; read index (again)
      TBLR pattPoint2             ; read the value of instrument
      beq  executeB3              ; skip if zero

      jsr  pl_new_instr           ; set up a new instrument 

;=================================
; execute B3 (command)
;=================================
executeB3:
      ldy  pattIndex,x            ; read index (again)
      TBLR pattPoint3             ; read the value of command
      sta  actCommand,x

      ;ldy  pattIndex,x            ; read index (again)
      TBLR pattPoint4             ; read the value of param
      sta  actParam,x

                                  ; check for all possible commands and initialize them
      ldy  actCommand,x           ; read command in y
      cpy  #CMD_STOP              ; test for stop command
      bne  chk_next0

      cmp  #0
      beq  exitPP

      eor  #$FF
      and  activeCommand,x
      sta  activeCommand,x
      rts

;=======
; Set Tempo
;=======
chk_next0:
 .if USE_CMD_TEMPO=1
      cpy  #CMD_TEMPO             ; test for set tempo
      bne  chk_next1

      cmp  #0
      beq  setNT

      sta  pattTempo,x            ; store new pattern tempo to use
      sta  pattDelay,x
      rts

setNT:
      ldy  #0
      TBLR pattPoint1             ; read pattern value
      sta  pattTempo,x            ; set the pattern tempo for the pattern
      sta  pattDelay,x
      rts
 .endif

;=======
; Set AD
;=======

chk_next1:
 .if USE_CMD_AD=1
      cpy  #CMD_AD                ; test for set atack/decay
      bne  chk_next2

      sta  cmdADSR,x              ; store in command AD reg.

      lda  #1                     ; set for a AD in next command play routine
      sta  actCommand2,x
      rts
 .endif

;=======
; Set SR
;=======

chk_next2:
 .if USE_CMD_SR=1
      cpy  #CMD_SR                ; test for sustain/release
      bne  chk_next3

      sta  cmdADSR,x              ; store in command SR reg.

      lda  #2                     ; set for a SR in next command play routine
      sta  actCommand2,x
      rts
 .endif

;========
; Set Volume
;========

chk_next3:
 .if USE_CMD_VOLUME=1
      cpy #CMD_VOL                ; test for volume
      bne chk_next4

      sta  shadow_VOL             ; store in shadow volume reg.
      rts
 .endif

;========
; Set Arpeggio
;========

chk_next4:
 .if USE_CMD_ARP=1
      cpy  #CMD_ARP               ; test for arpeggio
      bne  chk_next5

      sta  actParam,x

      rol                         ; isolate the speed
      rol
      rol
      and  #$03
      sta  speedArpeggio,x
      sta  speedRelArp,x

      lda  actParam,x
      lsr
      lsr
    .if USE_UOP=0
      lsr                         ;          [2]
      and  #$07                   ;          [2] = 4
    .else
      .byte $4B, $0E              ; ALR #$0E [2] = 2
    .endif
      clc 
      adc  actNote,x
      sta  note1Arpeggio,x        ; store first arpeggio note

      lda  actParam,x
      and  #$07
      clc
      adc  note1Arpeggio,x
      sta  note2Arpeggio,x        ; store second arpeggio note

      lda  #$01
      ora  activeCommand,x        ; activate arpeggio effect
      sta  activeCommand,x

      lda  #0
      sta  posArpeggio,x
      rts
 .endif

;========
; Set Port. up
;========

chk_next5:
 .if USE_CMD_PUP=1
      cpy  #CMD_PUP               ; test for portamento up
      bne  chk_next6

      sta  freqPortUp,x           ; store freq. for portamento up

      lda  #$02
      ora  activeCommand,x        ; activate portamento up
      sta  activeCommand,x
      rts
 .endif

;========
; Set Port. dn
;========

chk_next6:
 .if USE_CMD_PDN=1
      cpy  #CMD_PDN               ; test for portamento dn
      bne  chk_next7

      sta  freqPortDn,x           ; store freq. for portamento dn

      lda  #$04
      ora  activeCommand,x        ; activate portamento dn
      sta  activeCommand,x
      rts
 .endif

;========
; Set Tone Port.
;========

chk_next7:
 .if USE_CMD_TPO=1
      cpy  #CMD_TPO               ; test for tone portamento
      bne  chk_next8

      sta  freqTonePort,x         ; store freq. for tone portamento

      lda  #$08
      ora  activeCommand,x        ; activate toneportamento
      sta  activeCommand,x

      lda  #00                    ; suppose to have a up direction
      sta  toneDir,x

      lda  shadow_FH,x            ; store tone frequency to reach
      sta  tone_FH,x
      lda  shadow_FL,x
      sta  tone_FL,x

      lda  copy_FL,x              ; store the copy as the freq. to start from
      sta  shadow_FL,x
      lda  copy_FH,x
      sta  shadow_FH,x    

      cmp  tone_FH,x              ; test the high freq. of toneport. for dir.
      beq  testLow
      bcc  chk_next8
      inc  toneDir,x              ; invert direction
      bne  chk_next8

testLow:
      lda  copy_FL,x              ; test the low freq. of toneport. for dir.
      cmp  tone_FL,x
      bcc  chk_next8
      inc  toneDir,x              ; inver direction
 .endif

;========
; Set Vibrato
;========

chk_next8:
 .if USE_CMD_VIB=1
      cpy  #CMD_VIB               ; test for vibrato
      bne  chk_next9

      pha
      and  #$0F
      sta  vibSpeed,x             ; store vibrato speed
      pla
      and  #$F0
      clc
      adc  #$10
      sta  vibFreq,x              ; store vibrato frequency
      inc  vibSpeed,x             ; increment speed (0 is end mark)

      lda  vibSpeed,x
      sta  vibSpeed2,x            ; load second speed
      lda  #00
      sta  vibSpeed1,x            ; reset first speed

      lda  #$10
      ora  activeCommand,x        ; activate vibrato
      sta  activeCommand,x
      rts
 .endif

;========
; Set Slide Up
;========

chk_next9:
 .if USE_CMD_SUP=1
      cpy  #CMD_SUP               ; test for slide up
      bne  chk_next10

      sta  slideUp,x              ; store slide up value

      lda  #$20
      ora  activeCommand,x        ; activate slide up
      sta  activeCommand,x
      rts
 .endif

;========
; Set Slide Down
;========

chk_next10:
 .if USE_CMD_SDN=1
      cpy  #CMD_SDN               ; test for slide down
      bne  chk_next11

      sta  slideDn,x              ; store slide down value

      lda  #$40
      ora  activeCommand,x        ; activate slide down
      sta  activeCommand,x
 .endif
      rts

;========
; Set Auto Fade out
;========

chk_next11:
 .if USE_CMD_FOUT=1
      cpy  #CMD_AFO               ; test for auto fade out
      bne  chk_next12

      sta  autoFadeOut,x          ; store auto fade out value
      sta  actualFadeOut,x        ; store auto fade out value
      rts
 .endif

;========
; Set Filter type
;========

chk_next12:
 .if USE_CMD_FTY=1
      cpy  #CMD_FTY               ; test for filter type
      bne  chk_next13

      sta  cmdFilter,x            ; store filter params
      lda  #$20
      sta  actCommand2,x
      rts
 .endif

;========
; Set Filter resonance
;========

chk_next13:
 .if USE_CMD_FRS=1
      cpy  #CMD_FRE               ; test for filter res.
      bne  chk_next14

      sta  cmdFilter,x            ; store filter resonance
      lda  #$40
      sta  actCommand2,x
      rts
 .endif

;========
; Set Filter cut off
;========

chk_next14:
 .if USE_CMD_FCU=1
      cpy  #CMD_FCU               ; test for filter cut off
      bne  chk_next15

      sta  cmdFilter,x            ; store filter resonance
      lda  #$80
      sta  actCommand2,x
      rts
 .endif

;=======
; Set Gate SR
;=======

chk_next15:
 .if USE_CMD_GSR=1
      cpy  #CMD_GSR               ; test for gate sustain/release
      bne  exitExecute

      sta  cmdADSR,x              ; store in command SR reg.

      lda  #1                     ; set for a Gate SR in next command play routine
      sta  actCommand3,x
 .endif

exitExecute:
      rts

;=================================
; Play the command of pattern
;=================================
pl_play_command:

;========
; Arpeggio
;========
 .if USE_CMD_ARP=1
      lda  activeCommand,x
      and  #$01                   ; arpeggio command ?
      beq  skip_com1
      
      lda  posArpeggio,x          ; put the right note according to position
      cmp  #1
      bne  skipPos1

      ldy  note1Arpeggio,x        ; use middle note
      jmp  putFr

skipPos1:
      bcs  skipPos0
 
      ldy  actNote,x             ; use main note
      jmp  putFr

skipPos0:
      ldy  note2Arpeggio,x       ; use last note

putFr:                           ; put frequency
      lda  frequencyLo,y
      sta  shadow_FL,x

      lda  frequencyHi,y
      sta  shadow_FH,x

      dec  speedArpeggio,x
      bpl  skipInc

      lda  speedRelArp,x          ; reload speed
      sta  speedArpeggio,x  

      inc  posArpeggio,x          ; go to next position
      lda  posArpeggio,x
      cmp  #3                     ; over the limit ?
      bne  skipInc

      lda  #0                     ; yes, restore to the start
      sta  posArpeggio,x

skipInc:
 .endif

;========
; Do portamento up
;========

skip_com1:
 .if USE_CMD_PUP=1
      lda  activeCommand,x
      and  #$02                   ; portamento up command ?
      beq  skip_com2

      ldy  #PORT_MULT             ; value is *PORT_MULT
loopSubPortUp:

      lda  shadow_FL,x            ; read pulse low
      clc  
      adc  freqPortUp,x           ; add port. up value
      sta  shadow_FL,x
      bcc  skip_com2
      inc  shadow_FH,x            ; fix to high

      dey
      bne  loopSubPortUp
 .endif

;========
; Do portamento dn
;========

skip_com2:
 .if USE_CMD_PDN=1
      lda  activeCommand,x
      and  #$04                   ; portamento dn command ?
      beq  skip_com3

      ldy  #PORT_MULT             ; value is *PORT_MULT
loopSubPortDn:

      lda  shadow_FL,x            ; read pulse low
      sec 
      sbc  freqPortDn,x           ; sub prot. dn value
      sta  shadow_FL,x
      bcs  skip_com3
      dec  shadow_FH,x            ; fix to high

      dey
      bne  loopSubPortDn
 .endif

;========
; tone-portamento
;========

skip_com3:
 .if USE_CMD_TPO=1
      lda  activeCommand,x
      and  #$08                   ; tone-portamento command ?
      beq  skip_com4

      lda  toneDir,x              ; read portamento direction
      bne  negPort

      ldy  #PORT_MULT             ; value is *PORT_MULT
loopAddPort:
      lda  shadow_FL,x            ; read actual low freq.
      clc
      adc  freqTonePort,x         ; add the tone port freq. value
      sta  shadow_FL,x
      bcc  skipTPU
      inc  shadow_FH,x            ; fix high of frequency
skipTPU:
      dey
      bne  loopAddPort

      lda  shadow_FH,x            ; test if high freq is reached
      cmp  tone_FH,x
      beq  testLUP                ; is to test low ?
      bcc  skip_com4
      bcs  stopTone

testLUP:
      lda  shadow_FL,x            ; test if low freq is reached
      cmp  tone_FL,x
      bcc  skip_com4

stopTone:
      lda  tone_FH,x              ; copy final value to freq.
      sta  shadow_FH,x
      lda  tone_FL,x
      sta  shadow_FL,x

      lda  activeCommand,x        ; stop tone portamento command
      and  #$F7
      sta  activeCommand,x
      jmp  skip_com4

negPort:
      ldy  #PORT_MULT             ; value is *PORT_MULT
loopSubPort:
      lda  shadow_FL,x            ; read actual low freq.
      sec
      sbc  freqTonePort,x         ; sub the tone port freq. value
      sta  shadow_FL,x
      bcs  skipTPD
      dec  shadow_FH,x            ; fix high of frequency
skipTPD:
      dey
      bne  loopSubPort

      lda  shadow_FH,x            ; test if high freq is reached
      cmp  tone_FH,x
      beq  testLDN                ; is to test low ?
      bcs  skip_com4
      bcc  stopTone

testLDN:
      lda  shadow_FL,x            ; test if low freq is reached
      cmp  tone_FL,x
      bcs  skip_com4
      bcc  stopTone
 .endif

;========
; Do vibrato
;========

skip_com4:
 .if USE_CMD_VIB=1
      lda  activeCommand,x
      and  #$10                   ; vibrato command ?
      beq  skip_com5

      lda  vibSpeed1,x            ; test first speed value
      beq  testSp2

      dec  vibSpeed1,x            ; decrement speed counter 
      jmp  goDir

testSp2:
      lda  vibSpeed2,x            ; test second speed value
      beq  invDir

      dec  vibSpeed2,x            ; decrement speed counter 
      jmp  goDir

invDir:
      lda  vibSpeed,x             ; reload speed
      sta  vibSpeed1,x
      sta  vibSpeed2,x
      lda  vibDir,x               ; invert direction
      eor  #$01
      sta  vibDir,x

goDir:
      lda  vibDir,x               ; load vibrato direction
      bne  invertDir

      lda  shadow_FL,x            ; read actual low freq.
      clc
      adc  vibFreq,x              ; add vibrato value
      sta  shadow_FL,x
      bcc  skipVU
      inc  shadow_FH,x            ; fix for high freq.
skipVU:

      jmp  skip_com5

invertDir:
      lda  shadow_FL,x            ; read actual low freq.
      sec
      sbc  vibFreq,x              ; sub vibrato value
      sta  shadow_FL,x
      bcs  skipVD
      dec  shadow_FH,x            ; fix for high freq.
skipVD:
 .endif

;========
; Do slide up
;========

skip_com5:
 .if USE_CMD_SUP=1
      lda  activeCommand,x
      and  #$20                   ; slide up command ?
      beq  skip_com6

      lda  shadow_PL,x            ; read pulse low
      clc  
      adc  slideUp,x              ; add slide up value
      sta  shadow_PL,x
      bcc  skip_com6
      inc  shadow_PH,x            ; fix to high
 .endif

;========
; Do slide down
;========

skip_com6:
 .if USE_CMD_SDN=1
      lda  activeCommand,x
      and  #$40                   ; slide dn command ?
      beq  skip_com7

      lda  shadow_PL,x            ; read pulse low
      sec 
      sbc  slideDn,x              ; sub slide dn value
      sta  shadow_PL,x
      bcs  skip_com7
      dec  shadow_PH,x            ; fix to high
 .endif

;========
; Do fade out
;========

skip_com7:
 .if USE_CMD_FOUT=1

; do special command
      lda  autoFadeOut,x          ; read auto fade out
      beq  oneShotCmd

      lda  shadow_VOL             ; check actual volume
      beq  exitAFO

      dec  actualFadeOut,x        ; dec actual fade out counter
      bne  oneShotCmd

      dec  shadow_VOL             ; decrement volume
      lda  autoFadeOut,x          ; read auto fade out
      sta  actualFadeOut,x        ; set actual fade out
      bne  oneShotCmd

exitAFO:
      sta  autoFadeOut,x          ; clear auto fade out
 .endif

; do one shot command
oneShotCmd:

;=======================
; AD command
;=======================

 .if USE_CMD_AD=1
      lda  actCommand2,x
      ;beq  skip_3com1             ; exit if not more commands
      and  #1                     ; AD ?
      beq  skip_2com1

      lda  cmdADSR,x
      sta  shadow_AD,x            ; store AD

      lda  actCommand2,x
      and  #$F7
      sta  actCommand2,x          ; clear command flag
 .endif

;=======================
; SR command
;=======================

skip_2com1:
 .if USE_CMD_SR=1
      lda  actCommand2,x
      and  #2
      beq  skip_2com2

      lda  cmdADSR,x
      sta  shadow_SR,x            ; store SR
      lda  #$00
      sta  actCommand2,x          ; clear command flag
 .endif

;=======================
; Key on command
;=======================

skip_2com2:
      lda  actCommand2,x
      and  #4
      beq  skip_2com3

      lda  shadow_CTRL,x          ; put key on
      ora  #$01
      sta  shadow_CTRL,x

;=======================
; Key off command
;=======================

skip_2com3:
      lda  actCommand2,x
      and  #8
      beq  skip_2com4

      lda  shadow_CTRL,x          ; put key off
      and  #$FE
      sta  shadow_CTRL,x

;=======================
; Rest command
;=======================

skip_2com4:
      lda  actCommand2,x
      and  #$10
      beq  skip_2com5

      lda  #0                     ; put frequency to zero
      sta  shadow_FL,x 
      sta  shadow_FH,x
      sta  alreadyInstr,x         ; clear already instr started

;========================
; Filter type command
;========================

skip_2com5:
 .if USE_CMD_FTY=1
      lda  actCommand2,x
      and  #$20
      beq  skip_2com6

      lda  cmdFilter,x             ; put filter type
      sta  shadow_TYPE
      
      lda  #$00
      sta  actCommand2,x          ; clear command flag
 .endif

;========================
; Filter resonance
;========================

skip_2com6:
 .if USE_CMD_FRS=1
      lda  actCommand2,x
      and  #$40
      beq  skip_2com7

      lda  cmdFilter,x             ; put filter res.
      sta  shadow_RES
      
      lda  #$00
      sta  actCommand2,x          ; clear command flag
 .endif

;========================
; Filter cut off
;========================

skip_2com7:
 .if USE_CMD_FCU=1
      lda  actCommand2,x
      and  #$80
      beq  skip_3com1

      lda  cmdFilter,x             ; put filter cut
      sta  shadow_FCH
      
      lda  #$00
      sta  actCommand2,x          ; clear command flag
 .endif

;=======================
; GSR command
;=======================

skip_3com1:
 .if USE_CMD_GSR=1
      lda  actCommand3,x
      and  #1
      beq  skip_3com2

      lda  cmdADSR,x
      sta  shadow_SR,x            ; store SR

skip_3com2:
 .endif
      rts


;=================================
; Read next pattern in track
;=================================
pl_read_track:
      lda  trackIndex,x           ; read actual track index
pl_read_track_:
      tay
pl_read_track__:
      TBLR tuneTrack              ; read the value of track

                                  ; decode and manage the value
      cmp  #$DF
      bcs  isNotPattern

;=======
; Pattern
;=======
      jsr  pl_init_pattern        ; this is a pattern, set it up
      jmp  incTrack               ; go to increment track

isNotPattern:
      bne  isNotRepCmd

;========
; Repeat cmd
;========
      inc  trackIndex,x           ; inc actual track index
      iny
      lda  (ADDR_LOW),y           ; read the value of track

      pha
      lsr
      lsr
      lsr
    .if USE_UOP=0
      lsr                         ;                            [2]
      and  #$0f                   ; get steps and increment it [2] = 4
    .else
      .byte $4B, $1E              ; ALR #$1E                   [2] = 2
    .endif

      clc
      adc  #$01

      sta  trackRelStep,x         ; store steps
      sta  trackSteps,x

      pla
      and  #$0f                   ; get number of repeat and increment it      

      ;;sta  trackRepeat,x        ; [5] 
      ;;inc  trackRepeat,x        ; [7] = 12

      ;clc                        ; [2] carry must be already at 0 from previous clc and adc with max 16
      adc  #$01                   ; [2]  
      sta  trackRepeat,x          ; [5] = 9-2=7

      inc  trackIndex,x           ; inc actual track index
      lda  trackIndex,x
      sta  trackRestPos,x         ; store track restart position
      jmp  pl_read_track_         ; read and execute next command

isNotRepCmd:
      cmp  #$FF                   ; restart command ?
      bne  isNotRestCmd

;========
; Restart command
;========
      iny                         ; inc actual track index value 
      lda  (ADDR_LOW),y           ; read the value of track 
      cmp  #$FF                   ; no restart ?
      beq  notRestart    

      sta  trackIndex,x           ; store new index pointer
      jmp  pl_read_track_         ; read and execute next command

notRestart:
      lda  #1
      sta  stopTrack,x            ; track is finished
      lda  #0
      sta  shadow_FH,x
      sta  shadow_FL,x            ; output frequency to zero
      sta  alreadyInstr,x         ; instrument not started
      rts

isNotRestCmd:
      sec
      sbc  #$EF                   ; subtract the value of transpose 0
      sta  trackTransp,x
      inc  trackIndex,x           ; inc actual track index
      iny
      jmp  pl_read_track__        ; go to execute next cmd

incTrack:
                                  ; increase track index according to repeat cmd
      inc  trackIndex,x           ; inc actual track index
      lda  trackRepeat,x          ; is there a repeat of track cmd?
      beq  exitPRT

      dec  trackSteps,x           ; decrement executed steps
      bne  exitPRT

      dec  trackRepeat,x
      beq  exitPRT


      lda  trackRelStep,x         ; reload steps to repeat
      sta  trackSteps,x
      lda  trackRestPos,x         ; start from the repeat position
      sta  trackIndex,x           

exitPRT:
      rts

;=================================
; Set up to use the passed 
; instrument in A
;=================================
pl_new_instr:
      sta  actInstr,x
      tay                         ; instrument index
                                  ; copy all the pointers to fix positions for later short access to them
      lda  instrPtrLow-1,y        ; instrument start from 1
      sta  ADDR_LOW
      lda  instrPtrHigh-1,y       ; instrument start from 1
      sta  ADDR_HIGH

      ldy  #0
      lda  (ADDR_LOW),y
      sta  instr_HR,x             ; instrument HR
      iny
      lda  (ADDR_LOW),y
      sta  instr_AD,x             ; instrument AD
      iny
      lda  (ADDR_LOW),y
      sta  instr_SR,x             ; instrument SR
      iny
      lda  (ADDR_LOW),y
      sta  instr_CTRL1,x          ; instrument CTRL 1
      iny
      lda  (ADDR_LOW),y
      sta  instr_CTRL2,x          ; instrument CTRL 2

      iny                         ; copy pointer to AD table
 .if USE_INSTR_AD=1
      lda  (ADDR_LOW),y
      sta  instrPtrAD_L,x
 .endif
      iny
 .if USE_INSTR_AD=1
      lda  (ADDR_LOW),y
      sta  instrPtrAD_H,x
 .endif

      iny                         ; copy pointer to SR table
 .if USE_INSTR_SR=1
      lda  (ADDR_LOW),y
      sta  instrPtrSR_L,x
 .endif
      iny
 .if USE_INSTR_SR=1
      lda  (ADDR_LOW),y
      sta  instrPtrSR_H,x
 .endif

      iny                         ; copy pointer to Wave table
 .if USE_INSTR_WAVE=1
      lda  (ADDR_LOW),y
      sta  instrPtrWave_L,x
 .endif
      iny
 .if USE_INSTR_WAVE=1
      lda  (ADDR_LOW),y
      sta  instrPtrWave_H,x
 .endif

      iny                         ; copy pointer to Freq table
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrFreq_L,x
 .endif
      iny
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrFreq_H,x
 .endif

      iny                         ; copy pointer to Pulse table
 .if USE_INSTR_PULSE=1
      lda  (ADDR_LOW),y
      sta  instrPtrPulse_L,x
 .endif
      iny
 .if USE_INSTR_PULSE=1
      lda  (ADDR_LOW),y
      sta  instrPtrPulse_H,x
 .endif

      iny                         ; copy pointer to Filter table
 .if USE_INSTR_FILTER=1
      lda  (ADDR_LOW),y
      sta  instrPtrFilter_L,x
 .endif
      iny
 .if USE_INSTR_FILTER=1
      lda  (ADDR_LOW),y
      sta  instrPtrFilter_H,x
 .endif

      iny                         ; copy pointer to Res table
 .if USE_INSTR_RES=1
      lda  (ADDR_LOW),y
      sta  instrPtrRes_L,x
 .endif
      iny
 .if USE_INSTR_RES=1
      lda  (ADDR_LOW),y
      sta  instrPtrRes_H,x
 .endif

      iny                         ; copy pointer to Type table
 .if USE_INSTR_TYPE=1
      lda  (ADDR_LOW),y
      sta  instrPtrType_L,x
 .endif
      iny
 .if USE_INSTR_TYPE=1
      lda  (ADDR_LOW),y
      sta  instrPtrType_H,x
 .endif

      iny                         ; copy pointer to Rel Note table
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelNote_L,x
 .endif
      iny
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelNote_H,x
 .endif

      iny                         ; copy pointer to Fix Freq table
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrFixFreq_L,x
 .endif
      iny
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrFixFreq_H,x
 .endif

      iny                         ; copy pointer to Rel Freq table
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelFreq_L,x
 .endif
      iny
 .if USE_INSTR_FREQ=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelFreq_H,x
 .endif

      iny                         ; copy pointer to Fix Pulse table
 .if USE_INSTR_PULSE=1
      lda  (ADDR_LOW),y
      sta  instrPtrFixPulse_L,x
 .endif
      iny
 .if USE_INSTR_PULSE=1
      lda  (ADDR_LOW),y
      sta  instrPtrFixPulse_H,x
 .endif

      iny                         ; copy pointer to Rel Pulse table
 .if USE_INSTR_PULSE=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelPulse_L,x
 .endif
      iny
 .if USE_INSTR_PULSE=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelPulse_H,x
 .endif

      iny                         ; copy pointer to Rel Filter table
 .if USE_INSTR_FILTER=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelFilter_L,x
  .endif
      iny
 .if USE_INSTR_FILTER=1
      lda  (ADDR_LOW),y
      sta  instrPtrRelFilter_H,x
  .endif

      iny                         ; copy pointer to Fix Filter table
 .if USE_INSTR_FILTER=1
      lda  (ADDR_LOW),y
      sta  instrPtrFixFilter_L,x
  .endif
      iny
 .if USE_INSTR_FILTER=1
      lda  (ADDR_LOW),y
      sta  instrPtrFixFilter_H,x
  .endif

      iny                         ; copy pointer to Delay table
      lda  (ADDR_LOW),y
      sta  instrPtrDelay_L,x
      iny
      lda  (ADDR_LOW),y
      sta  instrPtrDelay_H,x

      iny                         ; copy pointer to Repeat table
      lda  (ADDR_LOW),y
      sta  instrPtrRepeat_L,x
      iny
      lda  (ADDR_LOW),y
      sta  instrPtrRepeat_H,x

      lda  #0                     ; init index to beginning of table
  .if USE_INSTR_AD=1
      sta  actIndex_AD,x
  .endif
  .if USE_INSTR_SR=1
      sta  actIndex_SR,x
  .endif
  .if USE_INSTR_WAVE=1
      sta  actIndex_Wave,x
  .endif
  .if USE_INSTR_FREQ=1
      sta  actIndex_Freq,x
  .endif
  .if USE_INSTR_PULSE=1
      sta  actIndex_Pulse,x
  .endif
  .if USE_INSTR_FILTER=1
      sta  actIndex_Filter,x
  .endif
  .if USE_INSTR_RES=1
      sta  actIndex_Res,x
  .endif
  .if USE_INSTR_TYPE=1
      sta  actIndex_Type,x
  .endif
      lda  #1
      sta  alreadyInstr,x         ; instrument is already started
      rts

;==================================
; Player instruction core: called
; at each ticks. It executes all
; the tables core
;==================================
pl_intr_core:
      lda  alreadyInstr,x         ; test if an instrument is already started
      beq  skipInstr

  .if USE_MZP=1
      lda  instrPtrDelay_L,x
      sta  ADDR_LOWD
      lda  instrPtrDelay_H,x
      sta  ADDR_HIGHD
      lda  instrPtrRepeat_L,x
      sta  ADDR_LOWR
      lda  instrPtrRepeat_H,x
      sta  ADDR_HIGHR
  .endif

  .if USE_INSTR_AD=1
      jsr  pl_instr_core_AD
  .endif
  .if USE_INSTR_SR=1
      jsr  pl_instr_core_SR
  .endif
  .if USE_INSTR_WAVE=1
      jsr  pl_instr_core_Wave
  .endif
  .if USE_INSTR_FREQ=1
      jsr  pl_instr_core_Freq
  .endif
  .if USE_INSTR_PULSE=1
      jsr  pl_instr_core_Pulse
  .endif
  .if USE_INSTR_FILTER=1
      jsr  pl_instr_core_Filter
  .endif
  .if USE_INSTR_RES=1
      jsr  pl_instr_core_Res
  .endif
  .if USE_INSTR_TYPE=1
      jsr  pl_instr_core_Type
  .endif
skipInstr:
      rts

;===================================
; Manage instrument frequency table
; A=table value
;===================================
putFreq:
      cmp  #$60                    ; test for absolute note (<$60)
      bcs  testRelLocFreq
                                   ; absolute note
useFreqTable:
      tay
useFreqTable_:
      lda  frequencyLo,y
      sta  shadow_FL,x
      lda  frequencyHi,y
      sta  shadow_FH,x
exitPF:
      rts

testRelLocFreq:
      cmp  #$A0                    ; test for relative local frequency (<$A0)
      bcs  testRelFreq

      sec
      sbc  #$60
      lsr
      bcs  subRelLocFreq

      asl
      tay
      TBLR2 instrPtrRelNote        ; read value
 
      clc
      adc  actNote,x               ; add the current note being played
      jmp  testPort

subRelLocFreq:
      asl
      tay
      TBLR2 instrPtrRelNote        ; read value

      sta  TEMP2
      lda  actNote,x
      sec
      sbc  TEMP2                   ; sub the current note being played

testPort:
      tay
      lda  activeCommand,x
      and  #$08                    ; tone-portamento command ?
      bne  exitPF
      jmp  useFreqTable_           ; put the new frequency using the table

testRelFreq:
      cmp  #$E0                    ; test for relative frequency (<$E0)
      bcs  isFixFreq

      sec
      sbc  #$A0
      lsr
      bcs  subRelFreq

      asl
      tay
      TBLR2 instrPtrRelFreq        ; read value
      clc
      adc  shadow_FL,x
      sta  shadow_FL,x
      iny 
      lda  (ADDR_LOW2),y           ; read values
      adc  shadow_FH,x
      sta  shadow_FH,x
      rts

subRelFreq:
      asl
      tay
      TBLR2 instrPtrRelFreq        ; read value
      sta  TEMP2
      lda  shadow_FL,x
      sec
      sbc  TEMP2
      sta  shadow_FL,x
      iny 
      lda  (ADDR_LOW2),y           ; read values
      sta  TEMP2
      lda  shadow_FH,x
      sbc  TEMP2
      sta  shadow_FH,x
      rts

isFixFreq:
      sec
      sbc  #$E0

      asl
      tay
      TBLR2 instrPtrFixFreq        ; read value
      sta  shadow_FL,x
      iny
      lda  (ADDR_LOW2),y           ; read values
      sta  shadow_FH,x
      rts

;===================================
; Manage instrument pulse table
; A=table value
;===================================
putPulse:
      cmp  #$60                    ; test for absolute pulse (<$60)
      bcs  isRelPulse
                                   ; absolute pulse
      asl
      tay
      TBLR2 instrPtrFixPulse       ; read value
      sta  shadow_PL,x
      iny
      lda  (ADDR_LOW2),y           ; read values
      sta  shadow_PH,x
      rts

isRelPulse:                        ; relative pulse
      sec
      sbc  #$60
      lsr
      bcs  subRelPulse

      asl
      tay
      TBLR2 instrPtrRelPulse       ; read value
      clc
      adc  shadow_PL,x
      sta  shadow_PL,x
      iny 
      lda  (ADDR_LOW2),y           ; read values
      adc  shadow_PH,x
      sta  shadow_PH,x
      rts

subRelPulse:
      asl
      tay
      TBLR2 instrPtrRelPulse       ; read value
      sta  TEMP2
      lda  shadow_PL,x
      sec
      sbc  TEMP2
      sta  shadow_PL,x
      iny 
      lda  (ADDR_LOW2),y           ; read values
      sta  TEMP2
      lda  shadow_PH,x
      sbc  TEMP2
      sta  shadow_PH,x
      rts

;===================================
; Manage instrument filter freq
; A=table value
;===================================
putFilterFreq:
      cmp  #$60                    ; test for absolute filter freq (<$60)
      bcs  isRelFilter
                                   ; absolute pulse
      asl
      tay
      TBLR2 instrPtrFixFilter      ; read value
      sta  shadow_FCL
      iny
      lda  (ADDR_LOW2),y           ; read values
      sta  shadow_FCH
      rts

isRelFilter:                       ; relative pulse
      sec
      sbc  #$60
      lsr
      bcs  subRelFilter

      asl
      tay
      TBLR2 instrPtrRelFilter      ; read value
      clc
      adc  shadow_FCL
      sta  shadow_FCL
      iny 
      lda  (ADDR_LOW2),y           ; read values
      adc  shadow_FCH
      sta  shadow_FCH
      rts

subRelFilter:
      asl
      tay
      TBLR2 instrPtrRelFilter      ; read value
      sta  TEMP2
      lda  shadow_FCL
      sec
      sbc  TEMP2
      sta  shadow_FCL
      iny 
      lda  (ADDR_LOW2),y           ; read values
      sta  TEMP2
      lda  shadow_FCH
      sbc  TEMP2
      sta  shadow_FCH
      rts

;===================================
; Manage instrument filter res.
; A=table value
;===================================
putFilterRes: 
      sta  TEMP2                   ; store value 
      lsr
      bcc  notFixed

      lda  TEMP2                   ; retrieve value and use it
      and  #$F0
      sta  shadow_RES
      rts

notFixed:
      lsr
      bcc  isToSub

      lda  TEMP2                   ; retrieve value
      and  #$F0
      clc
      adc  shadow_RES              ; add to current value
      and  #$F0
      sta  shadow_RES
      rts

isToSub:
      lda  TEMP2                   ; retrieve value
      and  #$F0
      sta  TEMP2
      lda  shadow_RES
      sec
      sbc  TEMP2                   ; sub to current value
      and  #$F0
      sta  shadow_RES
      rts

;===================================
; Out the value to shadow reg. 
; according to the actual type of 
; action (A=read value from table)
;===================================
 .mac OUTV 
par SET {2}
 .if par=1                         ; AD 
      sta  shadow_AD,x             ; out value
 .endif
 .if par=2                         ; SR
      sta  shadow_SR,x             ; out value
 .endif
 .if par=3                         ; Wave
      beq  .skip_CTRL              ; skip if zero
      sta  shadow_CTRL,x
.skip_CTRL:
 .endif
 .if par=4                         ; Freq
      sty  TEMP                    ; preserve y index reg 
      jsr  putFreq
      ldy  TEMP
 .endif
 .if par=5                         ; Pulse
      sty  TEMP                    ; preserve y index reg 
      jsr  putPulse
      ldy  TEMP
 .endif
 .if par=6                         ; Filter Freq
      sty  TEMP                    ; preserve y index reg 
      jsr  putFilterFreq
      ldy  TEMP
 .endif
 .if par=7                         ; Filter Resonance
      sty  TEMP                    ; preserve y index reg 
      jsr  putFilterRes
      ldy  TEMP
 .endif
 .if par=8                         ; Filter Type
      sta  shadow_TYPE             ; out value
 .endif
 .endm

;===================================
; Macro for instruction core
;===================================
 .mac pl_instr_core_
      ldy  actIndex_{1},x         ; is first time with the instrument?
      bne  cont_IC_{1}

      TBLR instrPtr{1}            ; read values
      sta  dimension_{1},x        ; save the dimension of table

      iny
      lda  (ADDR_LOW),y           ; read value
      sta  allowRepeat_{1},x      ; save repeat information
      iny
      lda  (ADDR_LOW),y           ; read value
      sta  stepPos_{1},x          ; save step position

      iny
      tya
      sta  actIndex_{1},x         ; store actual index

      lda  dimension_{1},x        ; if table is empty, exit
      beq  exit_IC_{1}

      lda  (ADDR_LOW),y           ; read values
start_IC_{1}:
      OUTV {1}, {2}               ; out value

ecount_IC_{1}:
      iny
      lda  (ADDR_LOW),y           ; read delay repeat from table
      tay

  .if USE_MZP=1
      lda  (ADDR_LOWD),y          ; read delay from table   [5*]
      sta  actDelay_{1},x         ; store in actual delay   [5*]
      lda  (ADDR_LOWR),y          ; read repeat from table  [5*]
      sta  actRepeat_{1},x        ; store actual repeat     [5*]  =20*
  .else
      TBLR instrPtrDelay          ; read delay from table   [19*]
      sta  actDelay_{1},x         ; store in actual delay   [5]
      TBLR instrPtrRepeat         ; read repeat from table  [19*]
      sta  actRepeat_{1},x        ; store actual repeat     [5*]  =48*
  .endif

exit_IC_{1}:
      rts                         ; exit

cont_IC_{1}:
      lda  dimension_{1},x        ; if table is empty, exit
      beq  exit_IC_{1}

      lda  actDelay_{1},x         ; read actual delay
      beq  cont1_IC_{1}           ; if zero go away with repeat

      dec  actDelay_{1},x         ; decrement actual delay
      rts                         ; exit

cont1_IC_{1}:
      lda  actRepeat_{1},x        ; read actual repeat value
      beq  cont2_IC_{1}           ; if zero go away with next index in table

      TBLR instrPtr{1}            ; read values
      OUTV {1}, {2}               ; out value

      iny
      lda  (ADDR_LOW),y           ; read delay repeat from table
      tay

  .if USE_MZP=1
      lda  (ADDR_LOWD),y          ; read delay from table   [5*]
      sta  actDelay_{1},x         ; store in actual delay   [5*] = 10*
  .else
      TBLR instrPtrDelay          ; read delay from table   [19*]
      sta  actDelay_{1},x         ; store in actual delay   [5]  = 24*
  .endif

      dec  actRepeat_{1},x        ; decrement actual repeat
      rts                         ; exit

cont2_IC_{1}:
      lda  actIndex_{1},x         ; test if actual position is over dimension
      cmp  dimension_{1},x
      bcs  cont3_IC_{1}

      ;inc  actIndex_{1},x        ; increment actual index   [7]
      ;inc  actIndex_{1},x        ; increment actual index   [7]
      ;ldy  actIndex_{1},x        ;                          [4] =>18  

      ldy  actIndex_{1},x         ;                          [4*]   
      iny                         ;                          [2]                      
      iny                         ; increment actual index   [2]      
      tya                         ;                          [2]    
      sta  actIndex_{1},x         ;                          [5] =>15*        
                                  ;                          ~-6 Raster line
      TBLR instrPtr{1}            ; read values
      OUTV {1}, {2}               ; out value
      jmp  ecount_IC_{1}

cont3_IC_{1}:
      lda  stepPos_{1},x          ; test if there is no repeat
      beq  exit2_IC_{1}

      ldy  allowRepeat_{1},x      ; test if infinite repeat
      bne  cont4_IC_{1}

econt2_IC_{1}:
      sta  actIndex_{1},x         ; store stepPos in actual position
      tay
      TBLR instrPtr{1}            ; read values
      jmp  start_IC_{1}           ; and restart the core

cont4_IC_{1}:
      lda  actNumRepeat_{1},x     ; test if actual repeat is equal to max nun of repeat
      cmp  allowRepeat_{1},x
      beq  exit2_IC_{1}

      inc  actNumRepeat_{1},x     ; increment actual number of repeat
      lda  stepPos_{1},x          ; and use a new step position
      bne  econt2_IC_{1}

exit2_IC_{1}:
      rts
 .endm

;==================================
; Attack/Decay instruction core
;==================================
pl_instr_core_AD:
  .if USE_INSTR_AD=1
      pl_instr_core_ AD, 1
  .endif

;==================================
; Sustain/Release instruction core
;==================================
pl_instr_core_SR:
  .if USE_INSTR_SR=1
      pl_instr_core_ SR, 2
  .endif

;==================================
; Wave instruction core
;==================================
pl_instr_core_Wave:
  .if USE_INSTR_WAVE=1
      pl_instr_core_ Wave, 3
  .endif

;==================================
; Freq instruction core
;==================================
pl_instr_core_Freq:
  .if USE_INSTR_FREQ=1
      pl_instr_core_ Freq, 4
  .endif

;==================================
; Pulse instruction core
;==================================
pl_instr_core_Pulse:
  .if USE_INSTR_PULSE=1
      pl_instr_core_ Pulse, 5
  .endif

;==================================
; Filter instruction core
;==================================
pl_instr_core_Filter:
  .if USE_INSTR_FILTER=1
      pl_instr_core_ Filter, 6
  .endif

;==================================
; Resonance instruction core
;==================================
pl_instr_core_Res:
  .if USE_INSTR_RES=1
      pl_instr_core_ Res, 7
  .endif

;==================================
; Type instruction core
;==================================
pl_instr_core_Type:
  .if USE_INSTR_TYPE=1
      pl_instr_core_ Type, 8
  .endif

;==================================
; Initialize the pattern to use
; A=number of pattern to use
;==================================
pl_init_pattern:
       tay
                                   ; set the pointer for note pattern byte
       lda  pat_b1_low,y
       sta  pattPoint1_L,x
       lda  pat_b1_high,y
       sta  pattPoint1_H,x
                                   ; set the pointer for instrument pattern byte
       lda  pat_b2_low,y
       sta  pattPoint2_L,x
       lda  pat_b2_high,y
       sta  pattPoint2_H,x
                                   ; set the pointer for command pattern byte
       lda  pat_b3_low,y
       sta  pattPoint3_L,x
       lda  pat_b3_high,y
       sta  pattPoint3_H,x
                                   ; set the pointer for param. pattern byte
       lda  pat_b4_low,y
       sta  pattPoint4_L,x
       lda  pat_b4_high,y
       sta  pattPoint4_H,x

       lda  #0
       sta  pattDelay,x            ; set the delay for tempo ticks
       sta  pattIndex,x            ; index of pattern start from 1 (0 is for the tempo)
       tay                         ; but we increment it before use

       TBLR pattPoint1             ; read pattern value

       sta  pattTempo,x            ; set the pattern tempo for the pattern
       rts

shadow_FCL:     .byte $00  ; shadow reg for Filter Freq Low
shadow_FCH:     .byte $00  ; shadow reg for Filter Freq High
shadow_RES:     .byte $00  ; shadow reg for Filter Resonance
shadow_TYPE:    .byte $00  ; shadow reg for Filter Type
shadow_VOL:     .byte $00  ; shadow reg for Volume

shadow_FL:      .byte $00  ; shadow reg for Freq Low
shadow_FH:      .byte $00  ; shadow reg for Freq High 
shadow_PL:      .byte $00  ; shadow reg for Pulse Low
shadow_PH:      .byte $00  ; shadow reg for Pulse High
shadow_CTRL:    .byte $00  ; shadow reg for Control
shadow_AD:      .byte $00  ; shadow reg for Attack/Decay
shadow_SR:      .byte $00  ; shadow reg for Sustain/Release

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

                                              ; voice 1
actInstr:       .byte $00  ; actual instrument being used
actNote:        .byte $00  ; actual note being played
instrPtrAD_L:   .byte $00  ; (low)  pointer to instrument table AD
instrPtrAD_H:   .byte $00  ; (high) pointer to instrument table AD
instrPtrSR_L:   .byte $00  ; (low)  pointer to instrument table SR
instrPtrSR_H:   .byte $00  ; (high) pointer to instrument table SR
instrPtrWave_L: .byte $00  ; (low)  pointer to instrument table Wave

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

instrPtrWave_H:   .byte $00  ; (high) pointer to instrument table Wave
instrPtrFreq_L:   .byte $00  ; (low)  pointer to instrument table Freq
instrPtrFreq_H:   .byte $00  ; (high) pointer to instrument table Freq
instrPtrPulse_L:  .byte $00  ; (low)  pointer to instrument table Pulse
instrPtrPulse_H:  .byte $00  ; (high) pointer to instrument table Pulse
instrPtrFilter_L: .byte $00  ; (low)  pointer to instrument table Filter
instrPtrFilter_H: .byte $00  ; (high) pointer to instrument table Filter

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

instrPtrRes_L:     .byte $00  ; (low)  pointer to instrument table Res
instrPtrRes_H:     .byte $00  ; (high) pointer to instrument table Res
instrPtrType_L:    .byte $00  ; (low)  pointer to instrument table Type
instrPtrType_H:    .byte $00  ; (high) pointer to instrument table Type
instrPtrFixFreq_L: .byte $00  ; (low)  pointer to instrument table Fix Freq
instrPtrFixFreq_H: .byte $00  ; (high) pointer to instrument table Fix Freq
instrPtrRelFreq_L: .byte $00  ; (low)  pointer to instrument table Rel Freq

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

instrPtrRelFreq_H:   .byte $00  ; (high) pointer to instrument table Rel Freq
instrPtrFixPulse_L:  .byte $00  ; (low)  pointer to instrument table Fix Pulse
instrPtrFixPulse_H:  .byte $00  ; (high) pointer to instrument table Fix Pulse
instrPtrRelPulse_L:  .byte $00  ; (low)  pointer to instrument table Rel Pulse
instrPtrRelPulse_H:  .byte $00  ; (high) pointer to instrument table Rel Pulse
instrPtrRelFilter_L: .byte $00  ; (low)  pointer to instrument table Rel Filter
instrPtrRelFilter_H: .byte $00  ; (high) pointer to instrument table Rel Filter

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3


instrPtrFixFilter_L: .byte $00  ; (low)  pointer to instrument table Fix Filter
instrPtrFixFilter_H: .byte $00  ; (high) pointer to instrument table Fix Filter
instrPtrDelay_L:     .byte $00  ; (low)  pointer to instrument table Delay
instrPtrDelay_H:     .byte $00  ; (high) pointer to instrument table Delay
instrPtrRepeat_L:    .byte $00  ; (low)  pointer to instrument table Repeat
instrPtrRepeat_H:    .byte $00  ; (high) pointer to instrument table Repeat
trackIndex:          .byte $00  ; index of current track position

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

instrPtrRelNote_L:   .byte $00  ; (low)  pointer to instrument table Rel note
instrPtrRelNote_H:   .byte $00  ; (high) pointer to instrument table Rel note
                     .byte $00  ; free
                     .byte $00  ; free
                     .byte $00  ; free
                     .byte $00  ; free
                     .byte $00  ; free

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Attack/Decay voice 1
dimension_AD:     .byte $00 ; dimension of table
actIndex_AD:      .byte $00 ; actual index in table
allowRepeat_AD:   .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_AD:  .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_AD:       .byte $00 ; step position (index)
actDelay_AD:      .byte $00 ; actual delay in table
actRepeat_AD:     .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Sustain/Release voice 1
dimension_SR:     .byte $00 ; dimension of table
actIndex_SR:      .byte $00 ; actual index in table
allowRepeat_SR:   .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_SR:  .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_SR:       .byte $00 ; step position (index)
actDelay_SR:      .byte $00 ; actual delay in table
actRepeat_SR:     .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Wave voice 1
dimension_Wave:    .byte $00 ; dimension of table
actIndex_Wave:     .byte $00 ; actual index in table
allowRepeat_Wave:  .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_Wave: .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_Wave:      .byte $00 ; step position (index)
actDelay_Wave:     .byte $00 ; actual delay in table
actRepeat_Wave:    .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Freq voice 1
dimension_Freq:    .byte $00 ; dimension of table
actIndex_Freq:     .byte $00 ; actual index in table
allowRepeat_Freq:  .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_Freq: .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_Freq:      .byte $00 ; step position (index)
actDelay_Freq:     .byte $00 ; actual delay in table
actRepeat_Freq:    .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Pulse voice 1
dimension_Pulse:    .byte $00 ; dimension of table
actIndex_Pulse:     .byte $00 ; actual index in table
allowRepeat_Pulse:  .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_Pulse: .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_Pulse:      .byte $00 ; step position (index)
actDelay_Pulse:     .byte $00 ; actual delay in table
actRepeat_Pulse:    .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Filter voice 1
dimension_Filter:    .byte $00 ; dimension of table
actIndex_Filter:     .byte $00 ; actual index in table
allowRepeat_Filter:  .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_Filter: .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_Filter:      .byte $00 ; step position (index)
actDelay_Filter:     .byte $00 ; actual delay in table
actRepeat_Filter:    .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Type voice 1
dimension_Type:    .byte $00 ; dimension of table
actIndex_Type:     .byte $00 ; actual index in table
allowRepeat_Type:  .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_Type: .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_Type:      .byte $00 ; step position (index)
actDelay_Type:     .byte $00 ; actual delay in table
actRepeat_Type:    .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table specific variables for Res voice 1
dimension_Res:    .byte $00 ; dimension of table
actIndex_Res:     .byte $00 ; actual index in table
allowRepeat_Res:  .byte $00 ; 0=infinite repeat, !=0 repeat a max number of repeat
actNumRepeat_Res: .byte $00 ; actual number of repeat if allowRepeat is !=0
stepPos_Res:      .byte $00 ; step position (index)
actDelay_Res:     .byte $00 ; actual delay in table
actRepeat_Res:    .byte $00 ; actual repeat in table

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

; table variables of value for HR voice 1
instr_HR:    .byte $00 ; instrument HR
instr_AD:    .byte $00 ; instrument AD
instr_SR:    .byte $00 ; instrument SR
instr_CTRL1: .byte $00 ; instrument CTRL 1
instr_CTRL2: .byte $00 ; instrument CTRL 2
tuneTrack_L: .byte $00 ; low pointer of track
tuneTrack_H: .byte $00 ; high pointer for track

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

trackTransp:   .byte $00 ; transpose for the track
pattIndex:     .byte $00 ; actual index in the pattern
pattDelay:     .byte $00 ; actual patt delay (tempo)
pattPoint1_L:  .byte $00 ; pattern pointer note low 
pattPoint1_H:  .byte $00 ; pattern pointer note high
pattPoint2_L:  .byte $00 ; pattern pointer instr. low
pattPoint2_H:  .byte $00 ; pattern pointer instr. high

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

pattPoint3_L:  .byte $00 ; pattern pointer command low 
pattPoint3_H:  .byte $00 ; pattern pointer command high
pattPoint4_L:  .byte $00 ; pattern pointer param. low
pattPoint4_H:  .byte $00 ; pattern pointer param. high
pattTempo:     .byte $00 ; pattern tempo to use
actCommand:    .byte $00 ; actual command to play
actParam:      .byte $00 ; actual parameter of command

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

activeCommand: .byte $00 ; active commands to execute (flags)
note1Arpeggio: .byte $00 ; note 1 to play for arpeggio
note2Arpeggio: .byte $00 ; note 2 to play for arpeggio
freqPortUp:    .byte $00 ; frequency for portamento up
freqPortDn:    .byte $00 ; frequency for portamento dn
freqTonePort:  .byte $00 ; frequency for tone portamento
slideUp:       .byte $00 ; slide up

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

slideDn:       .byte $00 ; slide down
vibSpeed:      .byte $00 ; vibrato speed
vibFreq:       .byte $00 ; vibrato frequency
vibDir:        .byte $00 ; vibrato direction (0=up)
vibSpeed1:     .byte $00 ; vibrato speed 1
vibSpeed2:     .byte $00 ; vibrato speed 2
toneDir:       .byte $00 ; toneportamento direction (0=up)

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

copy_FL:       .byte $00 ; copy of FL for toneportamento
copy_FH:       .byte $00 ; copy of FH for toneportamento
tone_FL:       .byte $00 ; toneportamento low freq. to reach
tone_FH:       .byte $00 ; toneportamento high freq. to reach
trackRestPos:  .byte $00 ; track restart position
trackRepeat:   .byte $00 ; number of repeat for track command
trackSteps:    .byte $00 ; number of steps for track command

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

trackRelStep:  .byte $00 ; track reload steps for track comamnd
stopTrack:     .byte $00 ; 1=track is stopped (finished)
speedArpeggio: .byte $00 ; speed of arpeggio
speedRelArp:   .byte $00 ; speed reload for arpeggio
posArpeggio:   .byte $00 ; position for arpeggio (0, 1, 2)
hrActive:      .byte $00 ; HR actived into this frame (<>0)
cmdADSR:       .byte $00 ; AD/SR for the pattern command

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3

actCommand2:   .byte $00 ; active command 2 byte
autoFadeOut:   .byte $00 ; auto fade out value
actualFadeOut: .byte $00 ; actual fade out value
cmdFilter:     .byte $00 ; value for the filter commands
actCommand3:   .byte $00 ; active command 3 byte
alreadyInstr:  .byte $00 ; already instrument started
               .byte $00 ; free

  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 2
  .byte $00, $00, $00, $00, $00, $00, $00   ; voice 3


 .if A4_FREQ=0                    ; A4=424Hz (Matt Gray)
frequencyLo:
  .byte $0C, $1C, $2D, $3E        ; C-0 C#0 D-0 D#0
  .byte $51, $66, $7B, $91
  .byte $A9, $C3, $DD, $FA
  .byte $18, $38, $5A, $7D        ; C-1 C#1 D-1 D#1
  .byte $A3, $CC, $F6, $23
  .byte $53, $86, $BB, $F4
  .byte $30, $70, $B4, $FB        ; C-2 C#2 D-2 D#2
  .byte $47, $98, $ED, $47
  .byte $A7, $0C, $77, $E9
  .byte $61, $E1, $68, $F7        ; C-3 C#3 D-3 D#3
  .byte $8F, $30, $DA, $8F
  .byte $4E, $18, $EF, $D2
  .byte $C3, $C3, $D1, $EF        ; C-4 C#4 D-4 D#4
  .byte $1F, $60, $B5, $1E        ; E-4 F-4 F#4 G-4
  .byte $9C, $31, $DF, $A5        ; G#4 A-4 A#4 B-4
  .byte $87, $86, $A2, $DF        ; C-5 C#5 D-5 D#3
  .byte $3E, $C1, $6B, $3C
  .byte $39, $63, $BE, $4B
  .byte $0F, $0C, $45, $BF        ; C-6 C#6 D-6 D#6
  .byte $7D, $83, $D6, $79
  .byte $73, $C7, $7C, $97
  .byte $1E, $18, $8B, $7E        ; C-7 C#7 D-7 D#7
  .byte $FA, $06, $AC, $F3
  .byte $E6, $8F, $F8, $2E

frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $01
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02, $02, $02, $03
  .byte $03, $03, $03, $03
  .byte $04, $04, $04, $04        ; C-2 C#2 D-2 D#2
  .byte $05, $05, $05, $06
  .byte $06, $07, $07, $07
  .byte $08, $08, $09, $09        ; C-3 C#3 D-3 D#3
  .byte $0A, $0B, $0B, $0C
  .byte $0D, $0E, $0E, $0F
  .byte $10, $11, $12, $13        ; C-4 C#4 D-4 D#4
  .byte $15, $16, $17, $19        ; E-4 F-4 F#4 G-4
  .byte $1A, $1C, $1D, $1F        ; G#4 A-4 A#4 B-4
  .byte $21, $23, $25, $27        ; C-5 C#5 D-5 D#3
  .byte $2A, $2C, $2F, $32
  .byte $35, $38, $3B, $3F
  .byte $43, $47, $4B, $4F        ; C-6 C#6 D-6 D#6
  .byte $54, $59, $5E, $64
  .byte $6A, $70, $77, $7E
  .byte $86, $8E, $96, $9F        ; C-7 C#7 D-7 D#7
  .byte $A8, $B3, $BD, $C8
  .byte $D4, $E1, $EE, $FD
 .endif

 .if A4_FREQ=1                    ; A4=440Hz (Standard)
frequencyLo:
  .byte $16, $27, $39, $4B        ; C-0 C#0 D-0 D#0
  .byte $5F, $74, $8A, $A1
  .byte $BA, $D4, $F0, $0E
  .byte $2D, $4E, $71, $96        ; C-1 C#1 D-1 D#1
  .byte $BE, $E7, $14, $66
  .byte $74, $A9, $E0, $1B
  .byte $5A, $9C, $E2, $2D        ; C-2 C#2 D-2 D#2
  .byte $7B, $CF, $27, $85
  .byte $E8, $51, $C1, $37
  .byte $B4, $38, $C4, $59        ; C-3 C#3 D-3 D#3
  .byte $F7, $9E, $4E, $0A
  .byte $D0, $A2, $81, $6D
  .byte $67, $70, $89, $B2        ; C-4 C#4 D-4 D#4
  .byte $ED, $3B, $9D, $14        ; E-4 F-4 F#4 G-4
  .byte $A0, $45, $03, $DB        ; G#4 A-4 A#4 B-4
  .byte $CF, $E1, $12, $65        ; C-5 C#5 D-5 D#3
  .byte $DB, $76, $3A, $27
  .byte $41, $8A, $05, $B5
  .byte $9D, $C1, $24, $C9        ; C-6 C#6 D-6 D#6
  .byte $B6, $ED, $73, $4E
  .byte $82, $14, $0A, $6A
  .byte $3B, $82, $48, $93        ; C-7 C#7 D-7 D#7
  .byte $6B, $DA, $E7, $9C
  .byte $04, $28, $14, $FF

frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $02
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02, $02, $03, $03
  .byte $03, $03, $03, $04
  .byte $04, $04, $04, $05        ; C-2 C#2 D-2 D#2
  .byte $05, $05, $06, $06
  .byte $06, $07, $07, $08
  .byte $08, $09, $09, $0A        ; C-3 C#3 D-3 D#3
  .byte $0A, $0B, $0C, $0D
  .byte $0D, $0E, $0F, $10
  .byte $11, $12, $13, $14        ; C-4 C#4 D-4 D#4
  .byte $15, $17, $18, $1A        ; E-4 F-4 F#4 G-4
  .byte $1B, $1D, $1F, $20        ; G#4 A-4 A#4 B-4
  .byte $22, $24, $27, $29        ; C-5 C#5 D-5 D#3
  .byte $2B, $2E, $31, $34
  .byte $37, $3A, $3E, $41
  .byte $45, $49, $4E, $52        ; C-6 C#6 D-6 D#6
  .byte $57, $5C, $62, $68
  .byte $6E, $75, $7C, $83
  .byte $8B, $93, $9C, $A5        ; C-7 C#7 D-7 D#7
  .byte $AF, $B9, $C4, $D0
  .byte $DD, $EA, $F8, $FF
 .endif

 .if A4_FREQ=2                    ; A4=440Hz (Rob Hubbard)
frequencyLo:
  .byte $16, $27, $38, $4b        ; C-0 C#0 D-0 D#0
  .byte $5f, $73, $8a, $a1
  .byte $ba, $d4, $f0, $0e
  .byte $2d, $4e, $71, $96        ; C-1 C#1 D-1 D#1
  .byte $bd, $e7, $13, $42
  .byte $74, $a9, $e0, $1b
  .byte $5a, $9b, $e2, $2c        ; C-2 C#2 D-2 D#2
  .byte $7b, $ce, $27, $85
  .byte $e8, $51, $c1, $37
  .byte $b4, $37, $c4, $57        ; C-3 C#3 D-3 D#3
  .byte $f5, $9c, $4e, $09
  .byte $d0, $a3, $82, $6e
  .byte $68, $6e, $88, $af        ; C-4 C#4 D-4 D#4
  .byte $eb, $39, $9c, $13        ; E-4 F-4 F#4 G-4
  .byte $a1, $46, $04, $dc        ; G#4 A-4 A#4 B-4
  .byte $d0, $dc, $10, $5e        ; C-5 C#5 D-5 D#3
  .byte $d6, $72, $38, $26
  .byte $42, $8c, $08, $b8
  .byte $a0, $b8, $20, $bc        ; C-6 C#6 D-6 D#6
  .byte $ac, $e4, $70, $4c
  .byte $84, $18, $10, $70
  .byte $40, $70, $40, $78        ; C-7 C#7 D-7 D#7
  .byte $58, $c8, $e0, $98
  .byte $08, $30, $20, $2e

frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $02
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02 ,$02 ,$03, $03
  .byte $03, $03, $03, $04
  .byte $04, $04, $04, $05        ; C-2 C#2 D-2 D#2
  .byte $05, $05, $06, $06
  .byte $06, $07, $07, $08
  .byte $08, $09, $09, $0a        ; C-3 C#3 D-3 D#3
  .byte $0a, $0b, $0c, $0d
  .byte $0d, $0e, $0f, $10
  .byte $11, $12, $13, $14        ; C-4 C#4 D-4 D#4
  .byte $15, $17, $18, $1a        ; E-4 F-4 F#4 G-4
  .byte $1b, $1d, $1f, $20        ; G#4 A-4 A#4 B-4
  .byte $22, $24, $27, $29        ; C-5 C#5 D-5 D#3
  .byte $2b, $2e, $31, $34
  .byte $37, $3a, $3e, $41
  .byte $45, $49, $4e, $52        ; C-6 C#6 D-6 D#6
  .byte $57, $5c, $62, $68
  .byte $6e, $75, $7c, $83
  .byte $8b, $93, $9c, $a5        ; C-7 C#7 D-7 D#7
  .byte $af, $b9, $c4, $d0
  .byte $dd, $ea, $f8, $fd
 .endif

 .if A4_FREQ=3                    ; A4=442Hz
frequencyLo:
  .byte $17, $28, $3A, $4C        ; C-0 C#0 D-0 D#0
  .byte $60, $75, $8B, $A3
  .byte $BC, $D6, $F2, $10
  .byte $2F, $50, $73, $99        ; C-1 C#1 D-1 D#1
  .byte $C0, $EA, $16, $45
  .byte $77, $AC, $E4, $1F
  .byte $5E, $A0, $E7, $32        ; C-2 C#2 D-2 D#2
  .byte $80, $D4, $2D, $8B
  .byte $EE, $58, $C8, $3E
  .byte $BC, $41, $CD, $63        ; C-3 C#3 D-3 D#3
  .byte $01, $A8, $5A, $16
  .byte $DD, $B0, $90, $7C
  .byte $77, $81, $9B, $C5        ; C-4 C#4 D-4 D#4
  .byte $02, $51, $B4, $2C        ; E-4 F-4 F#4 G-4
  .byte $BA, $60, $1F, $F9        ; G#4 A-4 A#4 B-4
  .byte $EF, $03, $36, $8B        ; C-5 C#5 D-5 D#3
  .byte $03, $A1, $67, $57
  .byte $73, $C0, $3E, $F1
  .byte $DE, $05, $6C, $16        ; C-6 C#6 D-6 D#6
  .byte $06, $43, $CE, $AE
  .byte $E6, $80, $7C, $E2
  .byte $BC, $0A, $8C, $2C        ; C-7 C#7 D-7 D#7
  .byte $0C, $86, $9C, $5C
  .byte $8C, $00, $F8, $FF
frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $02
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02, $02, $03, $03
  .byte $03, $03, $03, $04
  .byte $04, $04, $04, $05        ; C-2 C#2 D-2 D#2
  .byte $05, $05, $06, $06
  .byte $06, $07, $07, $08
  .byte $08, $09, $09, $0A        ; C-3 C#3 D-3 D#3
  .byte $0B, $0B, $0C, $0D
  .byte $0D, $0E, $0F, $10
  .byte $11, $12, $13, $14        ; C-4 C#4 D-4 D#4
  .byte $16, $17, $18, $1A        ; E-4 F-4 F#4 G-4
  .byte $1B, $1D, $1F, $20        ; G#4 A-4 A#4 B-4
  .byte $22, $25, $27, $29        ; C-5 C#5 D-5 D#3
  .byte $2C, $2E, $31, $34
  .byte $37, $3A, $3E, $41
  .byte $45, $4A, $4E, $53        ; C-6 C#6 D-6 D#6
  .byte $58, $5D, $62, $68
  .byte $6E, $75, $7C, $83
  .byte $8B, $94, $9D, $A6        ; C-7 C#7 D-7 D#7
  .byte $B0, $BA, $C5, $D1
  .byte $DD, $EB, $F8, $FF
 .endif

 .if A4_FREQ=4                    ; A4=468Hz
frequencyLo:
  .byte $00, $28, $3a, $4c        ; C-0 C#0 D-0 D#0
  .byte $60, $75, $8b, $a3
  .byte $bc, $d6, $f2, $10
  .byte $2f, $50, $73, $99        ; C-1 C#1 D-1 D#1
  .byte $c0, $ea, $16, $45
  .byte $77, $ac, $e4, $1f
  .byte $5e, $a0, $e7, $32        ; C-2 C#2 D-2 D#2   
  .byte $80, $d4, $2d, $8b
  .byte $ee, $58, $c8, $3e
  .byte $bc, $41, $cd, $63        ; C-3 C#3 D-3 D#3  
  .byte $01, $a8, $5a, $16
  .byte $dd, $b0, $90, $7c
  .byte $77, $81, $9b, $c5        ; C-4 C#4 D-4 D#4 
  .byte $02, $51, $b4, $2c        ; E-4 F-4 F#4 G-4
  .byte $ba, $60, $1f, $f9        ; G#4 A-4 A#4 B-4
  .byte $ef, $03, $36, $8b        ; C-5 C#5 D-5 D#3 
  .byte $03, $a1, $67, $57      
  .byte $73, $c0, $3e, $f1    
  .byte $de, $05, $6c, $16        ; C-6 C#6 D-6 D#6
  .byte $06, $43, $ce, $ae
  .byte $e7, $80, $7d, $e4
  .byte $bb, $0a, $d7, $2c        ; C-7 C#7 D-7 D#7
  .byte $0d, $85, $9c, $5c
  .byte $cf, $00, $00, $00
frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $02, $02
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02, $03, $03, $03
  .byte $03, $03, $04, $04
  .byte $04, $04, $05, $05        ; C-2 C#2 D-2 D#2
  .byte $05, $06, $06, $06
  .byte $07, $07, $08, $08
  .byte $09, $09, $0a, $0b        ; C-3 C#3 D-3 D#3
  .byte $0b, $0c, $0d, $0d
  .byte $0e, $0f, $10, $11
  .byte $12, $13, $14, $16        ; C-4 C#4 D-4 D#4
  .byte $17, $18, $1a, $1b        ; E-4 F-4 F#4 G-4
  .byte $1d, $1f, $20, $22        ; G#4 A-4 A#4 B-4
  .byte $25, $27, $29, $2c        ; C-5 C#5 D-5 D#3
  .byte $2e, $31, $34, $37
  .byte $3a, $3e, $41, $45
  .byte $4a, $4e, $53, $58        ; C-6 C#6 D-6 D#6
  .byte $5d, $62, $68, $6e
  .byte $75, $7c, $83, $8b
  .byte $94, $9c, $a6, $b0        ; C-7 C#7 D-7 D#7
  .byte $ba, $c5, $d1, $dd
  .byte $eb, $00, $00, $00
 .endif

 .if A4_FREQ=5                    ; A4=415Hz
frequencyLo:
  .byte $07, $16, $27, $39        ; C-0 C#0 D-0 D#0
  .byte $4b, $5f, $74, $8a
  .byte $a1, $ba, $d4, $f0
  .byte $0e, $2d, $4e, $71        ; C-1 C#1 D-1 D#1
  .byte $96, $be, $e7, $14 
  .byte $42, $74, $a9, $e0
  .byte $1b, $5a, $9c, $e2        ; C-2 C#2 D-2 D#2
  .byte $2d, $7b, $cf, $27
  .byte $85, $e8, $51, $c1
  .byte $37, $b4, $38, $c4        ; C-3 C#3 D-3 D#3
  .byte $59, $f7, $9e, $4e
  .byte $0a, $d0, $a2, $81
  .byte $6d, $67, $70, $89        ; C-4 C#4 D-4 D#4
  .byte $b2, $ed, $3b, $9d        ; E-4 F-4 F#4 G-4
  .byte $14, $a0, $45, $03        ; G#4 A-4 A#4 B-4
  .byte $db, $cf, $e1, $12        ; C-5 C#5 D-5 D#3
  .byte $65, $db, $76, $3a
  .byte $27, $41, $8a, $05
  .byte $b5, $9d, $c1, $24        ; C-6 C#6 D-6 D#6
  .byte $c9, $b6, $ed, $73
  .byte $4e, $82, $14, $0a
  .byte $6a, $3b, $82, $48        ; C-7 C#7 D-7 D#7
  .byte $93, $6b, $da, $e7
  .byte $9c, $04, $28, $14
frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $01
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02, $02, $02, $03
  .byte $03, $03, $03, $03
  .byte $04, $04, $04, $04        ; C-2 C#2 D-2 D#2
  .byte $05, $05, $05, $06
  .byte $06, $06, $07, $07
  .byte $08, $08, $09, $09        ; C-3 C#3 D-3 D#3
  .byte $0a, $0a, $0b, $0c
  .byte $0d, $0d, $0e, $0f
  .byte $10, $11, $12, $13        ; C-4 C#4 D-4 D#4
  .byte $14, $15, $17, $18        ; E-4 F-4 F#4 G-4
  .byte $1a, $1b, $1d, $1f        ; G#4 A-4 A#4 B-4
  .byte $20, $22, $24, $27        ; C-5 C#5 D-5 D#3
  .byte $29, $2b, $2e, $31
  .byte $34, $37, $3a, $3e
  .byte $41, $45, $49, $4e        ; C-6 C#6 D-6 D#6
  .byte $52, $57, $5c, $62
  .byte $68, $6e, $75, $7c
  .byte $83, $8b, $93, $9c        ; C-7 C#7 D-7 D#7
  .byte $a5, $af, $b9, $c4
  .byte $d0, $dd, $ea, $f8
 .endif

 .if A4_FREQ=6                    ; A4=438Hz
frequencyLo:
  .byte $15, $25, $36, $49        ; C-0 C#0 D-0 D#0
  .byte $5c, $71, $87, $9f
  .byte $b7, $d1, $ed, $0a
  .byte $2a, $4a, $6d, $92        ; C-1 C#1 D-1 D#1
  .byte $b9, $e3, $0f, $3e
  .byte $6f, $a3, $db, $15
  .byte $54, $95, $db, $25        ; C-2 C#2 D-2 D#2
  .byte $73, $c7, $1e, $7c
  .byte $de, $47, $b6, $2b
  .byte $a8, $2b, $b7, $4b        ; C-3 C#3 D-3 D#3
  .byte $e7, $8e, $3d, $f8
  .byte $bd, $8e, $6c, $57
  .byte $50, $57, $6e, $96        ; C-4 C#4 D-4 D#4
  .byte $cf, $1c, $7b, $f0        ; E-4 F-4 F#4 G-4
  .byte $7b, $1d, $d8, $ae        ; G#4 A-4 A#4 B-4
  .byte $a0, $af, $dd, $2d        ; C-5 C#5 D-5 D#3
  .byte $9f, $38, $f7, $e0
  .byte $f6, $3b, $b1, $5d
  .byte $40, $5e, $bb, $5a        ; C-6 C#6 D-6 D#6
  .byte $3f, $70, $ef, $c1
  .byte $ed, $76, $63, $ba
  .byte $80, $bc, $76, $b4        ; C-7 C#7 D-7 D#7
  .byte $7f, $e0, $de, $83
  .byte $da, $ed, $c7, $ff
frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $02
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02, $02, $03, $03
  .byte $03, $03, $03, $04
  .byte $04, $04, $04, $05        ; C-2 C#2 D-2 D#2
  .byte $05, $05, $06, $06
  .byte $06, $07, $07, $08
  .byte $08, $09, $09, $0a        ; C-3 C#3 D-3 D#3
  .byte $0a, $0b, $0c, $0c
  .byte $0d, $0e, $0f, $10
  .byte $11, $12, $13, $14        ; C-4 C#4 D-4 D#4
  .byte $15, $17, $18, $19        ; E-4 F-4 F#4 G-4
  .byte $1b, $1d, $1e, $20        ; G#4 A-4 A#4 B-4
  .byte $22, $24, $26, $29        ; C-5 C#5 D-5 D#3
  .byte $2b, $2e, $30, $33
  .byte $36, $3a, $3d, $41
  .byte $45, $49, $4d, $52        ; C-6 C#6 D-6 D#6
  .byte $57, $5c, $61, $67
  .byte $6d, $74, $7b, $82
  .byte $8a, $92, $9b, $a4        ; C-7 C#7 D-7 D#7
  .byte $ae, $b8, $c3, $cf
  .byte $db, $e8, $f6, $ff
 .endif

 .if A4_FREQ=7                    ; A4=449Hz
frequencyLo:
  .byte $1c, $2d, $3e, $51        ; C-0 C#0 D-0 D#0
  .byte $66, $7b, $91, $a9
  .byte $c3, $dd, $fa, $18
  .byte $38, $5a, $7d, $a3        ; C-1 C#1 D-1 D#1
  .byte $cc, $f6, $23, $53
  .byte $86, $bb, $f4, $30
  .byte $70, $b4, $fb, $47        ; C-2 C#2 D-2 D#2
  .byte $98, $ed, $47, $a7 
  .byte $0c, $77, $e9, $61
  .byte $e1, $68, $f7, $8f        ; C-3 C#3 D-3 D#3
  .byte $30, $da, $8f, $4e 
  .byte $18, $ef, $d2, $c3
  .byte $c3, $d1, $ef, $1f        ; C-4 C#4 D-4 D#4
  .byte $60, $b5, $1e, $9c        ; E-4 F-4 F#4 G-4
  .byte $31, $df, $a5, $87        ; G#4 A-4 A#4 B-4
  .byte $86, $a2, $df, $3e        ; C-5 C#5 D-5 D#3
  .byte $c1, $6b, $3c, $39
  .byte $63, $be, $4b, $0f
  .byte $0c, $45, $bf, $7d        ; C-6 C#6 D-6 D#6
  .byte $83, $d6, $79, $73
  .byte $c7, $7c, $97, $1e
  .byte $18, $8b, $7e, $fa        ; C-7 C#7 D-7 D#7
  .byte $06, $ac, $f3, $e6
  .byte $8f, $f8, $2e, $00
frequencyHi:
  .byte $01, $01, $01, $01        ; C-0 C#0 D-0 D#0
  .byte $01, $01, $01, $01
  .byte $01, $01, $01, $02
  .byte $02, $02, $02, $02        ; C-1 C#1 D-1 D#1
  .byte $02, $02, $03, $03
  .byte $03, $03, $03, $04
  .byte $04, $04, $04, $05        ; C-2 C#2 D-2 D#2
  .byte $05, $05, $06, $06
  .byte $07, $07, $07, $08
  .byte $08, $09, $09, $0a        ; C-3 C#3 D-3 D#3
  .byte $0b, $0b, $0c, $0d        ; E-4 F-4 F#4 G-4
  .byte $0e, $0e, $0f, $10        ; G#4 A-4 A#4 B-4
  .byte $11, $12, $13, $15        ; C-4 C#4 D-4 D#4
  .byte $16, $17, $19, $1a
  .byte $1c, $1d, $1f, $21
  .byte $23, $25, $27, $2a        ; C-5 C#5 D-5 D#3
  .byte $2c, $2f, $32, $35
  .byte $38, $3b, $3f, $43
  .byte $47, $4b, $4f, $54        ; C-6 C#6 D-6 D#6
  .byte $59, $5e, $64, $6a
  .byte $70, $77, $7e, $86
  .byte $8e, $96, $9f, $a8        ; C-7 C#7 D-7 D#7
  .byte $b3, $bd, $c8, $d4
  .byte $e1, $ee, $fd, $00
 .endif

 .mac ins_instr_low
 .if (NUM_INSTR> ({1}-1))
   .byte <instr{1}
 .endif
 .endm

 .mac ins_instr_high
 .if (NUM_INSTR> ({1}-1))
   .byte >instr{1}
 .endif
 .endm


; instrument table pointer (filled according to the actual number of instruments)
instrPtrLow:
  ins_instr_low 1
  ins_instr_low 2
  ins_instr_low 3
  ins_instr_low 4
  ins_instr_low 5
  ins_instr_low 6
  ins_instr_low 7
  ins_instr_low 8
  ins_instr_low 9
  ins_instr_low 10
  ins_instr_low 11
  ins_instr_low 12
  ins_instr_low 13
  ins_instr_low 14
  ins_instr_low 15
  ins_instr_low 16
  ins_instr_low 17
  ins_instr_low 18
  ins_instr_low 19
  ins_instr_low 20
  ins_instr_low 21
  ins_instr_low 22
  ins_instr_low 23
  ins_instr_low 24
  ins_instr_low 25
  ins_instr_low 26
  ins_instr_low 27
  ins_instr_low 28
  ins_instr_low 29
  ins_instr_low 30
  ins_instr_low 31
  ins_instr_low 32
  ins_instr_low 33
  ins_instr_low 34
  ins_instr_low 35
  ins_instr_low 36
  ins_instr_low 37
  ins_instr_low 38
  ins_instr_low 39
  ins_instr_low 40
  ins_instr_low 41
  ins_instr_low 42
  ins_instr_low 43
  ins_instr_low 44
  ins_instr_low 45
  ins_instr_low 46
  ins_instr_low 47
  ins_instr_low 48
  ins_instr_low 49
  ins_instr_low 50
  ins_instr_low 51
  ins_instr_low 52
  ins_instr_low 53
  ins_instr_low 54
  ins_instr_low 55
  ins_instr_low 56
  ins_instr_low 57
  ins_instr_low 58
  ins_instr_low 59
  ins_instr_low 60
  ins_instr_low 61
  ins_instr_low 62
  ins_instr_low 63
  ins_instr_low 64
  ins_instr_low 65
  ins_instr_low 66
  ins_instr_low 67
  ins_instr_low 68
  ins_instr_low 69
  ins_instr_low 70
  ins_instr_low 71
  ins_instr_low 72
  ins_instr_low 73
  ins_instr_low 74
  ins_instr_low 75
  ins_instr_low 76
  ins_instr_low 77
  ins_instr_low 78
  ins_instr_low 79
  ins_instr_low 80
  ins_instr_low 81
  ins_instr_low 82
  ins_instr_low 83
  ins_instr_low 84
  ins_instr_low 85
  ins_instr_low 86
  ins_instr_low 87
  ins_instr_low 88
  ins_instr_low 89
  ins_instr_low 90
  ins_instr_low 91
  ins_instr_low 92
  ins_instr_low 93
  ins_instr_low 94
  ins_instr_low 95
  ins_instr_low 96
  ins_instr_low 97
  ins_instr_low 98
  ins_instr_low 99
  ins_instr_low 100
  ins_instr_low 101
  ins_instr_low 102
  ins_instr_low 103
  ins_instr_low 104
  ins_instr_low 105
  ins_instr_low 106
  ins_instr_low 107
  ins_instr_low 108
  ins_instr_low 109
  ins_instr_low 110
  ins_instr_low 111
  ins_instr_low 112
  ins_instr_low 113
  ins_instr_low 114
  ins_instr_low 115
  ins_instr_low 116
  ins_instr_low 117
  ins_instr_low 118
  ins_instr_low 119
  ins_instr_low 120
  ins_instr_low 121
  ins_instr_low 122
  ins_instr_low 123
  ins_instr_low 124
  ins_instr_low 125
  ins_instr_low 126
  ins_instr_low 127
  ins_instr_low 128
  ins_instr_low 129
  ins_instr_low 130
  ins_instr_low 131
  ins_instr_low 132
  ins_instr_low 133
  ins_instr_low 134
  ins_instr_low 135
  ins_instr_low 136
  ins_instr_low 137
  ins_instr_low 138
  ins_instr_low 139
  ins_instr_low 140
  ins_instr_low 141
  ins_instr_low 142
  ins_instr_low 143
  ins_instr_low 144
  ins_instr_low 145
  ins_instr_low 146
  ins_instr_low 147
  ins_instr_low 148
  ins_instr_low 149
  ins_instr_low 150
  ins_instr_low 151
  ins_instr_low 152
  ins_instr_low 153
  ins_instr_low 154
  ins_instr_low 155
  ins_instr_low 156
  ins_instr_low 157
  ins_instr_low 158
  ins_instr_low 159
  ins_instr_low 160
  ins_instr_low 161
  ins_instr_low 162
  ins_instr_low 163
  ins_instr_low 164
  ins_instr_low 165
  ins_instr_low 166
  ins_instr_low 167
  ins_instr_low 168
  ins_instr_low 169
  ins_instr_low 170
  ins_instr_low 171
  ins_instr_low 172
  ins_instr_low 173
  ins_instr_low 174
  ins_instr_low 175
  ins_instr_low 176
  ins_instr_low 177
  ins_instr_low 178
  ins_instr_low 179
  ins_instr_low 180
  ins_instr_low 181
  ins_instr_low 182
  ins_instr_low 183
  ins_instr_low 184
  ins_instr_low 185
  ins_instr_low 186
  ins_instr_low 187
  ins_instr_low 188
  ins_instr_low 189
  ins_instr_low 190
  ins_instr_low 191
  ins_instr_low 192
  ins_instr_low 193
  ins_instr_low 194
  ins_instr_low 195
  ins_instr_low 196
  ins_instr_low 197
  ins_instr_low 198
  ins_instr_low 199
  ins_instr_low 200
  ins_instr_low 201
  ins_instr_low 202
  ins_instr_low 203
  ins_instr_low 204
  ins_instr_low 205
  ins_instr_low 206
  ins_instr_low 207
  ins_instr_low 208
  ins_instr_low 209
  ins_instr_low 210
  ins_instr_low 211
  ins_instr_low 212
  ins_instr_low 213
  ins_instr_low 214
  ins_instr_low 215
  ins_instr_low 216
  ins_instr_low 217
  ins_instr_low 218
  ins_instr_low 219
  ins_instr_low 220
  ins_instr_low 221
  ins_instr_low 222
  ins_instr_low 223
  ins_instr_low 224
  ins_instr_low 225
  ins_instr_low 226
  ins_instr_low 227
  ins_instr_low 228
  ins_instr_low 229
  ins_instr_low 230
  ins_instr_low 231
  ins_instr_low 232
  ins_instr_low 233
  ins_instr_low 234
  ins_instr_low 235
  ins_instr_low 236
  ins_instr_low 237
  ins_instr_low 238
  ins_instr_low 239
  ins_instr_low 240
  ins_instr_low 241
  ins_instr_low 242
  ins_instr_low 243
  ins_instr_low 244
  ins_instr_low 245
  ins_instr_low 246
  ins_instr_low 247
  ins_instr_low 248
  ins_instr_low 249
  ins_instr_low 250
  ins_instr_low 251
  ins_instr_low 252
  ins_instr_low 253
  ins_instr_low 254
  ins_instr_low 255

instrPtrHigh:
  ins_instr_high 1
  ins_instr_high 2
  ins_instr_high 3
  ins_instr_high 4
  ins_instr_high 5
  ins_instr_high 6
  ins_instr_high 7
  ins_instr_high 8
  ins_instr_high 9
  ins_instr_high 10
  ins_instr_high 11
  ins_instr_high 12
  ins_instr_high 13
  ins_instr_high 14
  ins_instr_high 15
  ins_instr_high 16
  ins_instr_high 17
  ins_instr_high 18
  ins_instr_high 19
  ins_instr_high 20
  ins_instr_high 21
  ins_instr_high 22
  ins_instr_high 23
  ins_instr_high 24
  ins_instr_high 25
  ins_instr_high 26
  ins_instr_high 27
  ins_instr_high 28
  ins_instr_high 29
  ins_instr_high 30
  ins_instr_high 31
  ins_instr_high 32
  ins_instr_high 33
  ins_instr_high 34
  ins_instr_high 35
  ins_instr_high 36
  ins_instr_high 37
  ins_instr_high 38
  ins_instr_high 39
  ins_instr_high 40
  ins_instr_high 41
  ins_instr_high 42
  ins_instr_high 43
  ins_instr_high 44
  ins_instr_high 45
  ins_instr_high 46
  ins_instr_high 47
  ins_instr_high 48
  ins_instr_high 49
  ins_instr_high 50
  ins_instr_high 51
  ins_instr_high 52
  ins_instr_high 53
  ins_instr_high 54
  ins_instr_high 55
  ins_instr_high 56
  ins_instr_high 57
  ins_instr_high 58
  ins_instr_high 59
  ins_instr_high 60
  ins_instr_high 61
  ins_instr_high 62
  ins_instr_high 63
  ins_instr_high 64
  ins_instr_high 65
  ins_instr_high 66
  ins_instr_high 67
  ins_instr_high 68
  ins_instr_high 69
  ins_instr_high 70
  ins_instr_high 71
  ins_instr_high 72
  ins_instr_high 73
  ins_instr_high 74
  ins_instr_high 75
  ins_instr_high 76
  ins_instr_high 77
  ins_instr_high 78
  ins_instr_high 79
  ins_instr_high 80
  ins_instr_high 81
  ins_instr_high 82
  ins_instr_high 83
  ins_instr_high 84
  ins_instr_high 85
  ins_instr_high 86
  ins_instr_high 87
  ins_instr_high 88
  ins_instr_high 89
  ins_instr_high 90
  ins_instr_high 91
  ins_instr_high 92
  ins_instr_high 93
  ins_instr_high 94
  ins_instr_high 95
  ins_instr_high 96
  ins_instr_high 97
  ins_instr_high 98
  ins_instr_high 99
  ins_instr_high 100
  ins_instr_high 101
  ins_instr_high 102
  ins_instr_high 103
  ins_instr_high 104
  ins_instr_high 105
  ins_instr_high 106
  ins_instr_high 107
  ins_instr_high 108
  ins_instr_high 109
  ins_instr_high 110
  ins_instr_high 111
  ins_instr_high 112
  ins_instr_high 113
  ins_instr_high 114
  ins_instr_high 115
  ins_instr_high 116
  ins_instr_high 117
  ins_instr_high 118
  ins_instr_high 119
  ins_instr_high 120
  ins_instr_high 121
  ins_instr_high 122
  ins_instr_high 123
  ins_instr_high 124
  ins_instr_high 125
  ins_instr_high 126
  ins_instr_high 127
  ins_instr_high 128
  ins_instr_high 129
  ins_instr_high 130
  ins_instr_high 131
  ins_instr_high 132
  ins_instr_high 133
  ins_instr_high 134
  ins_instr_high 135
  ins_instr_high 136
  ins_instr_high 137
  ins_instr_high 138
  ins_instr_high 139
  ins_instr_high 140
  ins_instr_high 141
  ins_instr_high 142
  ins_instr_high 143
  ins_instr_high 144
  ins_instr_high 145
  ins_instr_high 146
  ins_instr_high 147
  ins_instr_high 148
  ins_instr_high 149
  ins_instr_high 150
  ins_instr_high 151
  ins_instr_high 152
  ins_instr_high 153
  ins_instr_high 154
  ins_instr_high 155
  ins_instr_high 156
  ins_instr_high 157
  ins_instr_high 158
  ins_instr_high 159
  ins_instr_high 160
  ins_instr_high 161
  ins_instr_high 162
  ins_instr_high 163
  ins_instr_high 164
  ins_instr_high 165
  ins_instr_high 166
  ins_instr_high 167
  ins_instr_high 168
  ins_instr_high 169
  ins_instr_high 170
  ins_instr_high 171
  ins_instr_high 172
  ins_instr_high 173
  ins_instr_high 174
  ins_instr_high 175
  ins_instr_high 176
  ins_instr_high 177
  ins_instr_high 178
  ins_instr_high 179
  ins_instr_high 180
  ins_instr_high 181
  ins_instr_high 182
  ins_instr_high 183
  ins_instr_high 184
  ins_instr_high 185
  ins_instr_high 186
  ins_instr_high 187
  ins_instr_high 188
  ins_instr_high 189
  ins_instr_high 190
  ins_instr_high 191
  ins_instr_high 192
  ins_instr_high 193
  ins_instr_high 194
  ins_instr_high 195
  ins_instr_high 196
  ins_instr_high 197
  ins_instr_high 198
  ins_instr_high 199
  ins_instr_high 200
  ins_instr_high 201
  ins_instr_high 202
  ins_instr_high 203
  ins_instr_high 204
  ins_instr_high 205
  ins_instr_high 206
  ins_instr_high 207
  ins_instr_high 208
  ins_instr_high 209
  ins_instr_high 210
  ins_instr_high 211
  ins_instr_high 212
  ins_instr_high 213
  ins_instr_high 214
  ins_instr_high 215
  ins_instr_high 216
  ins_instr_high 217
  ins_instr_high 218
  ins_instr_high 219
  ins_instr_high 220
  ins_instr_high 221
  ins_instr_high 222
  ins_instr_high 223
  ins_instr_high 224
  ins_instr_high 225
  ins_instr_high 226
  ins_instr_high 227
  ins_instr_high 228
  ins_instr_high 229
  ins_instr_high 230
  ins_instr_high 231
  ins_instr_high 232
  ins_instr_high 233
  ins_instr_high 234
  ins_instr_high 235
  ins_instr_high 236
  ins_instr_high 237
  ins_instr_high 238
  ins_instr_high 239
  ins_instr_high 240
  ins_instr_high 241
  ins_instr_high 242
  ins_instr_high 243
  ins_instr_high 244
  ins_instr_high 245
  ins_instr_high 246
  ins_instr_high 247
  ins_instr_high 248
  ins_instr_high 249
  ins_instr_high 250
  ins_instr_high 251
  ins_instr_high 252
  ins_instr_high 253
  ins_instr_high 254
  ins_instr_high 255

; Instrument definition (filled according to actual number of instruments)

 .mac ins_instr
 .if (NUM_INSTR> ({1}-1))
instr{1}:
  .byte INSTR_HR_{1}
  .byte INSTR_AD_{1}
  .byte INSTR_SR_{1}
  .byte INSTR_CTRL1_{1}
  .byte INSTR_CTRL2_{1}
  .byte <instrAD_{1}        , >instrAD_{1}
  .byte <instrSR_{1}        , >instrSR_{1}
  .byte <instrWave_{1}      , >instrWave_{1}
  .byte <instrFreq_{1}      , >instrFreq_{1}
  .byte <instrPulse_{1}     , >instrPulse_{1}
  .byte <instrFilter_{1}    , >instrFilter_{1}
  .byte <instrRes_{1}       , >instrRes_{1}
  .byte <instrType_{1}      , >instrType_{1}
  .byte <instrRelNote_{1}   , >instrRelNote_{1}
  .byte <instrFixFreq_{1}   , >instrFixFreq_{1}
  .byte <instrRelFreq_{1}   , >instrRelFreq_{1}
  .byte <instrFixPulse_{1}  , >instrFixPulse_{1}
  .byte <instrRelPulse_{1}  , >instrRelPulse_{1}
  .byte <instrRelFilter_{1} , >instrRelFilter_{1}
  .byte <instrFixFilter_{1} , >instrFixFilter_{1}
  .byte <instrDelay_{1}     , >instrDelay_{1}
  .byte <instrRepeat_{1}    , >instrRepeat_{1}
 .endif
 .endm

  ins_instr 1
  ins_instr 2
  ins_instr 3
  ins_instr 4
  ins_instr 5
  ins_instr 6
  ins_instr 7
  ins_instr 8
  ins_instr 9
  ins_instr 10
  ins_instr 11
  ins_instr 12
  ins_instr 13
  ins_instr 14
  ins_instr 15
  ins_instr 16
  ins_instr 17
  ins_instr 18
  ins_instr 19
  ins_instr 20
  ins_instr 21
  ins_instr 22
  ins_instr 23
  ins_instr 24
  ins_instr 25
  ins_instr 26
  ins_instr 27
  ins_instr 28
  ins_instr 29
  ins_instr 30
  ins_instr 31
  ins_instr 32
  ins_instr 33
  ins_instr 34
  ins_instr 35
  ins_instr 36
  ins_instr 37
  ins_instr 38
  ins_instr 39
  ins_instr 40
  ins_instr 41
  ins_instr 42
  ins_instr 43
  ins_instr 44
  ins_instr 45
  ins_instr 46
  ins_instr 47
  ins_instr 48
  ins_instr 49
  ins_instr 50
  ins_instr 51
  ins_instr 52
  ins_instr 53
  ins_instr 54
  ins_instr 55
  ins_instr 56
  ins_instr 57
  ins_instr 58
  ins_instr 59
  ins_instr 60
  ins_instr 61
  ins_instr 62
  ins_instr 63
  ins_instr 64
  ins_instr 65
  ins_instr 66
  ins_instr 67
  ins_instr 68
  ins_instr 69
  ins_instr 70
  ins_instr 71
  ins_instr 72
  ins_instr 73
  ins_instr 74
  ins_instr 75
  ins_instr 76
  ins_instr 77
  ins_instr 78
  ins_instr 79
  ins_instr 80
  ins_instr 81
  ins_instr 82
  ins_instr 83
  ins_instr 84
  ins_instr 85
  ins_instr 86
  ins_instr 87
  ins_instr 88
  ins_instr 89
  ins_instr 90
  ins_instr 91
  ins_instr 92
  ins_instr 93
  ins_instr 94
  ins_instr 95
  ins_instr 96
  ins_instr 97
  ins_instr 98
  ins_instr 99
  ins_instr 100
  ins_instr 101
  ins_instr 102
  ins_instr 103
  ins_instr 104
  ins_instr 105
  ins_instr 106
  ins_instr 107
  ins_instr 108
  ins_instr 109
  ins_instr 110
  ins_instr 111
  ins_instr 112
  ins_instr 113
  ins_instr 114
  ins_instr 115
  ins_instr 116
  ins_instr 117
  ins_instr 118
  ins_instr 119
  ins_instr 120
  ins_instr 121
  ins_instr 122
  ins_instr 123
  ins_instr 124
  ins_instr 125
  ins_instr 126
  ins_instr 127
  ins_instr 128
  ins_instr 129
  ins_instr 130
  ins_instr 131
  ins_instr 132
  ins_instr 133
  ins_instr 134
  ins_instr 135
  ins_instr 136
  ins_instr 137
  ins_instr 138
  ins_instr 139
  ins_instr 140
  ins_instr 141
  ins_instr 142
  ins_instr 143
  ins_instr 144
  ins_instr 145
  ins_instr 146
  ins_instr 147
  ins_instr 148
  ins_instr 149
  ins_instr 150
  ins_instr 151
  ins_instr 152
  ins_instr 153
  ins_instr 154
  ins_instr 155
  ins_instr 156
  ins_instr 157
  ins_instr 158
  ins_instr 159
  ins_instr 160
  ins_instr 161
  ins_instr 162
  ins_instr 163
  ins_instr 164
  ins_instr 165
  ins_instr 166
  ins_instr 167
  ins_instr 168
  ins_instr 169
  ins_instr 170
  ins_instr 171
  ins_instr 172
  ins_instr 173
  ins_instr 174
  ins_instr 175
  ins_instr 176
  ins_instr 177
  ins_instr 178
  ins_instr 179
  ins_instr 180
  ins_instr 181
  ins_instr 182
  ins_instr 183
  ins_instr 184
  ins_instr 185
  ins_instr 186
  ins_instr 187
  ins_instr 188
  ins_instr 189
  ins_instr 190
  ins_instr 191
  ins_instr 192
  ins_instr 193
  ins_instr 194
  ins_instr 195
  ins_instr 196
  ins_instr 197
  ins_instr 198
  ins_instr 199
  ins_instr 200
  ins_instr 201
  ins_instr 202
  ins_instr 203
  ins_instr 204
  ins_instr 205
  ins_instr 206
  ins_instr 207
  ins_instr 208
  ins_instr 209
  ins_instr 210
  ins_instr 211
  ins_instr 212
  ins_instr 213
  ins_instr 214
  ins_instr 215
  ins_instr 216
  ins_instr 217
  ins_instr 218
  ins_instr 219
  ins_instr 220
  ins_instr 221
  ins_instr 222
  ins_instr 223
  ins_instr 224
  ins_instr 225
  ins_instr 226
  ins_instr 227
  ins_instr 228
  ins_instr 229
  ins_instr 230
  ins_instr 231
  ins_instr 232
  ins_instr 233
  ins_instr 234
  ins_instr 235
  ins_instr 236
  ins_instr 237
  ins_instr 238
  ins_instr 239
  ins_instr 240
  ins_instr 241
  ins_instr 242
  ins_instr 243
  ins_instr 244
  ins_instr 245
  ins_instr 246
  ins_instr 247
  ins_instr 248
  ins_instr 249
  ins_instr 250
  ins_instr 251
  ins_instr 252
  ins_instr 253
  ins_instr 254
  ins_instr 255


; tables for tunes and tracks

 .mac tune_track_low
 .if (NUM_TUNE> ({1}-1))
   .byte <tune{1}_track{2}
 .endif
 .endm

 .mac tune_track_high
 .if (NUM_TUNE> ({1}-1))
   .byte >tune{1}_track{2}
 .endif
 .endm

; low pointer for track 1 of tunes
tuneTrack1_L:
  tune_track_low 1, 1
  tune_track_low 2, 1
  tune_track_low 3, 1
  tune_track_low 4, 1
  tune_track_low 5, 1
  tune_track_low 6, 1
  tune_track_low 7, 1
  tune_track_low 8, 1
  tune_track_low 9, 1
  tune_track_low 10, 1
  tune_track_low 11, 1
  tune_track_low 12, 1
  tune_track_low 13, 1
  tune_track_low 14, 1
  tune_track_low 15, 1
  tune_track_low 16, 1
  tune_track_low 17, 1
  tune_track_low 18, 1
  tune_track_low 19, 1
  tune_track_low 20, 1
  tune_track_low 21, 1
  tune_track_low 22, 1
  tune_track_low 23, 1
  tune_track_low 24, 1
  tune_track_low 25, 1
  tune_track_low 26, 1
  tune_track_low 27, 1
  tune_track_low 28, 1
  tune_track_low 29, 1
  tune_track_low 30, 1
  tune_track_low 31, 1
  tune_track_low 32, 1
  tune_track_low 33, 1
  tune_track_low 34, 1
  tune_track_low 35, 1
  tune_track_low 36, 1
  tune_track_low 37, 1
  tune_track_low 38, 1
  tune_track_low 39, 1
  tune_track_low 40, 1
  tune_track_low 41, 1
  tune_track_low 42, 1
  tune_track_low 43, 1
  tune_track_low 44, 1
  tune_track_low 45, 1
  tune_track_low 46, 1
  tune_track_low 47, 1
  tune_track_low 48, 1
  tune_track_low 49, 1
  tune_track_low 50, 1
  tune_track_low 51, 1
  tune_track_low 52, 1
  tune_track_low 53, 1
  tune_track_low 54, 1
  tune_track_low 55, 1
  tune_track_low 56, 1
  tune_track_low 57, 1
  tune_track_low 58, 1
  tune_track_low 59, 1
  tune_track_low 60, 1
  tune_track_low 61, 1
  tune_track_low 62, 1
  tune_track_low 63, 1
  tune_track_low 64, 1
  tune_track_low 65, 1
  tune_track_low 66, 1
  tune_track_low 67, 1
  tune_track_low 68, 1
  tune_track_low 69, 1
  tune_track_low 70, 1
  tune_track_low 71, 1
  tune_track_low 72, 1
  tune_track_low 73, 1
  tune_track_low 74, 1
  tune_track_low 75, 1
  tune_track_low 76, 1
  tune_track_low 77, 1
  tune_track_low 78, 1
  tune_track_low 79, 1
  tune_track_low 80, 1
  tune_track_low 81, 1
  tune_track_low 82, 1
  tune_track_low 83, 1
  tune_track_low 84, 1
  tune_track_low 85, 1
  tune_track_low 86, 1
  tune_track_low 87, 1
  tune_track_low 88, 1
  tune_track_low 89, 1
  tune_track_low 90, 1
  tune_track_low 91, 1
  tune_track_low 92, 1
  tune_track_low 93, 1
  tune_track_low 94, 1
  tune_track_low 95, 1
  tune_track_low 96, 1
  tune_track_low 97, 1
  tune_track_low 98, 1
  tune_track_low 99, 1
  tune_track_low 100, 1
  tune_track_low 101, 1
  tune_track_low 102, 1
  tune_track_low 103, 1
  tune_track_low 104, 1
  tune_track_low 105, 1
  tune_track_low 106, 1
  tune_track_low 107, 1
  tune_track_low 108, 1
  tune_track_low 109, 1
  tune_track_low 110, 1
  tune_track_low 111, 1
  tune_track_low 112, 1
  tune_track_low 113, 1
  tune_track_low 114, 1
  tune_track_low 115, 1
  tune_track_low 116, 1
  tune_track_low 117, 1
  tune_track_low 118, 1
  tune_track_low 119, 1
  tune_track_low 120, 1
  tune_track_low 121, 1
  tune_track_low 122, 1
  tune_track_low 123, 1
  tune_track_low 124, 1
  tune_track_low 125, 1
  tune_track_low 126, 1
  tune_track_low 127, 1
  tune_track_low 128, 1
  tune_track_low 129, 1
  tune_track_low 130, 1
  tune_track_low 131, 1
  tune_track_low 132, 1
  tune_track_low 133, 1
  tune_track_low 134, 1
  tune_track_low 135, 1
  tune_track_low 136, 1
  tune_track_low 137, 1
  tune_track_low 138, 1
  tune_track_low 139, 1
  tune_track_low 140, 1
  tune_track_low 141, 1
  tune_track_low 142, 1
  tune_track_low 143, 1
  tune_track_low 144, 1
  tune_track_low 145, 1
  tune_track_low 146, 1
  tune_track_low 147, 1
  tune_track_low 148, 1
  tune_track_low 149, 1
  tune_track_low 150, 1
  tune_track_low 151, 1
  tune_track_low 152, 1
  tune_track_low 153, 1
  tune_track_low 154, 1
  tune_track_low 155, 1
  tune_track_low 156, 1
  tune_track_low 157, 1
  tune_track_low 158, 1
  tune_track_low 159, 1
  tune_track_low 160, 1
  tune_track_low 161, 1
  tune_track_low 162, 1
  tune_track_low 163, 1
  tune_track_low 164, 1
  tune_track_low 165, 1
  tune_track_low 166, 1
  tune_track_low 167, 1
  tune_track_low 168, 1
  tune_track_low 169, 1
  tune_track_low 170, 1
  tune_track_low 171, 1
  tune_track_low 172, 1
  tune_track_low 173, 1
  tune_track_low 174, 1
  tune_track_low 175, 1
  tune_track_low 176, 1
  tune_track_low 177, 1
  tune_track_low 178, 1
  tune_track_low 179, 1
  tune_track_low 180, 1
  tune_track_low 181, 1
  tune_track_low 182, 1
  tune_track_low 183, 1
  tune_track_low 184, 1
  tune_track_low 185, 1
  tune_track_low 186, 1
  tune_track_low 187, 1
  tune_track_low 188, 1
  tune_track_low 189, 1
  tune_track_low 190, 1
  tune_track_low 191, 1
  tune_track_low 192, 1
  tune_track_low 193, 1
  tune_track_low 194, 1
  tune_track_low 195, 1
  tune_track_low 196, 1
  tune_track_low 197, 1
  tune_track_low 198, 1
  tune_track_low 199, 1
  tune_track_low 200, 1
  tune_track_low 201, 1
  tune_track_low 202, 1
  tune_track_low 203, 1
  tune_track_low 204, 1
  tune_track_low 205, 1
  tune_track_low 206, 1
  tune_track_low 207, 1
  tune_track_low 208, 1
  tune_track_low 209, 1
  tune_track_low 210, 1
  tune_track_low 211, 1
  tune_track_low 212, 1
  tune_track_low 213, 1
  tune_track_low 214, 1
  tune_track_low 215, 1
  tune_track_low 216, 1
  tune_track_low 217, 1
  tune_track_low 218, 1
  tune_track_low 219, 1
  tune_track_low 220, 1
  tune_track_low 221, 1
  tune_track_low 222, 1
  tune_track_low 223, 1
  tune_track_low 224, 1
  tune_track_low 225, 1
  tune_track_low 226, 1
  tune_track_low 227, 1
  tune_track_low 228, 1
  tune_track_low 229, 1
  tune_track_low 230, 1
  tune_track_low 231, 1
  tune_track_low 232, 1
  tune_track_low 233, 1
  tune_track_low 234, 1
  tune_track_low 235, 1
  tune_track_low 236, 1
  tune_track_low 237, 1
  tune_track_low 238, 1
  tune_track_low 239, 1
  tune_track_low 240, 1
  tune_track_low 241, 1
  tune_track_low 242, 1
  tune_track_low 243, 1
  tune_track_low 244, 1
  tune_track_low 245, 1
  tune_track_low 246, 1
  tune_track_low 247, 1
  tune_track_low 248, 1
  tune_track_low 249, 1
  tune_track_low 250, 1
  tune_track_low 251, 1
  tune_track_low 252, 1
  tune_track_low 253, 1
  tune_track_low 254, 1
  tune_track_low 255, 1
  tune_track_low 256, 1

; high pointer for track 1 of tunes
tuneTrack1_H:
  tune_track_high 1, 1
  tune_track_high 2, 1
  tune_track_high 3, 1
  tune_track_high 4, 1
  tune_track_high 5, 1
  tune_track_high 6, 1
  tune_track_high 7, 1
  tune_track_high 8, 1
  tune_track_high 9, 1
  tune_track_high 10, 1
  tune_track_high 11, 1
  tune_track_high 12, 1
  tune_track_high 13, 1
  tune_track_high 14, 1
  tune_track_high 15, 1
  tune_track_high 16, 1
  tune_track_high 17, 1
  tune_track_high 18, 1
  tune_track_high 19, 1
  tune_track_high 20, 1
  tune_track_high 21, 1
  tune_track_high 22, 1
  tune_track_high 23, 1
  tune_track_high 24, 1
  tune_track_high 25, 1
  tune_track_high 26, 1
  tune_track_high 27, 1
  tune_track_high 28, 1
  tune_track_high 29, 1
  tune_track_high 30, 1
  tune_track_high 31, 1
  tune_track_high 32, 1
  tune_track_high 33, 1
  tune_track_high 34, 1
  tune_track_high 35, 1
  tune_track_high 36, 1
  tune_track_high 37, 1
  tune_track_high 38, 1
  tune_track_high 39, 1
  tune_track_high 40, 1
  tune_track_high 41, 1
  tune_track_high 42, 1
  tune_track_high 43, 1
  tune_track_high 44, 1
  tune_track_high 45, 1
  tune_track_high 46, 1
  tune_track_high 47, 1
  tune_track_high 48, 1
  tune_track_high 49, 1
  tune_track_high 50, 1
  tune_track_high 51, 1
  tune_track_high 52, 1
  tune_track_high 53, 1
  tune_track_high 54, 1
  tune_track_high 55, 1
  tune_track_high 56, 1
  tune_track_high 57, 1
  tune_track_high 58, 1
  tune_track_high 59, 1
  tune_track_high 60, 1
  tune_track_high 61, 1
  tune_track_high 62, 1
  tune_track_high 63, 1
  tune_track_high 64, 1
  tune_track_high 65, 1
  tune_track_high 66, 1
  tune_track_high 67, 1
  tune_track_high 68, 1
  tune_track_high 69, 1
  tune_track_high 70, 1
  tune_track_high 71, 1
  tune_track_high 72, 1
  tune_track_high 73, 1
  tune_track_high 74, 1
  tune_track_high 75, 1
  tune_track_high 76, 1
  tune_track_high 77, 1
  tune_track_high 78, 1
  tune_track_high 79, 1
  tune_track_high 80, 1
  tune_track_high 81, 1
  tune_track_high 82, 1
  tune_track_high 83, 1
  tune_track_high 84, 1
  tune_track_high 85, 1
  tune_track_high 86, 1
  tune_track_high 87, 1
  tune_track_high 88, 1
  tune_track_high 89, 1
  tune_track_high 90, 1
  tune_track_high 91, 1
  tune_track_high 92, 1
  tune_track_high 93, 1
  tune_track_high 94, 1
  tune_track_high 95, 1
  tune_track_high 96, 1
  tune_track_high 97, 1
  tune_track_high 98, 1
  tune_track_high 99, 1
  tune_track_high 100, 1
  tune_track_high 101, 1
  tune_track_high 102, 1
  tune_track_high 103, 1
  tune_track_high 104, 1
  tune_track_high 105, 1
  tune_track_high 106, 1
  tune_track_high 107, 1
  tune_track_high 108, 1
  tune_track_high 109, 1
  tune_track_high 110, 1
  tune_track_high 111, 1
  tune_track_high 112, 1
  tune_track_high 113, 1
  tune_track_high 114, 1
  tune_track_high 115, 1
  tune_track_high 116, 1
  tune_track_high 117, 1
  tune_track_high 118, 1
  tune_track_high 119, 1
  tune_track_high 120, 1
  tune_track_high 121, 1
  tune_track_high 122, 1
  tune_track_high 123, 1
  tune_track_high 124, 1
  tune_track_high 125, 1
  tune_track_high 126, 1
  tune_track_high 127, 1
  tune_track_high 128, 1
  tune_track_high 129, 1
  tune_track_high 130, 1
  tune_track_high 131, 1
  tune_track_high 132, 1
  tune_track_high 133, 1
  tune_track_high 134, 1
  tune_track_high 135, 1
  tune_track_high 136, 1
  tune_track_high 137, 1
  tune_track_high 138, 1
  tune_track_high 139, 1
  tune_track_high 140, 1
  tune_track_high 141, 1
  tune_track_high 142, 1
  tune_track_high 143, 1
  tune_track_high 144, 1
  tune_track_high 145, 1
  tune_track_high 146, 1
  tune_track_high 147, 1
  tune_track_high 148, 1
  tune_track_high 149, 1
  tune_track_high 150, 1
  tune_track_high 151, 1
  tune_track_high 152, 1
  tune_track_high 153, 1
  tune_track_high 154, 1
  tune_track_high 155, 1
  tune_track_high 156, 1
  tune_track_high 157, 1
  tune_track_high 158, 1
  tune_track_high 159, 1
  tune_track_high 160, 1
  tune_track_high 161, 1
  tune_track_high 162, 1
  tune_track_high 163, 1
  tune_track_high 164, 1
  tune_track_high 165, 1
  tune_track_high 166, 1
  tune_track_high 167, 1
  tune_track_high 168, 1
  tune_track_high 169, 1
  tune_track_high 170, 1
  tune_track_high 171, 1
  tune_track_high 172, 1
  tune_track_high 173, 1
  tune_track_high 174, 1
  tune_track_high 175, 1
  tune_track_high 176, 1
  tune_track_high 177, 1
  tune_track_high 178, 1
  tune_track_high 179, 1
  tune_track_high 180, 1
  tune_track_high 181, 1
  tune_track_high 182, 1
  tune_track_high 183, 1
  tune_track_high 184, 1
  tune_track_high 185, 1
  tune_track_high 186, 1
  tune_track_high 187, 1
  tune_track_high 188, 1
  tune_track_high 189, 1
  tune_track_high 190, 1
  tune_track_high 191, 1
  tune_track_high 192, 1
  tune_track_high 193, 1
  tune_track_high 194, 1
  tune_track_high 195, 1
  tune_track_high 196, 1
  tune_track_high 197, 1
  tune_track_high 198, 1
  tune_track_high 199, 1
  tune_track_high 200, 1
  tune_track_high 201, 1
  tune_track_high 202, 1
  tune_track_high 203, 1
  tune_track_high 204, 1
  tune_track_high 205, 1
  tune_track_high 206, 1
  tune_track_high 207, 1
  tune_track_high 208, 1
  tune_track_high 209, 1
  tune_track_high 210, 1
  tune_track_high 211, 1
  tune_track_high 212, 1
  tune_track_high 213, 1
  tune_track_high 214, 1
  tune_track_high 215, 1
  tune_track_high 216, 1
  tune_track_high 217, 1
  tune_track_high 218, 1
  tune_track_high 219, 1
  tune_track_high 220, 1
  tune_track_high 221, 1
  tune_track_high 222, 1
  tune_track_high 223, 1
  tune_track_high 224, 1
  tune_track_high 225, 1
  tune_track_high 226, 1
  tune_track_high 227, 1
  tune_track_high 228, 1
  tune_track_high 229, 1
  tune_track_high 230, 1
  tune_track_high 231, 1
  tune_track_high 232, 1
  tune_track_high 233, 1
  tune_track_high 234, 1
  tune_track_high 235, 1
  tune_track_high 236, 1
  tune_track_high 237, 1
  tune_track_high 238, 1
  tune_track_high 239, 1
  tune_track_high 240, 1
  tune_track_high 241, 1
  tune_track_high 242, 1
  tune_track_high 243, 1
  tune_track_high 244, 1
  tune_track_high 245, 1
  tune_track_high 246, 1
  tune_track_high 247, 1
  tune_track_high 248, 1
  tune_track_high 249, 1
  tune_track_high 250, 1
  tune_track_high 251, 1
  tune_track_high 252, 1
  tune_track_high 253, 1
  tune_track_high 254, 1
  tune_track_high 255, 1
  tune_track_high 256, 1

; low pointer for track 2 of tunes
tuneTrack2_L:
  tune_track_low 1, 2
  tune_track_low 2, 2
  tune_track_low 3, 2
  tune_track_low 4, 2
  tune_track_low 5, 2
  tune_track_low 6, 2
  tune_track_low 7, 2
  tune_track_low 8, 2
  tune_track_low 9, 2
  tune_track_low 10, 2
  tune_track_low 11, 2
  tune_track_low 12, 2
  tune_track_low 13, 2
  tune_track_low 14, 2
  tune_track_low 15, 2
  tune_track_low 16, 2
  tune_track_low 17, 2
  tune_track_low 18, 2
  tune_track_low 19, 2
  tune_track_low 20, 2
  tune_track_low 21, 2
  tune_track_low 22, 2
  tune_track_low 23, 2
  tune_track_low 24, 2
  tune_track_low 25, 2
  tune_track_low 26, 2
  tune_track_low 27, 2
  tune_track_low 28, 2
  tune_track_low 29, 2
  tune_track_low 30, 2
  tune_track_low 31, 2
  tune_track_low 32, 2
  tune_track_low 33, 2
  tune_track_low 34, 2
  tune_track_low 35, 2
  tune_track_low 36, 2
  tune_track_low 37, 2
  tune_track_low 38, 2
  tune_track_low 39, 2
  tune_track_low 40, 2
  tune_track_low 41, 2
  tune_track_low 42, 2
  tune_track_low 43, 2
  tune_track_low 44, 2
  tune_track_low 45, 2
  tune_track_low 46, 2
  tune_track_low 47, 2
  tune_track_low 48, 2
  tune_track_low 49, 2
  tune_track_low 50, 2
  tune_track_low 51, 2
  tune_track_low 52, 2
  tune_track_low 53, 2
  tune_track_low 54, 2
  tune_track_low 55, 2
  tune_track_low 56, 2
  tune_track_low 57, 2
  tune_track_low 58, 2
  tune_track_low 59, 2
  tune_track_low 60, 2
  tune_track_low 61, 2
  tune_track_low 62, 2
  tune_track_low 63, 2
  tune_track_low 64, 2
  tune_track_low 65, 2
  tune_track_low 66, 2
  tune_track_low 67, 2
  tune_track_low 68, 2
  tune_track_low 69, 2
  tune_track_low 70, 2
  tune_track_low 71, 2
  tune_track_low 72, 2
  tune_track_low 73, 2
  tune_track_low 74, 2
  tune_track_low 75, 2
  tune_track_low 76, 2
  tune_track_low 77, 2
  tune_track_low 78, 2
  tune_track_low 79, 2
  tune_track_low 80, 2
  tune_track_low 81, 2
  tune_track_low 82, 2
  tune_track_low 83, 2
  tune_track_low 84, 2
  tune_track_low 85, 2
  tune_track_low 86, 2
  tune_track_low 87, 2
  tune_track_low 88, 2
  tune_track_low 89, 2
  tune_track_low 90, 2
  tune_track_low 91, 2
  tune_track_low 92, 2
  tune_track_low 93, 2
  tune_track_low 94, 2
  tune_track_low 95, 2
  tune_track_low 96, 2
  tune_track_low 97, 2
  tune_track_low 98, 2
  tune_track_low 99, 2
  tune_track_low 100, 2
  tune_track_low 101, 2
  tune_track_low 102, 2
  tune_track_low 103, 2
  tune_track_low 104, 2
  tune_track_low 105, 2
  tune_track_low 106, 2
  tune_track_low 107, 2
  tune_track_low 108, 2
  tune_track_low 109, 2
  tune_track_low 110, 2
  tune_track_low 111, 2
  tune_track_low 112, 2
  tune_track_low 113, 2
  tune_track_low 114, 2
  tune_track_low 115, 2
  tune_track_low 116, 2
  tune_track_low 117, 2
  tune_track_low 118, 2
  tune_track_low 119, 2
  tune_track_low 120, 2
  tune_track_low 121, 2
  tune_track_low 122, 2
  tune_track_low 123, 2
  tune_track_low 124, 2
  tune_track_low 125, 2
  tune_track_low 126, 2
  tune_track_low 127, 2
  tune_track_low 128, 2
  tune_track_low 129, 2
  tune_track_low 130, 2
  tune_track_low 131, 2
  tune_track_low 132, 2
  tune_track_low 133, 2
  tune_track_low 134, 2
  tune_track_low 135, 2
  tune_track_low 136, 2
  tune_track_low 137, 2
  tune_track_low 138, 2
  tune_track_low 139, 2
  tune_track_low 140, 2
  tune_track_low 141, 2
  tune_track_low 142, 2
  tune_track_low 143, 2
  tune_track_low 144, 2
  tune_track_low 145, 2
  tune_track_low 146, 2
  tune_track_low 147, 2
  tune_track_low 148, 2
  tune_track_low 149, 2
  tune_track_low 150, 2
  tune_track_low 151, 2
  tune_track_low 152, 2
  tune_track_low 153, 2
  tune_track_low 154, 2
  tune_track_low 155, 2
  tune_track_low 156, 2
  tune_track_low 157, 2
  tune_track_low 158, 2
  tune_track_low 159, 2
  tune_track_low 160, 2
  tune_track_low 161, 2
  tune_track_low 162, 2
  tune_track_low 163, 2
  tune_track_low 164, 2
  tune_track_low 165, 2
  tune_track_low 166, 2
  tune_track_low 167, 2
  tune_track_low 168, 2
  tune_track_low 169, 2
  tune_track_low 170, 2
  tune_track_low 171, 2
  tune_track_low 172, 2
  tune_track_low 173, 2
  tune_track_low 174, 2
  tune_track_low 175, 2
  tune_track_low 176, 2
  tune_track_low 177, 2
  tune_track_low 178, 2
  tune_track_low 179, 2
  tune_track_low 180, 2
  tune_track_low 181, 2
  tune_track_low 182, 2
  tune_track_low 183, 2
  tune_track_low 184, 2
  tune_track_low 185, 2
  tune_track_low 186, 2
  tune_track_low 187, 2
  tune_track_low 188, 2
  tune_track_low 189, 2
  tune_track_low 190, 2
  tune_track_low 191, 2
  tune_track_low 192, 2
  tune_track_low 193, 2
  tune_track_low 194, 2
  tune_track_low 195, 2
  tune_track_low 196, 2
  tune_track_low 197, 2
  tune_track_low 198, 2
  tune_track_low 199, 2
  tune_track_low 200, 2
  tune_track_low 201, 2
  tune_track_low 202, 2
  tune_track_low 203, 2
  tune_track_low 204, 2
  tune_track_low 205, 2
  tune_track_low 206, 2
  tune_track_low 207, 2
  tune_track_low 208, 2
  tune_track_low 209, 2
  tune_track_low 210, 2
  tune_track_low 211, 2
  tune_track_low 212, 2
  tune_track_low 213, 2
  tune_track_low 214, 2
  tune_track_low 215, 2
  tune_track_low 216, 2
  tune_track_low 217, 2
  tune_track_low 218, 2
  tune_track_low 219, 2
  tune_track_low 220, 2
  tune_track_low 221, 2
  tune_track_low 222, 2
  tune_track_low 223, 2
  tune_track_low 224, 2
  tune_track_low 225, 2
  tune_track_low 226, 2
  tune_track_low 227, 2
  tune_track_low 228, 2
  tune_track_low 229, 2
  tune_track_low 230, 2
  tune_track_low 231, 2
  tune_track_low 232, 2
  tune_track_low 233, 2
  tune_track_low 234, 2
  tune_track_low 235, 2
  tune_track_low 236, 2
  tune_track_low 237, 2
  tune_track_low 238, 2
  tune_track_low 239, 2
  tune_track_low 240, 2
  tune_track_low 241, 2
  tune_track_low 242, 2
  tune_track_low 243, 2
  tune_track_low 244, 2
  tune_track_low 245, 2
  tune_track_low 246, 2
  tune_track_low 247, 2
  tune_track_low 248, 2
  tune_track_low 249, 2
  tune_track_low 250, 2
  tune_track_low 251, 2
  tune_track_low 252, 2
  tune_track_low 253, 2
  tune_track_low 254, 2
  tune_track_low 255, 2
  tune_track_low 256, 2

; high pointer for track 2 of tunes
tuneTrack2_H:
  tune_track_high 1, 2
  tune_track_high 2, 2
  tune_track_high 3, 2
  tune_track_high 4, 2
  tune_track_high 5, 2
  tune_track_high 6, 2
  tune_track_high 7, 2
  tune_track_high 8, 2
  tune_track_high 9, 2
  tune_track_high 10, 2
  tune_track_high 11, 2
  tune_track_high 12, 2
  tune_track_high 13, 2
  tune_track_high 14, 2
  tune_track_high 15, 2
  tune_track_high 16, 2
  tune_track_high 17, 2
  tune_track_high 18, 2
  tune_track_high 19, 2
  tune_track_high 20, 2
  tune_track_high 21, 2
  tune_track_high 22, 2
  tune_track_high 23, 2
  tune_track_high 24, 2
  tune_track_high 25, 2
  tune_track_high 26, 2
  tune_track_high 27, 2
  tune_track_high 28, 2
  tune_track_high 29, 2
  tune_track_high 30, 2
  tune_track_high 31, 2
  tune_track_high 32, 2
  tune_track_high 33, 2
  tune_track_high 34, 2
  tune_track_high 35, 2
  tune_track_high 36, 2
  tune_track_high 37, 2
  tune_track_high 38, 2
  tune_track_high 39, 2
  tune_track_high 40, 2
  tune_track_high 41, 2
  tune_track_high 42, 2
  tune_track_high 43, 2
  tune_track_high 44, 2
  tune_track_high 45, 2
  tune_track_high 46, 2
  tune_track_high 47, 2
  tune_track_high 48, 2
  tune_track_high 49, 2
  tune_track_high 50, 2
  tune_track_high 51, 2
  tune_track_high 52, 2
  tune_track_high 53, 2
  tune_track_high 54, 2
  tune_track_high 55, 2
  tune_track_high 56, 2
  tune_track_high 57, 2
  tune_track_high 58, 2
  tune_track_high 59, 2
  tune_track_high 60, 2
  tune_track_high 61, 2
  tune_track_high 62, 2
  tune_track_high 63, 2
  tune_track_high 64, 2
  tune_track_high 65, 2
  tune_track_high 66, 2
  tune_track_high 67, 2
  tune_track_high 68, 2
  tune_track_high 69, 2
  tune_track_high 70, 2
  tune_track_high 71, 2
  tune_track_high 72, 2
  tune_track_high 73, 2
  tune_track_high 74, 2
  tune_track_high 75, 2
  tune_track_high 76, 2
  tune_track_high 77, 2
  tune_track_high 78, 2
  tune_track_high 79, 2
  tune_track_high 80, 2
  tune_track_high 81, 2
  tune_track_high 82, 2
  tune_track_high 83, 2
  tune_track_high 84, 2
  tune_track_high 85, 2
  tune_track_high 86, 2
  tune_track_high 87, 2
  tune_track_high 88, 2
  tune_track_high 89, 2
  tune_track_high 90, 2
  tune_track_high 91, 2
  tune_track_high 92, 2
  tune_track_high 93, 2
  tune_track_high 94, 2
  tune_track_high 95, 2
  tune_track_high 96, 2
  tune_track_high 97, 2
  tune_track_high 98, 2
  tune_track_high 99, 2
  tune_track_high 100, 2
  tune_track_high 101, 2
  tune_track_high 102, 2
  tune_track_high 103, 2
  tune_track_high 104, 2
  tune_track_high 105, 2
  tune_track_high 106, 2
  tune_track_high 107, 2
  tune_track_high 108, 2
  tune_track_high 109, 2
  tune_track_high 110, 2
  tune_track_high 111, 2
  tune_track_high 112, 2
  tune_track_high 113, 2
  tune_track_high 114, 2
  tune_track_high 115, 2
  tune_track_high 116, 2
  tune_track_high 117, 2
  tune_track_high 118, 2
  tune_track_high 119, 2
  tune_track_high 120, 2
  tune_track_high 121, 2
  tune_track_high 122, 2
  tune_track_high 123, 2
  tune_track_high 124, 2
  tune_track_high 125, 2
  tune_track_high 126, 2
  tune_track_high 127, 2
  tune_track_high 128, 2
  tune_track_high 129, 2
  tune_track_high 130, 2
  tune_track_high 131, 2
  tune_track_high 132, 2
  tune_track_high 133, 2
  tune_track_high 134, 2
  tune_track_high 135, 2
  tune_track_high 136, 2
  tune_track_high 137, 2
  tune_track_high 138, 2
  tune_track_high 139, 2
  tune_track_high 140, 2
  tune_track_high 141, 2
  tune_track_high 142, 2
  tune_track_high 143, 2
  tune_track_high 144, 2
  tune_track_high 145, 2
  tune_track_high 146, 2
  tune_track_high 147, 2
  tune_track_high 148, 2
  tune_track_high 149, 2
  tune_track_high 150, 2
  tune_track_high 151, 2
  tune_track_high 152, 2
  tune_track_high 153, 2
  tune_track_high 154, 2
  tune_track_high 155, 2
  tune_track_high 156, 2
  tune_track_high 157, 2
  tune_track_high 158, 2
  tune_track_high 159, 2
  tune_track_high 160, 2
  tune_track_high 161, 2
  tune_track_high 162, 2
  tune_track_high 163, 2
  tune_track_high 164, 2
  tune_track_high 165, 2
  tune_track_high 166, 2
  tune_track_high 167, 2
  tune_track_high 168, 2
  tune_track_high 169, 2
  tune_track_high 170, 2
  tune_track_high 171, 2
  tune_track_high 172, 2
  tune_track_high 173, 2
  tune_track_high 174, 2
  tune_track_high 175, 2
  tune_track_high 176, 2
  tune_track_high 177, 2
  tune_track_high 178, 2
  tune_track_high 179, 2
  tune_track_high 180, 2
  tune_track_high 181, 2
  tune_track_high 182, 2
  tune_track_high 183, 2
  tune_track_high 184, 2
  tune_track_high 185, 2
  tune_track_high 186, 2
  tune_track_high 187, 2
  tune_track_high 188, 2
  tune_track_high 189, 2
  tune_track_high 190, 2
  tune_track_high 191, 2
  tune_track_high 192, 2
  tune_track_high 193, 2
  tune_track_high 194, 2
  tune_track_high 195, 2
  tune_track_high 196, 2
  tune_track_high 197, 2
  tune_track_high 198, 2
  tune_track_high 199, 2
  tune_track_high 200, 2
  tune_track_high 201, 2
  tune_track_high 202, 2
  tune_track_high 203, 2
  tune_track_high 204, 2
  tune_track_high 205, 2
  tune_track_high 206, 2
  tune_track_high 207, 2
  tune_track_high 208, 2
  tune_track_high 209, 2
  tune_track_high 210, 2
  tune_track_high 211, 2
  tune_track_high 212, 2
  tune_track_high 213, 2
  tune_track_high 214, 2
  tune_track_high 215, 2
  tune_track_high 216, 2
  tune_track_high 217, 2
  tune_track_high 218, 2
  tune_track_high 219, 2
  tune_track_high 220, 2
  tune_track_high 221, 2
  tune_track_high 222, 2
  tune_track_high 223, 2
  tune_track_high 224, 2
  tune_track_high 225, 2
  tune_track_high 226, 2
  tune_track_high 227, 2
  tune_track_high 228, 2
  tune_track_high 229, 2
  tune_track_high 230, 2
  tune_track_high 231, 2
  tune_track_high 232, 2
  tune_track_high 233, 2
  tune_track_high 234, 2
  tune_track_high 235, 2
  tune_track_high 236, 2
  tune_track_high 237, 2
  tune_track_high 238, 2
  tune_track_high 239, 2
  tune_track_high 240, 2
  tune_track_high 241, 2
  tune_track_high 242, 2
  tune_track_high 243, 2
  tune_track_high 244, 2
  tune_track_high 245, 2
  tune_track_high 246, 2
  tune_track_high 247, 2
  tune_track_high 248, 2
  tune_track_high 249, 2
  tune_track_high 250, 2
  tune_track_high 251, 2
  tune_track_high 252, 2
  tune_track_high 253, 2
  tune_track_high 254, 2
  tune_track_high 255, 2
  tune_track_high 256, 2

; low pointer for track 3 of tunes
tuneTrack3_L:
  tune_track_low 1, 3
  tune_track_low 2, 3
  tune_track_low 3, 3
  tune_track_low 4, 3
  tune_track_low 5, 3
  tune_track_low 6, 3
  tune_track_low 7, 3
  tune_track_low 8, 3
  tune_track_low 9, 3
  tune_track_low 10, 3
  tune_track_low 11, 3
  tune_track_low 12, 3
  tune_track_low 13, 3
  tune_track_low 14, 3
  tune_track_low 15, 3
  tune_track_low 16, 3
  tune_track_low 17, 3
  tune_track_low 18, 3
  tune_track_low 19, 3
  tune_track_low 20, 3
  tune_track_low 21, 3
  tune_track_low 22, 3
  tune_track_low 23, 3
  tune_track_low 24, 3
  tune_track_low 25, 3
  tune_track_low 26, 3
  tune_track_low 27, 3
  tune_track_low 28, 3
  tune_track_low 29, 3
  tune_track_low 30, 3
  tune_track_low 31, 3
  tune_track_low 32, 3
  tune_track_low 33, 3
  tune_track_low 34, 3
  tune_track_low 35, 3
  tune_track_low 36, 3
  tune_track_low 37, 3
  tune_track_low 38, 3
  tune_track_low 39, 3
  tune_track_low 40, 3
  tune_track_low 41, 3
  tune_track_low 42, 3
  tune_track_low 43, 3
  tune_track_low 44, 3
  tune_track_low 45, 3
  tune_track_low 46, 3
  tune_track_low 47, 3
  tune_track_low 48, 3
  tune_track_low 49, 3
  tune_track_low 50, 3
  tune_track_low 51, 3
  tune_track_low 52, 3
  tune_track_low 53, 3
  tune_track_low 54, 3
  tune_track_low 55, 3
  tune_track_low 56, 3
  tune_track_low 57, 3
  tune_track_low 58, 3
  tune_track_low 59, 3
  tune_track_low 60, 3
  tune_track_low 61, 3
  tune_track_low 62, 3
  tune_track_low 63, 3
  tune_track_low 64, 3
  tune_track_low 65, 3
  tune_track_low 66, 3
  tune_track_low 67, 3
  tune_track_low 68, 3
  tune_track_low 69, 3
  tune_track_low 70, 3
  tune_track_low 71, 3
  tune_track_low 72, 3
  tune_track_low 73, 3
  tune_track_low 74, 3
  tune_track_low 75, 3
  tune_track_low 76, 3
  tune_track_low 77, 3
  tune_track_low 78, 3
  tune_track_low 79, 3
  tune_track_low 80, 3
  tune_track_low 81, 3
  tune_track_low 82, 3
  tune_track_low 83, 3
  tune_track_low 84, 3
  tune_track_low 85, 3
  tune_track_low 86, 3
  tune_track_low 87, 3
  tune_track_low 88, 3
  tune_track_low 89, 3
  tune_track_low 90, 3
  tune_track_low 91, 3
  tune_track_low 92, 3
  tune_track_low 93, 3
  tune_track_low 94, 3
  tune_track_low 95, 3
  tune_track_low 96, 3
  tune_track_low 97, 3
  tune_track_low 98, 3
  tune_track_low 99, 3
  tune_track_low 100, 3
  tune_track_low 101, 3
  tune_track_low 102, 3
  tune_track_low 103, 3
  tune_track_low 104, 3
  tune_track_low 105, 3
  tune_track_low 106, 3
  tune_track_low 107, 3
  tune_track_low 108, 3
  tune_track_low 109, 3
  tune_track_low 110, 3
  tune_track_low 111, 3
  tune_track_low 112, 3
  tune_track_low 113, 3
  tune_track_low 114, 3
  tune_track_low 115, 3
  tune_track_low 116, 3
  tune_track_low 117, 3
  tune_track_low 118, 3
  tune_track_low 119, 3
  tune_track_low 120, 3
  tune_track_low 121, 3
  tune_track_low 122, 3
  tune_track_low 123, 3
  tune_track_low 124, 3
  tune_track_low 125, 3
  tune_track_low 126, 3
  tune_track_low 127, 3
  tune_track_low 128, 3
  tune_track_low 129, 3
  tune_track_low 130, 3
  tune_track_low 131, 3
  tune_track_low 132, 3
  tune_track_low 133, 3
  tune_track_low 134, 3
  tune_track_low 135, 3
  tune_track_low 136, 3
  tune_track_low 137, 3
  tune_track_low 138, 3
  tune_track_low 139, 3
  tune_track_low 140, 3
  tune_track_low 141, 3
  tune_track_low 142, 3
  tune_track_low 143, 3
  tune_track_low 144, 3
  tune_track_low 145, 3
  tune_track_low 146, 3
  tune_track_low 147, 3
  tune_track_low 148, 3
  tune_track_low 149, 3
  tune_track_low 150, 3
  tune_track_low 151, 3
  tune_track_low 152, 3
  tune_track_low 153, 3
  tune_track_low 154, 3
  tune_track_low 155, 3
  tune_track_low 156, 3
  tune_track_low 157, 3
  tune_track_low 158, 3
  tune_track_low 159, 3
  tune_track_low 160, 3
  tune_track_low 161, 3
  tune_track_low 162, 3
  tune_track_low 163, 3
  tune_track_low 164, 3
  tune_track_low 165, 3
  tune_track_low 166, 3
  tune_track_low 167, 3
  tune_track_low 168, 3
  tune_track_low 169, 3
  tune_track_low 170, 3
  tune_track_low 171, 3
  tune_track_low 172, 3
  tune_track_low 173, 3
  tune_track_low 174, 3
  tune_track_low 175, 3
  tune_track_low 176, 3
  tune_track_low 177, 3
  tune_track_low 178, 3
  tune_track_low 179, 3
  tune_track_low 180, 3
  tune_track_low 181, 3
  tune_track_low 182, 3
  tune_track_low 183, 3
  tune_track_low 184, 3
  tune_track_low 185, 3
  tune_track_low 186, 3
  tune_track_low 187, 3
  tune_track_low 188, 3
  tune_track_low 189, 3
  tune_track_low 190, 3
  tune_track_low 191, 3
  tune_track_low 192, 3
  tune_track_low 193, 3
  tune_track_low 194, 3
  tune_track_low 195, 3
  tune_track_low 196, 3
  tune_track_low 197, 3
  tune_track_low 198, 3
  tune_track_low 199, 3
  tune_track_low 200, 3
  tune_track_low 201, 3
  tune_track_low 202, 3
  tune_track_low 203, 3
  tune_track_low 204, 3
  tune_track_low 205, 3
  tune_track_low 206, 3
  tune_track_low 207, 3
  tune_track_low 208, 3
  tune_track_low 209, 3
  tune_track_low 210, 3
  tune_track_low 211, 3
  tune_track_low 212, 3
  tune_track_low 213, 3
  tune_track_low 214, 3
  tune_track_low 215, 3
  tune_track_low 216, 3
  tune_track_low 217, 3
  tune_track_low 218, 3
  tune_track_low 219, 3
  tune_track_low 220, 3
  tune_track_low 221, 3
  tune_track_low 222, 3
  tune_track_low 223, 3
  tune_track_low 224, 3
  tune_track_low 225, 3
  tune_track_low 226, 3
  tune_track_low 227, 3
  tune_track_low 228, 3
  tune_track_low 229, 3
  tune_track_low 230, 3
  tune_track_low 231, 3
  tune_track_low 232, 3
  tune_track_low 233, 3
  tune_track_low 234, 3
  tune_track_low 235, 3
  tune_track_low 236, 3
  tune_track_low 237, 3
  tune_track_low 238, 3
  tune_track_low 239, 3
  tune_track_low 240, 3
  tune_track_low 241, 3
  tune_track_low 242, 3
  tune_track_low 243, 3
  tune_track_low 244, 3
  tune_track_low 245, 3
  tune_track_low 246, 3
  tune_track_low 247, 3
  tune_track_low 248, 3
  tune_track_low 249, 3
  tune_track_low 250, 3
  tune_track_low 251, 3
  tune_track_low 252, 3
  tune_track_low 253, 3
  tune_track_low 254, 3
  tune_track_low 255, 3
  tune_track_low 256, 3

; high pointer for track 3 of tunes
tuneTrack3_H:
  tune_track_high 1, 3
  tune_track_high 2, 3
  tune_track_high 3, 3
  tune_track_high 4, 3
  tune_track_high 5, 3
  tune_track_high 6, 3
  tune_track_high 7, 3
  tune_track_high 8, 3
  tune_track_high 9, 3
  tune_track_high 10, 3
  tune_track_high 11, 3
  tune_track_high 12, 3
  tune_track_high 13, 3
  tune_track_high 14, 3
  tune_track_high 15, 3
  tune_track_high 16, 3
  tune_track_high 17, 3
  tune_track_high 18, 3
  tune_track_high 19, 3
  tune_track_high 20, 3
  tune_track_high 21, 3
  tune_track_high 22, 3
  tune_track_high 23, 3
  tune_track_high 24, 3
  tune_track_high 25, 3
  tune_track_high 26, 3
  tune_track_high 27, 3
  tune_track_high 28, 3
  tune_track_high 29, 3
  tune_track_high 30, 3
  tune_track_high 31, 3
  tune_track_high 32, 3
  tune_track_high 33, 3
  tune_track_high 34, 3
  tune_track_high 35, 3
  tune_track_high 36, 3
  tune_track_high 37, 3
  tune_track_high 38, 3
  tune_track_high 39, 3
  tune_track_high 40, 3
  tune_track_high 41, 3
  tune_track_high 42, 3
  tune_track_high 43, 3
  tune_track_high 44, 3
  tune_track_high 45, 3
  tune_track_high 46, 3
  tune_track_high 47, 3
  tune_track_high 48, 3
  tune_track_high 49, 3
  tune_track_high 50, 3
  tune_track_high 51, 3
  tune_track_high 52, 3
  tune_track_high 53, 3
  tune_track_high 54, 3
  tune_track_high 55, 3
  tune_track_high 56, 3
  tune_track_high 57, 3
  tune_track_high 58, 3
  tune_track_high 59, 3
  tune_track_high 60, 3
  tune_track_high 61, 3
  tune_track_high 62, 3
  tune_track_high 63, 3
  tune_track_high 64, 3
  tune_track_high 65, 3
  tune_track_high 66, 3
  tune_track_high 67, 3
  tune_track_high 68, 3
  tune_track_high 69, 3
  tune_track_high 70, 3
  tune_track_high 71, 3
  tune_track_high 72, 3
  tune_track_high 73, 3
  tune_track_high 74, 3
  tune_track_high 75, 3
  tune_track_high 76, 3
  tune_track_high 77, 3
  tune_track_high 78, 3
  tune_track_high 79, 3
  tune_track_high 80, 3
  tune_track_high 81, 3
  tune_track_high 82, 3
  tune_track_high 83, 3
  tune_track_high 84, 3
  tune_track_high 85, 3
  tune_track_high 86, 3
  tune_track_high 87, 3
  tune_track_high 88, 3
  tune_track_high 89, 3
  tune_track_high 90, 3
  tune_track_high 91, 3
  tune_track_high 92, 3
  tune_track_high 93, 3
  tune_track_high 94, 3
  tune_track_high 95, 3
  tune_track_high 96, 3
  tune_track_high 97, 3
  tune_track_high 98, 3
  tune_track_high 99, 3
  tune_track_high 100, 3
  tune_track_high 101, 3
  tune_track_high 102, 3
  tune_track_high 103, 3
  tune_track_high 104, 3
  tune_track_high 105, 3
  tune_track_high 106, 3
  tune_track_high 107, 3
  tune_track_high 108, 3
  tune_track_high 109, 3
  tune_track_high 110, 3
  tune_track_high 111, 3
  tune_track_high 112, 3
  tune_track_high 113, 3
  tune_track_high 114, 3
  tune_track_high 115, 3
  tune_track_high 116, 3
  tune_track_high 117, 3
  tune_track_high 118, 3
  tune_track_high 119, 3
  tune_track_high 120, 3
  tune_track_high 121, 3
  tune_track_high 122, 3
  tune_track_high 123, 3
  tune_track_high 124, 3
  tune_track_high 125, 3
  tune_track_high 126, 3
  tune_track_high 127, 3
  tune_track_high 128, 3
  tune_track_high 129, 3
  tune_track_high 130, 3
  tune_track_high 131, 3
  tune_track_high 132, 3
  tune_track_high 133, 3
  tune_track_high 134, 3
  tune_track_high 135, 3
  tune_track_high 136, 3
  tune_track_high 137, 3
  tune_track_high 138, 3
  tune_track_high 139, 3
  tune_track_high 140, 3
  tune_track_high 141, 3
  tune_track_high 142, 3
  tune_track_high 143, 3
  tune_track_high 144, 3
  tune_track_high 145, 3
  tune_track_high 146, 3
  tune_track_high 147, 3
  tune_track_high 148, 3
  tune_track_high 149, 3
  tune_track_high 150, 3
  tune_track_high 151, 3
  tune_track_high 152, 3
  tune_track_high 153, 3
  tune_track_high 154, 3
  tune_track_high 155, 3
  tune_track_high 156, 3
  tune_track_high 157, 3
  tune_track_high 158, 3
  tune_track_high 159, 3
  tune_track_high 160, 3
  tune_track_high 161, 3
  tune_track_high 162, 3
  tune_track_high 163, 3
  tune_track_high 164, 3
  tune_track_high 165, 3
  tune_track_high 166, 3
  tune_track_high 167, 3
  tune_track_high 168, 3
  tune_track_high 169, 3
  tune_track_high 170, 3
  tune_track_high 171, 3
  tune_track_high 172, 3
  tune_track_high 173, 3
  tune_track_high 174, 3
  tune_track_high 175, 3
  tune_track_high 176, 3
  tune_track_high 177, 3
  tune_track_high 178, 3
  tune_track_high 179, 3
  tune_track_high 180, 3
  tune_track_high 181, 3
  tune_track_high 182, 3
  tune_track_high 183, 3
  tune_track_high 184, 3
  tune_track_high 185, 3
  tune_track_high 186, 3
  tune_track_high 187, 3
  tune_track_high 188, 3
  tune_track_high 189, 3
  tune_track_high 190, 3
  tune_track_high 191, 3
  tune_track_high 192, 3
  tune_track_high 193, 3
  tune_track_high 194, 3
  tune_track_high 195, 3
  tune_track_high 196, 3
  tune_track_high 197, 3
  tune_track_high 198, 3
  tune_track_high 199, 3
  tune_track_high 200, 3
  tune_track_high 201, 3
  tune_track_high 202, 3
  tune_track_high 203, 3
  tune_track_high 204, 3
  tune_track_high 205, 3
  tune_track_high 206, 3
  tune_track_high 207, 3
  tune_track_high 208, 3
  tune_track_high 209, 3
  tune_track_high 210, 3
  tune_track_high 211, 3
  tune_track_high 212, 3
  tune_track_high 213, 3
  tune_track_high 214, 3
  tune_track_high 215, 3
  tune_track_high 216, 3
  tune_track_high 217, 3
  tune_track_high 218, 3
  tune_track_high 219, 3
  tune_track_high 220, 3
  tune_track_high 221, 3
  tune_track_high 222, 3
  tune_track_high 223, 3
  tune_track_high 224, 3
  tune_track_high 225, 3
  tune_track_high 226, 3
  tune_track_high 227, 3
  tune_track_high 228, 3
  tune_track_high 229, 3
  tune_track_high 230, 3
  tune_track_high 231, 3
  tune_track_high 232, 3
  tune_track_high 233, 3
  tune_track_high 234, 3
  tune_track_high 235, 3
  tune_track_high 236, 3
  tune_track_high 237, 3
  tune_track_high 238, 3
  tune_track_high 239, 3
  tune_track_high 240, 3
  tune_track_high 241, 3
  tune_track_high 242, 3
  tune_track_high 243, 3
  tune_track_high 244, 3
  tune_track_high 245, 3
  tune_track_high 246, 3
  tune_track_high 247, 3
  tune_track_high 248, 3
  tune_track_high 249, 3
  tune_track_high 250, 3
  tune_track_high 251, 3
  tune_track_high 252, 3
  tune_track_high 253, 3
  tune_track_high 254, 3
  tune_track_high 255, 3
  tune_track_high 256, 3

; tables for patterns

 .mac pat_b_low
 .if (NUM_PAT>= ({1}))
   .byte <pat{1}_b{2}
 .endif
 .endm

 .mac pat_b_high
 .if (NUM_PAT>= ({1}))
   .byte >pat{1}_b{2}
 .endif
 .endm

; byte 1 of pattern low address 
pat_b1_low:

  pat_b_low 0, 1
  pat_b_low 1, 1
  pat_b_low 2, 1
  pat_b_low 3, 1
  pat_b_low 4, 1
  pat_b_low 5, 1
  pat_b_low 6, 1
  pat_b_low 7, 1
  pat_b_low 8, 1
  pat_b_low 9, 1
  pat_b_low 10, 1
  pat_b_low 11, 1
  pat_b_low 12, 1
  pat_b_low 13, 1
  pat_b_low 14, 1
  pat_b_low 15, 1
  pat_b_low 16, 1
  pat_b_low 17, 1
  pat_b_low 18, 1
  pat_b_low 19, 1
  pat_b_low 20, 1
  pat_b_low 21, 1
  pat_b_low 22, 1
  pat_b_low 23, 1
  pat_b_low 24, 1
  pat_b_low 25, 1
  pat_b_low 26, 1
  pat_b_low 27, 1
  pat_b_low 28, 1
  pat_b_low 29, 1
  pat_b_low 30, 1
  pat_b_low 31, 1
  pat_b_low 32, 1
  pat_b_low 33, 1
  pat_b_low 34, 1
  pat_b_low 35, 1
  pat_b_low 36, 1
  pat_b_low 37, 1
  pat_b_low 38, 1
  pat_b_low 39, 1
  pat_b_low 40, 1
  pat_b_low 41, 1
  pat_b_low 42, 1
  pat_b_low 43, 1
  pat_b_low 44, 1
  pat_b_low 45, 1
  pat_b_low 46, 1
  pat_b_low 47, 1
  pat_b_low 48, 1
  pat_b_low 49, 1
  pat_b_low 50, 1
  pat_b_low 51, 1
  pat_b_low 52, 1
  pat_b_low 53, 1
  pat_b_low 54, 1
  pat_b_low 55, 1
  pat_b_low 56, 1
  pat_b_low 57, 1
  pat_b_low 58, 1
  pat_b_low 59, 1
  pat_b_low 60, 1
  pat_b_low 61, 1
  pat_b_low 62, 1
  pat_b_low 63, 1
  pat_b_low 64, 1
  pat_b_low 65, 1
  pat_b_low 66, 1
  pat_b_low 67, 1
  pat_b_low 68, 1
  pat_b_low 69, 1
  pat_b_low 70, 1
  pat_b_low 71, 1
  pat_b_low 72, 1
  pat_b_low 73, 1
  pat_b_low 74, 1
  pat_b_low 75, 1
  pat_b_low 76, 1
  pat_b_low 77, 1
  pat_b_low 78, 1
  pat_b_low 79, 1
  pat_b_low 80, 1
  pat_b_low 81, 1
  pat_b_low 82, 1
  pat_b_low 83, 1
  pat_b_low 84, 1
  pat_b_low 85, 1
  pat_b_low 86, 1
  pat_b_low 87, 1
  pat_b_low 88, 1
  pat_b_low 89, 1
  pat_b_low 90, 1
  pat_b_low 91, 1
  pat_b_low 92, 1
  pat_b_low 93, 1
  pat_b_low 94, 1
  pat_b_low 95, 1
  pat_b_low 96, 1
  pat_b_low 97, 1
  pat_b_low 98, 1
  pat_b_low 99, 1
  pat_b_low 100, 1
  pat_b_low 101, 1
  pat_b_low 102, 1
  pat_b_low 103, 1
  pat_b_low 104, 1
  pat_b_low 105, 1
  pat_b_low 106, 1
  pat_b_low 107, 1
  pat_b_low 108, 1
  pat_b_low 109, 1
  pat_b_low 110, 1
  pat_b_low 111, 1
  pat_b_low 112, 1
  pat_b_low 113, 1
  pat_b_low 114, 1
  pat_b_low 115, 1
  pat_b_low 116, 1
  pat_b_low 117, 1
  pat_b_low 118, 1
  pat_b_low 119, 1
  pat_b_low 120, 1
  pat_b_low 121, 1
  pat_b_low 122, 1
  pat_b_low 123, 1
  pat_b_low 124, 1
  pat_b_low 125, 1
  pat_b_low 126, 1
  pat_b_low 127, 1
  pat_b_low 128, 1
  pat_b_low 129, 1
  pat_b_low 130, 1
  pat_b_low 131, 1
  pat_b_low 132, 1
  pat_b_low 133, 1
  pat_b_low 134, 1
  pat_b_low 135, 1
  pat_b_low 136, 1
  pat_b_low 137, 1
  pat_b_low 138, 1
  pat_b_low 139, 1
  pat_b_low 140, 1
  pat_b_low 141, 1
  pat_b_low 142, 1
  pat_b_low 143, 1
  pat_b_low 144, 1
  pat_b_low 145, 1
  pat_b_low 146, 1
  pat_b_low 147, 1
  pat_b_low 148, 1
  pat_b_low 149, 1
  pat_b_low 150, 1
  pat_b_low 151, 1
  pat_b_low 152, 1
  pat_b_low 153, 1
  pat_b_low 154, 1
  pat_b_low 155, 1
  pat_b_low 156, 1
  pat_b_low 157, 1
  pat_b_low 158, 1
  pat_b_low 159, 1
  pat_b_low 160, 1
  pat_b_low 161, 1
  pat_b_low 162, 1
  pat_b_low 163, 1
  pat_b_low 164, 1
  pat_b_low 165, 1
  pat_b_low 166, 1
  pat_b_low 167, 1
  pat_b_low 168, 1
  pat_b_low 169, 1
  pat_b_low 170, 1
  pat_b_low 171, 1
  pat_b_low 172, 1
  pat_b_low 173, 1
  pat_b_low 174, 1
  pat_b_low 175, 1
  pat_b_low 176, 1
  pat_b_low 177, 1
  pat_b_low 178, 1
  pat_b_low 179, 1
  pat_b_low 180, 1
  pat_b_low 181, 1
  pat_b_low 182, 1
  pat_b_low 183, 1
  pat_b_low 184, 1
  pat_b_low 185, 1
  pat_b_low 186, 1
  pat_b_low 187, 1
  pat_b_low 188, 1
  pat_b_low 189, 1
  pat_b_low 190, 1
  pat_b_low 191, 1
  pat_b_low 192, 1
  pat_b_low 193, 1
  pat_b_low 194, 1
  pat_b_low 195, 1
  pat_b_low 196, 1
  pat_b_low 197, 1
  pat_b_low 198, 1
  pat_b_low 199, 1
  pat_b_low 200, 1
  pat_b_low 201, 1
  pat_b_low 202, 1
  pat_b_low 203, 1
  pat_b_low 204, 1
  pat_b_low 205, 1
  pat_b_low 206, 1
  pat_b_low 207, 1
  pat_b_low 208, 1
  pat_b_low 209, 1
  pat_b_low 210, 1
  pat_b_low 211, 1
  pat_b_low 212, 1
  pat_b_low 213, 1
  pat_b_low 214, 1
  pat_b_low 215, 1
  pat_b_low 216, 1
  pat_b_low 217, 1
  pat_b_low 218, 1
  pat_b_low 219, 1
  pat_b_low 220, 1
  pat_b_low 221, 1
  pat_b_low 222, 1

; byte 1 of pattern high address 
pat_b1_high:

  pat_b_high 0, 1
  pat_b_high 1, 1
  pat_b_high 2, 1
  pat_b_high 3, 1
  pat_b_high 4, 1
  pat_b_high 5, 1
  pat_b_high 6, 1
  pat_b_high 7, 1
  pat_b_high 8, 1
  pat_b_high 9, 1
  pat_b_high 10, 1
  pat_b_high 11, 1
  pat_b_high 12, 1
  pat_b_high 13, 1
  pat_b_high 14, 1
  pat_b_high 15, 1
  pat_b_high 16, 1
  pat_b_high 17, 1
  pat_b_high 18, 1
  pat_b_high 19, 1
  pat_b_high 20, 1
  pat_b_high 21, 1
  pat_b_high 22, 1
  pat_b_high 23, 1
  pat_b_high 24, 1
  pat_b_high 25, 1
  pat_b_high 26, 1
  pat_b_high 27, 1
  pat_b_high 28, 1
  pat_b_high 29, 1
  pat_b_high 30, 1
  pat_b_high 31, 1
  pat_b_high 32, 1
  pat_b_high 33, 1
  pat_b_high 34, 1
  pat_b_high 35, 1
  pat_b_high 36, 1
  pat_b_high 37, 1
  pat_b_high 38, 1
  pat_b_high 39, 1
  pat_b_high 40, 1
  pat_b_high 41, 1
  pat_b_high 42, 1
  pat_b_high 43, 1
  pat_b_high 44, 1
  pat_b_high 45, 1
  pat_b_high 46, 1
  pat_b_high 47, 1
  pat_b_high 48, 1
  pat_b_high 49, 1
  pat_b_high 50, 1
  pat_b_high 51, 1
  pat_b_high 52, 1
  pat_b_high 53, 1
  pat_b_high 54, 1
  pat_b_high 55, 1
  pat_b_high 56, 1
  pat_b_high 57, 1
  pat_b_high 58, 1
  pat_b_high 59, 1
  pat_b_high 60, 1
  pat_b_high 61, 1
  pat_b_high 62, 1
  pat_b_high 63, 1
  pat_b_high 64, 1
  pat_b_high 65, 1
  pat_b_high 66, 1
  pat_b_high 67, 1
  pat_b_high 68, 1
  pat_b_high 69, 1
  pat_b_high 70, 1
  pat_b_high 71, 1
  pat_b_high 72, 1
  pat_b_high 73, 1
  pat_b_high 74, 1
  pat_b_high 75, 1
  pat_b_high 76, 1
  pat_b_high 77, 1
  pat_b_high 78, 1
  pat_b_high 79, 1
  pat_b_high 80, 1
  pat_b_high 81, 1
  pat_b_high 82, 1
  pat_b_high 83, 1
  pat_b_high 84, 1
  pat_b_high 85, 1
  pat_b_high 86, 1
  pat_b_high 87, 1
  pat_b_high 88, 1
  pat_b_high 89, 1
  pat_b_high 90, 1
  pat_b_high 91, 1
  pat_b_high 92, 1
  pat_b_high 93, 1
  pat_b_high 94, 1
  pat_b_high 95, 1
  pat_b_high 96, 1
  pat_b_high 97, 1
  pat_b_high 98, 1
  pat_b_high 99, 1
  pat_b_high 100, 1
  pat_b_high 101, 1
  pat_b_high 102, 1
  pat_b_high 103, 1
  pat_b_high 104, 1
  pat_b_high 105, 1
  pat_b_high 106, 1
  pat_b_high 107, 1
  pat_b_high 108, 1
  pat_b_high 109, 1
  pat_b_high 110, 1
  pat_b_high 111, 1
  pat_b_high 112, 1
  pat_b_high 113, 1
  pat_b_high 114, 1
  pat_b_high 115, 1
  pat_b_high 116, 1
  pat_b_high 117, 1
  pat_b_high 118, 1
  pat_b_high 119, 1
  pat_b_high 120, 1
  pat_b_high 121, 1
  pat_b_high 122, 1
  pat_b_high 123, 1
  pat_b_high 124, 1
  pat_b_high 125, 1
  pat_b_high 126, 1
  pat_b_high 127, 1
  pat_b_high 128, 1
  pat_b_high 129, 1
  pat_b_high 130, 1
  pat_b_high 131, 1
  pat_b_high 132, 1
  pat_b_high 133, 1
  pat_b_high 134, 1
  pat_b_high 135, 1
  pat_b_high 136, 1
  pat_b_high 137, 1
  pat_b_high 138, 1
  pat_b_high 139, 1
  pat_b_high 140, 1
  pat_b_high 141, 1
  pat_b_high 142, 1
  pat_b_high 143, 1
  pat_b_high 144, 1
  pat_b_high 145, 1
  pat_b_high 146, 1
  pat_b_high 147, 1
  pat_b_high 148, 1
  pat_b_high 149, 1
  pat_b_high 150, 1
  pat_b_high 151, 1
  pat_b_high 152, 1
  pat_b_high 153, 1
  pat_b_high 154, 1
  pat_b_high 155, 1
  pat_b_high 156, 1
  pat_b_high 157, 1
  pat_b_high 158, 1
  pat_b_high 159, 1
  pat_b_high 160, 1
  pat_b_high 161, 1
  pat_b_high 162, 1
  pat_b_high 163, 1
  pat_b_high 164, 1
  pat_b_high 165, 1
  pat_b_high 166, 1
  pat_b_high 167, 1
  pat_b_high 168, 1
  pat_b_high 169, 1
  pat_b_high 170, 1
  pat_b_high 171, 1
  pat_b_high 172, 1
  pat_b_high 173, 1
  pat_b_high 174, 1
  pat_b_high 175, 1
  pat_b_high 176, 1
  pat_b_high 177, 1
  pat_b_high 178, 1
  pat_b_high 179, 1
  pat_b_high 180, 1
  pat_b_high 181, 1
  pat_b_high 182, 1
  pat_b_high 183, 1
  pat_b_high 184, 1
  pat_b_high 185, 1
  pat_b_high 186, 1
  pat_b_high 187, 1
  pat_b_high 188, 1
  pat_b_high 189, 1
  pat_b_high 190, 1
  pat_b_high 191, 1
  pat_b_high 192, 1
  pat_b_high 193, 1
  pat_b_high 194, 1
  pat_b_high 195, 1
  pat_b_high 196, 1
  pat_b_high 197, 1
  pat_b_high 198, 1
  pat_b_high 199, 1
  pat_b_high 200, 1
  pat_b_high 201, 1
  pat_b_high 202, 1
  pat_b_high 203, 1
  pat_b_high 204, 1
  pat_b_high 205, 1
  pat_b_high 206, 1
  pat_b_high 207, 1
  pat_b_high 208, 1
  pat_b_high 209, 1
  pat_b_high 210, 1
  pat_b_high 211, 1
  pat_b_high 212, 1
  pat_b_high 213, 1
  pat_b_high 214, 1
  pat_b_high 215, 1
  pat_b_high 216, 1
  pat_b_high 217, 1
  pat_b_high 218, 1
  pat_b_high 219, 1
  pat_b_high 220, 1
  pat_b_high 221, 1
  pat_b_high 222, 1

; byte 2 of pattern low address 
pat_b2_low:

  pat_b_low 0, 2
  pat_b_low 1, 2
  pat_b_low 2, 2
  pat_b_low 3, 2
  pat_b_low 4, 2
  pat_b_low 5, 2
  pat_b_low 6, 2
  pat_b_low 7, 2
  pat_b_low 8, 2
  pat_b_low 9, 2
  pat_b_low 10, 2
  pat_b_low 11, 2
  pat_b_low 12, 2
  pat_b_low 13, 2
  pat_b_low 14, 2
  pat_b_low 15, 2
  pat_b_low 16, 2
  pat_b_low 17, 2
  pat_b_low 18, 2
  pat_b_low 19, 2
  pat_b_low 20, 2
  pat_b_low 21, 2
  pat_b_low 22, 2
  pat_b_low 23, 2
  pat_b_low 24, 2
  pat_b_low 25, 2
  pat_b_low 26, 2
  pat_b_low 27, 2
  pat_b_low 28, 2
  pat_b_low 29, 2
  pat_b_low 30, 2
  pat_b_low 31, 2
  pat_b_low 32, 2
  pat_b_low 33, 2
  pat_b_low 34, 2
  pat_b_low 35, 2
  pat_b_low 36, 2
  pat_b_low 37, 2
  pat_b_low 38, 2
  pat_b_low 39, 2
  pat_b_low 40, 2
  pat_b_low 41, 2
  pat_b_low 42, 2
  pat_b_low 43, 2
  pat_b_low 44, 2
  pat_b_low 45, 2
  pat_b_low 46, 2
  pat_b_low 47, 2
  pat_b_low 48, 2
  pat_b_low 49, 2
  pat_b_low 50, 2
  pat_b_low 51, 2
  pat_b_low 52, 2
  pat_b_low 53, 2
  pat_b_low 54, 2
  pat_b_low 55, 2
  pat_b_low 56, 2
  pat_b_low 57, 2
  pat_b_low 58, 2
  pat_b_low 59, 2
  pat_b_low 60, 2
  pat_b_low 61, 2
  pat_b_low 62, 2
  pat_b_low 63, 2
  pat_b_low 64, 2
  pat_b_low 65, 2
  pat_b_low 66, 2
  pat_b_low 67, 2
  pat_b_low 68, 2
  pat_b_low 69, 2
  pat_b_low 70, 2
  pat_b_low 71, 2
  pat_b_low 72, 2
  pat_b_low 73, 2
  pat_b_low 74, 2
  pat_b_low 75, 2
  pat_b_low 76, 2
  pat_b_low 77, 2
  pat_b_low 78, 2
  pat_b_low 79, 2
  pat_b_low 80, 2
  pat_b_low 81, 2
  pat_b_low 82, 2
  pat_b_low 83, 2
  pat_b_low 84, 2
  pat_b_low 85, 2
  pat_b_low 86, 2
  pat_b_low 87, 2
  pat_b_low 88, 2
  pat_b_low 89, 2
  pat_b_low 90, 2
  pat_b_low 91, 2
  pat_b_low 92, 2
  pat_b_low 93, 2
  pat_b_low 94, 2
  pat_b_low 95, 2
  pat_b_low 96, 2
  pat_b_low 97, 2
  pat_b_low 98, 2
  pat_b_low 99, 2
  pat_b_low 100, 2
  pat_b_low 101, 2
  pat_b_low 102, 2
  pat_b_low 103, 2
  pat_b_low 104, 2
  pat_b_low 105, 2
  pat_b_low 106, 2
  pat_b_low 107, 2
  pat_b_low 108, 2
  pat_b_low 109, 2
  pat_b_low 110, 2
  pat_b_low 111, 2
  pat_b_low 112, 2
  pat_b_low 113, 2
  pat_b_low 114, 2
  pat_b_low 115, 2
  pat_b_low 116, 2
  pat_b_low 117, 2
  pat_b_low 118, 2
  pat_b_low 119, 2
  pat_b_low 120, 2
  pat_b_low 121, 2
  pat_b_low 122, 2
  pat_b_low 123, 2
  pat_b_low 124, 2
  pat_b_low 125, 2
  pat_b_low 126, 2
  pat_b_low 127, 2
  pat_b_low 128, 2
  pat_b_low 129, 2
  pat_b_low 130, 2
  pat_b_low 131, 2
  pat_b_low 132, 2
  pat_b_low 133, 2
  pat_b_low 134, 2
  pat_b_low 135, 2
  pat_b_low 136, 2
  pat_b_low 137, 2
  pat_b_low 138, 2
  pat_b_low 139, 2
  pat_b_low 140, 2
  pat_b_low 141, 2
  pat_b_low 142, 2
  pat_b_low 143, 2
  pat_b_low 144, 2
  pat_b_low 145, 2
  pat_b_low 146, 2
  pat_b_low 147, 2
  pat_b_low 148, 2
  pat_b_low 149, 2
  pat_b_low 150, 2
  pat_b_low 151, 2
  pat_b_low 152, 2
  pat_b_low 153, 2
  pat_b_low 154, 2
  pat_b_low 155, 2
  pat_b_low 156, 2
  pat_b_low 157, 2
  pat_b_low 158, 2
  pat_b_low 159, 2
  pat_b_low 160, 2
  pat_b_low 161, 2
  pat_b_low 162, 2
  pat_b_low 163, 2
  pat_b_low 164, 2
  pat_b_low 165, 2
  pat_b_low 166, 2
  pat_b_low 167, 2
  pat_b_low 168, 2
  pat_b_low 169, 2
  pat_b_low 170, 2
  pat_b_low 171, 2
  pat_b_low 172, 2
  pat_b_low 173, 2
  pat_b_low 174, 2
  pat_b_low 175, 2
  pat_b_low 176, 2
  pat_b_low 177, 2
  pat_b_low 178, 2
  pat_b_low 179, 2
  pat_b_low 180, 2
  pat_b_low 181, 2
  pat_b_low 182, 2
  pat_b_low 183, 2
  pat_b_low 184, 2
  pat_b_low 185, 2
  pat_b_low 186, 2
  pat_b_low 187, 2
  pat_b_low 188, 2
  pat_b_low 189, 2
  pat_b_low 190, 2
  pat_b_low 191, 2
  pat_b_low 192, 2
  pat_b_low 193, 2
  pat_b_low 194, 2
  pat_b_low 195, 2
  pat_b_low 196, 2
  pat_b_low 197, 2
  pat_b_low 198, 2
  pat_b_low 199, 2
  pat_b_low 200, 2
  pat_b_low 201, 2
  pat_b_low 202, 2
  pat_b_low 203, 2
  pat_b_low 204, 2
  pat_b_low 205, 2
  pat_b_low 206, 2
  pat_b_low 207, 2
  pat_b_low 208, 2
  pat_b_low 209, 2
  pat_b_low 210, 2
  pat_b_low 211, 2
  pat_b_low 212, 2
  pat_b_low 213, 2
  pat_b_low 214, 2
  pat_b_low 215, 2
  pat_b_low 216, 2
  pat_b_low 217, 2
  pat_b_low 218, 2
  pat_b_low 219, 2
  pat_b_low 220, 2
  pat_b_low 221, 2
  pat_b_low 222, 2

; byte 2 of pattern high address 
pat_b2_high:

  pat_b_high 0, 2
  pat_b_high 1, 2
  pat_b_high 2, 2
  pat_b_high 3, 2
  pat_b_high 4, 2
  pat_b_high 5, 2
  pat_b_high 6, 2
  pat_b_high 7, 2
  pat_b_high 8, 2
  pat_b_high 9, 2
  pat_b_high 10, 2
  pat_b_high 11, 2
  pat_b_high 12, 2
  pat_b_high 13, 2
  pat_b_high 14, 2
  pat_b_high 15, 2
  pat_b_high 16, 2
  pat_b_high 17, 2
  pat_b_high 18, 2
  pat_b_high 19, 2
  pat_b_high 20, 2
  pat_b_high 21, 2
  pat_b_high 22, 2
  pat_b_high 23, 2
  pat_b_high 24, 2
  pat_b_high 25, 2
  pat_b_high 26, 2
  pat_b_high 27, 2
  pat_b_high 28, 2
  pat_b_high 29, 2
  pat_b_high 30, 2
  pat_b_high 31, 2
  pat_b_high 32, 2
  pat_b_high 33, 2
  pat_b_high 34, 2
  pat_b_high 35, 2
  pat_b_high 36, 2
  pat_b_high 37, 2
  pat_b_high 38, 2
  pat_b_high 39, 2
  pat_b_high 40, 2
  pat_b_high 41, 2
  pat_b_high 42, 2
  pat_b_high 43, 2
  pat_b_high 44, 2
  pat_b_high 45, 2
  pat_b_high 46, 2
  pat_b_high 47, 2
  pat_b_high 48, 2
  pat_b_high 49, 2
  pat_b_high 50, 2
  pat_b_high 51, 2
  pat_b_high 52, 2
  pat_b_high 53, 2
  pat_b_high 54, 2
  pat_b_high 55, 2
  pat_b_high 56, 2
  pat_b_high 57, 2
  pat_b_high 58, 2
  pat_b_high 59, 2
  pat_b_high 60, 2
  pat_b_high 61, 2
  pat_b_high 62, 2
  pat_b_high 63, 2
  pat_b_high 64, 2
  pat_b_high 65, 2
  pat_b_high 66, 2
  pat_b_high 67, 2
  pat_b_high 68, 2
  pat_b_high 69, 2
  pat_b_high 70, 2
  pat_b_high 71, 2
  pat_b_high 72, 2
  pat_b_high 73, 2
  pat_b_high 74, 2
  pat_b_high 75, 2
  pat_b_high 76, 2
  pat_b_high 77, 2
  pat_b_high 78, 2
  pat_b_high 79, 2
  pat_b_high 80, 2
  pat_b_high 81, 2
  pat_b_high 82, 2
  pat_b_high 83, 2
  pat_b_high 84, 2
  pat_b_high 85, 2
  pat_b_high 86, 2
  pat_b_high 87, 2
  pat_b_high 88, 2
  pat_b_high 89, 2
  pat_b_high 90, 2
  pat_b_high 91, 2
  pat_b_high 92, 2
  pat_b_high 93, 2
  pat_b_high 94, 2
  pat_b_high 95, 2
  pat_b_high 96, 2
  pat_b_high 97, 2
  pat_b_high 98, 2
  pat_b_high 99, 2
  pat_b_high 100, 2
  pat_b_high 101, 2
  pat_b_high 102, 2
  pat_b_high 103, 2
  pat_b_high 104, 2
  pat_b_high 105, 2
  pat_b_high 106, 2
  pat_b_high 107, 2
  pat_b_high 108, 2
  pat_b_high 109, 2
  pat_b_high 110, 2
  pat_b_high 111, 2
  pat_b_high 112, 2
  pat_b_high 113, 2
  pat_b_high 114, 2
  pat_b_high 115, 2
  pat_b_high 116, 2
  pat_b_high 117, 2
  pat_b_high 118, 2
  pat_b_high 119, 2
  pat_b_high 120, 2
  pat_b_high 121, 2
  pat_b_high 122, 2
  pat_b_high 123, 2
  pat_b_high 124, 2
  pat_b_high 125, 2
  pat_b_high 126, 2
  pat_b_high 127, 2
  pat_b_high 128, 2
  pat_b_high 129, 2
  pat_b_high 130, 2
  pat_b_high 131, 2
  pat_b_high 132, 2
  pat_b_high 133, 2
  pat_b_high 134, 2
  pat_b_high 135, 2
  pat_b_high 136, 2
  pat_b_high 137, 2
  pat_b_high 138, 2
  pat_b_high 139, 2
  pat_b_high 140, 2
  pat_b_high 141, 2
  pat_b_high 142, 2
  pat_b_high 143, 2
  pat_b_high 144, 2
  pat_b_high 145, 2
  pat_b_high 146, 2
  pat_b_high 147, 2
  pat_b_high 148, 2
  pat_b_high 149, 2
  pat_b_high 150, 2
  pat_b_high 151, 2
  pat_b_high 152, 2
  pat_b_high 153, 2
  pat_b_high 154, 2
  pat_b_high 155, 2
  pat_b_high 156, 2
  pat_b_high 157, 2
  pat_b_high 158, 2
  pat_b_high 159, 2
  pat_b_high 160, 2
  pat_b_high 161, 2
  pat_b_high 162, 2
  pat_b_high 163, 2
  pat_b_high 164, 2
  pat_b_high 165, 2
  pat_b_high 166, 2
  pat_b_high 167, 2
  pat_b_high 168, 2
  pat_b_high 169, 2
  pat_b_high 170, 2
  pat_b_high 171, 2
  pat_b_high 172, 2
  pat_b_high 173, 2
  pat_b_high 174, 2
  pat_b_high 175, 2
  pat_b_high 176, 2
  pat_b_high 177, 2
  pat_b_high 178, 2
  pat_b_high 179, 2
  pat_b_high 180, 2
  pat_b_high 181, 2
  pat_b_high 182, 2
  pat_b_high 183, 2
  pat_b_high 184, 2
  pat_b_high 185, 2
  pat_b_high 186, 2
  pat_b_high 187, 2
  pat_b_high 188, 2
  pat_b_high 189, 2
  pat_b_high 190, 2
  pat_b_high 191, 2
  pat_b_high 192, 2
  pat_b_high 193, 2
  pat_b_high 194, 2
  pat_b_high 195, 2
  pat_b_high 196, 2
  pat_b_high 197, 2
  pat_b_high 198, 2
  pat_b_high 199, 2
  pat_b_high 200, 2
  pat_b_high 201, 2
  pat_b_high 202, 2
  pat_b_high 203, 2
  pat_b_high 204, 2
  pat_b_high 205, 2
  pat_b_high 206, 2
  pat_b_high 207, 2
  pat_b_high 208, 2
  pat_b_high 209, 2
  pat_b_high 210, 2
  pat_b_high 211, 2
  pat_b_high 212, 2
  pat_b_high 213, 2
  pat_b_high 214, 2
  pat_b_high 215, 2
  pat_b_high 216, 2
  pat_b_high 217, 2
  pat_b_high 218, 2
  pat_b_high 219, 2
  pat_b_high 220, 2
  pat_b_high 221, 2
  pat_b_high 222, 2

; byte 3 of pattern low address 
pat_b3_low:

  pat_b_low 0, 3
  pat_b_low 1, 3
  pat_b_low 2, 3
  pat_b_low 3, 3
  pat_b_low 4, 3
  pat_b_low 5, 3
  pat_b_low 6, 3
  pat_b_low 7, 3
  pat_b_low 8, 3
  pat_b_low 9, 3
  pat_b_low 10, 3
  pat_b_low 11, 3
  pat_b_low 12, 3
  pat_b_low 13, 3
  pat_b_low 14, 3
  pat_b_low 15, 3
  pat_b_low 16, 3
  pat_b_low 17, 3
  pat_b_low 18, 3
  pat_b_low 19, 3
  pat_b_low 20, 3
  pat_b_low 21, 3
  pat_b_low 22, 3
  pat_b_low 23, 3
  pat_b_low 24, 3
  pat_b_low 25, 3
  pat_b_low 26, 3
  pat_b_low 27, 3
  pat_b_low 28, 3
  pat_b_low 29, 3
  pat_b_low 30, 3
  pat_b_low 31, 3
  pat_b_low 32, 3
  pat_b_low 33, 3
  pat_b_low 34, 3
  pat_b_low 35, 3
  pat_b_low 36, 3
  pat_b_low 37, 3
  pat_b_low 38, 3
  pat_b_low 39, 3
  pat_b_low 40, 3
  pat_b_low 41, 3
  pat_b_low 42, 3
  pat_b_low 43, 3
  pat_b_low 44, 3
  pat_b_low 45, 3
  pat_b_low 46, 3
  pat_b_low 47, 3
  pat_b_low 48, 3
  pat_b_low 49, 3
  pat_b_low 50, 3
  pat_b_low 51, 3
  pat_b_low 52, 3
  pat_b_low 53, 3
  pat_b_low 54, 3
  pat_b_low 55, 3
  pat_b_low 56, 3
  pat_b_low 57, 3
  pat_b_low 58, 3
  pat_b_low 59, 3
  pat_b_low 60, 3
  pat_b_low 61, 3
  pat_b_low 62, 3
  pat_b_low 63, 3
  pat_b_low 64, 3
  pat_b_low 65, 3
  pat_b_low 66, 3
  pat_b_low 67, 3
  pat_b_low 68, 3
  pat_b_low 69, 3
  pat_b_low 70, 3
  pat_b_low 71, 3
  pat_b_low 72, 3
  pat_b_low 73, 3
  pat_b_low 74, 3
  pat_b_low 75, 3
  pat_b_low 76, 3
  pat_b_low 77, 3
  pat_b_low 78, 3
  pat_b_low 79, 3
  pat_b_low 80, 3
  pat_b_low 81, 3
  pat_b_low 82, 3
  pat_b_low 83, 3
  pat_b_low 84, 3
  pat_b_low 85, 3
  pat_b_low 86, 3
  pat_b_low 87, 3
  pat_b_low 88, 3
  pat_b_low 89, 3
  pat_b_low 90, 3
  pat_b_low 91, 3
  pat_b_low 92, 3
  pat_b_low 93, 3
  pat_b_low 94, 3
  pat_b_low 95, 3
  pat_b_low 96, 3
  pat_b_low 97, 3
  pat_b_low 98, 3
  pat_b_low 99, 3
  pat_b_low 100, 3
  pat_b_low 101, 3
  pat_b_low 102, 3
  pat_b_low 103, 3
  pat_b_low 104, 3
  pat_b_low 105, 3
  pat_b_low 106, 3
  pat_b_low 107, 3
  pat_b_low 108, 3
  pat_b_low 109, 3
  pat_b_low 110, 3
  pat_b_low 111, 3
  pat_b_low 112, 3
  pat_b_low 113, 3
  pat_b_low 114, 3
  pat_b_low 115, 3
  pat_b_low 116, 3
  pat_b_low 117, 3
  pat_b_low 118, 3
  pat_b_low 119, 3
  pat_b_low 120, 3
  pat_b_low 121, 3
  pat_b_low 122, 3
  pat_b_low 123, 3
  pat_b_low 124, 3
  pat_b_low 125, 3
  pat_b_low 126, 3
  pat_b_low 127, 3
  pat_b_low 128, 3
  pat_b_low 129, 3
  pat_b_low 130, 3
  pat_b_low 131, 3
  pat_b_low 132, 3
  pat_b_low 133, 3
  pat_b_low 134, 3
  pat_b_low 135, 3
  pat_b_low 136, 3
  pat_b_low 137, 3
  pat_b_low 138, 3
  pat_b_low 139, 3
  pat_b_low 140, 3
  pat_b_low 141, 3
  pat_b_low 142, 3
  pat_b_low 143, 3
  pat_b_low 144, 3
  pat_b_low 145, 3
  pat_b_low 146, 3
  pat_b_low 147, 3
  pat_b_low 148, 3
  pat_b_low 149, 3
  pat_b_low 150, 3
  pat_b_low 151, 3
  pat_b_low 152, 3
  pat_b_low 153, 3
  pat_b_low 154, 3
  pat_b_low 155, 3
  pat_b_low 156, 3
  pat_b_low 157, 3
  pat_b_low 158, 3
  pat_b_low 159, 3
  pat_b_low 160, 3
  pat_b_low 161, 3
  pat_b_low 162, 3
  pat_b_low 163, 3
  pat_b_low 164, 3
  pat_b_low 165, 3
  pat_b_low 166, 3
  pat_b_low 167, 3
  pat_b_low 168, 3
  pat_b_low 169, 3
  pat_b_low 170, 3
  pat_b_low 171, 3
  pat_b_low 172, 3
  pat_b_low 173, 3
  pat_b_low 174, 3
  pat_b_low 175, 3
  pat_b_low 176, 3
  pat_b_low 177, 3
  pat_b_low 178, 3
  pat_b_low 179, 3
  pat_b_low 180, 3
  pat_b_low 181, 3
  pat_b_low 182, 3
  pat_b_low 183, 3
  pat_b_low 184, 3
  pat_b_low 185, 3
  pat_b_low 186, 3
  pat_b_low 187, 3
  pat_b_low 188, 3
  pat_b_low 189, 3
  pat_b_low 190, 3
  pat_b_low 191, 3
  pat_b_low 192, 3
  pat_b_low 193, 3
  pat_b_low 194, 3
  pat_b_low 195, 3
  pat_b_low 196, 3
  pat_b_low 197, 3
  pat_b_low 198, 3
  pat_b_low 199, 3
  pat_b_low 200, 3
  pat_b_low 201, 3
  pat_b_low 202, 3
  pat_b_low 203, 3
  pat_b_low 204, 3
  pat_b_low 205, 3
  pat_b_low 206, 3
  pat_b_low 207, 3
  pat_b_low 208, 3
  pat_b_low 209, 3
  pat_b_low 210, 3
  pat_b_low 211, 3
  pat_b_low 212, 3
  pat_b_low 213, 3
  pat_b_low 214, 3
  pat_b_low 215, 3
  pat_b_low 216, 3
  pat_b_low 217, 3
  pat_b_low 218, 3
  pat_b_low 219, 3
  pat_b_low 220, 3
  pat_b_low 221, 3
  pat_b_low 222, 3

; byte 3 of pattern high address
pat_b3_high:

  pat_b_high 0, 3
  pat_b_high 1, 3
  pat_b_high 2, 3
  pat_b_high 3, 3
  pat_b_high 4, 3
  pat_b_high 5, 3
  pat_b_high 6, 3
  pat_b_high 7, 3
  pat_b_high 8, 3
  pat_b_high 9, 3
  pat_b_high 10, 3
  pat_b_high 11, 3
  pat_b_high 12, 3
  pat_b_high 13, 3
  pat_b_high 14, 3
  pat_b_high 15, 3
  pat_b_high 16, 3
  pat_b_high 17, 3
  pat_b_high 18, 3
  pat_b_high 19, 3
  pat_b_high 20, 3
  pat_b_high 21, 3
  pat_b_high 22, 3
  pat_b_high 23, 3
  pat_b_high 24, 3
  pat_b_high 25, 3
  pat_b_high 26, 3
  pat_b_high 27, 3
  pat_b_high 28, 3
  pat_b_high 29, 3
  pat_b_high 30, 3
  pat_b_high 31, 3
  pat_b_high 32, 3
  pat_b_high 33, 3
  pat_b_high 34, 3
  pat_b_high 35, 3
  pat_b_high 36, 3
  pat_b_high 37, 3
  pat_b_high 38, 3
  pat_b_high 39, 3
  pat_b_high 40, 3
  pat_b_high 41, 3
  pat_b_high 42, 3
  pat_b_high 43, 3
  pat_b_high 44, 3
  pat_b_high 45, 3
  pat_b_high 46, 3
  pat_b_high 47, 3
  pat_b_high 48, 3
  pat_b_high 49, 3
  pat_b_high 50, 3
  pat_b_high 51, 3
  pat_b_high 52, 3
  pat_b_high 53, 3
  pat_b_high 54, 3
  pat_b_high 55, 3
  pat_b_high 56, 3
  pat_b_high 57, 3
  pat_b_high 58, 3
  pat_b_high 59, 3
  pat_b_high 60, 3
  pat_b_high 61, 3
  pat_b_high 62, 3
  pat_b_high 63, 3
  pat_b_high 64, 3
  pat_b_high 65, 3
  pat_b_high 66, 3
  pat_b_high 67, 3
  pat_b_high 68, 3
  pat_b_high 69, 3
  pat_b_high 70, 3
  pat_b_high 71, 3
  pat_b_high 72, 3
  pat_b_high 73, 3
  pat_b_high 74, 3
  pat_b_high 75, 3
  pat_b_high 76, 3
  pat_b_high 77, 3
  pat_b_high 78, 3
  pat_b_high 79, 3
  pat_b_high 80, 3
  pat_b_high 81, 3
  pat_b_high 82, 3
  pat_b_high 83, 3
  pat_b_high 84, 3
  pat_b_high 85, 3
  pat_b_high 86, 3
  pat_b_high 87, 3
  pat_b_high 88, 3
  pat_b_high 89, 3
  pat_b_high 90, 3
  pat_b_high 91, 3
  pat_b_high 92, 3
  pat_b_high 93, 3
  pat_b_high 94, 3
  pat_b_high 95, 3
  pat_b_high 96, 3
  pat_b_high 97, 3
  pat_b_high 98, 3
  pat_b_high 99, 3
  pat_b_high 100, 3
  pat_b_high 101, 3
  pat_b_high 102, 3
  pat_b_high 103, 3
  pat_b_high 104, 3
  pat_b_high 105, 3
  pat_b_high 106, 3
  pat_b_high 107, 3
  pat_b_high 108, 3
  pat_b_high 109, 3
  pat_b_high 110, 3
  pat_b_high 111, 3
  pat_b_high 112, 3
  pat_b_high 113, 3
  pat_b_high 114, 3
  pat_b_high 115, 3
  pat_b_high 116, 3
  pat_b_high 117, 3
  pat_b_high 118, 3
  pat_b_high 119, 3
  pat_b_high 120, 3
  pat_b_high 121, 3
  pat_b_high 122, 3
  pat_b_high 123, 3
  pat_b_high 124, 3
  pat_b_high 125, 3
  pat_b_high 126, 3
  pat_b_high 127, 3
  pat_b_high 128, 3
  pat_b_high 129, 3
  pat_b_high 130, 3
  pat_b_high 131, 3
  pat_b_high 132, 3
  pat_b_high 133, 3
  pat_b_high 134, 3
  pat_b_high 135, 3
  pat_b_high 136, 3
  pat_b_high 137, 3
  pat_b_high 138, 3
  pat_b_high 139, 3
  pat_b_high 140, 3
  pat_b_high 141, 3
  pat_b_high 142, 3
  pat_b_high 143, 3
  pat_b_high 144, 3
  pat_b_high 145, 3
  pat_b_high 146, 3
  pat_b_high 147, 3
  pat_b_high 148, 3
  pat_b_high 149, 3
  pat_b_high 150, 3
  pat_b_high 151, 3
  pat_b_high 152, 3
  pat_b_high 153, 3
  pat_b_high 154, 3
  pat_b_high 155, 3
  pat_b_high 156, 3
  pat_b_high 157, 3
  pat_b_high 158, 3
  pat_b_high 159, 3
  pat_b_high 160, 3
  pat_b_high 161, 3
  pat_b_high 162, 3
  pat_b_high 163, 3
  pat_b_high 164, 3
  pat_b_high 165, 3
  pat_b_high 166, 3
  pat_b_high 167, 3
  pat_b_high 168, 3
  pat_b_high 169, 3
  pat_b_high 170, 3
  pat_b_high 171, 3
  pat_b_high 172, 3
  pat_b_high 173, 3
  pat_b_high 174, 3
  pat_b_high 175, 3
  pat_b_high 176, 3
  pat_b_high 177, 3
  pat_b_high 178, 3
  pat_b_high 179, 3
  pat_b_high 180, 3
  pat_b_high 181, 3
  pat_b_high 182, 3
  pat_b_high 183, 3
  pat_b_high 184, 3
  pat_b_high 185, 3
  pat_b_high 186, 3
  pat_b_high 187, 3
  pat_b_high 188, 3
  pat_b_high 189, 3
  pat_b_high 190, 3
  pat_b_high 191, 3
  pat_b_high 192, 3
  pat_b_high 193, 3
  pat_b_high 194, 3
  pat_b_high 195, 3
  pat_b_high 196, 3
  pat_b_high 197, 3
  pat_b_high 198, 3
  pat_b_high 199, 3
  pat_b_high 200, 3
  pat_b_high 201, 3
  pat_b_high 202, 3
  pat_b_high 203, 3
  pat_b_high 204, 3
  pat_b_high 205, 3
  pat_b_high 206, 3
  pat_b_high 207, 3
  pat_b_high 208, 3
  pat_b_high 209, 3
  pat_b_high 210, 3
  pat_b_high 211, 3
  pat_b_high 212, 3
  pat_b_high 213, 3
  pat_b_high 214, 3
  pat_b_high 215, 3
  pat_b_high 216, 3
  pat_b_high 217, 3
  pat_b_high 218, 3
  pat_b_high 219, 3
  pat_b_high 220, 3
  pat_b_high 221, 3
  pat_b_high 222, 3

; byte 4 of pattern low address 
pat_b4_low:

  pat_b_low 0, 4
  pat_b_low 1, 4
  pat_b_low 2, 4
  pat_b_low 3, 4
  pat_b_low 4, 4
  pat_b_low 5, 4
  pat_b_low 6, 4
  pat_b_low 7, 4
  pat_b_low 8, 4
  pat_b_low 9, 4
  pat_b_low 10, 4
  pat_b_low 11, 4
  pat_b_low 12, 4
  pat_b_low 13, 4
  pat_b_low 14, 4
  pat_b_low 15, 4
  pat_b_low 16, 4
  pat_b_low 17, 4
  pat_b_low 18, 4
  pat_b_low 19, 4
  pat_b_low 20, 4
  pat_b_low 21, 4
  pat_b_low 22, 4
  pat_b_low 23, 4
  pat_b_low 24, 4
  pat_b_low 25, 4
  pat_b_low 26, 4
  pat_b_low 27, 4
  pat_b_low 28, 4
  pat_b_low 29, 4
  pat_b_low 30, 4
  pat_b_low 31, 4
  pat_b_low 32, 4
  pat_b_low 33, 4
  pat_b_low 34, 4
  pat_b_low 35, 4
  pat_b_low 36, 4
  pat_b_low 37, 4
  pat_b_low 38, 4
  pat_b_low 39, 4
  pat_b_low 40, 4
  pat_b_low 41, 4
  pat_b_low 42, 4
  pat_b_low 43, 4
  pat_b_low 44, 4
  pat_b_low 45, 4
  pat_b_low 46, 4
  pat_b_low 47, 4
  pat_b_low 48, 4
  pat_b_low 49, 4
  pat_b_low 50, 4
  pat_b_low 51, 4
  pat_b_low 52, 4
  pat_b_low 53, 4
  pat_b_low 54, 4
  pat_b_low 55, 4
  pat_b_low 56, 4
  pat_b_low 57, 4
  pat_b_low 58, 4
  pat_b_low 59, 4
  pat_b_low 60, 4
  pat_b_low 61, 4
  pat_b_low 62, 4
  pat_b_low 63, 4
  pat_b_low 64, 4
  pat_b_low 65, 4
  pat_b_low 66, 4
  pat_b_low 67, 4
  pat_b_low 68, 4
  pat_b_low 69, 4
  pat_b_low 70, 4
  pat_b_low 71, 4
  pat_b_low 72, 4
  pat_b_low 73, 4
  pat_b_low 74, 4
  pat_b_low 75, 4
  pat_b_low 76, 4
  pat_b_low 77, 4
  pat_b_low 78, 4
  pat_b_low 79, 4
  pat_b_low 80, 4
  pat_b_low 81, 4
  pat_b_low 82, 4
  pat_b_low 83, 4
  pat_b_low 84, 4
  pat_b_low 85, 4
  pat_b_low 86, 4
  pat_b_low 87, 4
  pat_b_low 88, 4
  pat_b_low 89, 4
  pat_b_low 90, 4
  pat_b_low 91, 4
  pat_b_low 92, 4
  pat_b_low 93, 4
  pat_b_low 94, 4
  pat_b_low 95, 4
  pat_b_low 96, 4
  pat_b_low 97, 4
  pat_b_low 98, 4
  pat_b_low 99, 4
  pat_b_low 100, 4
  pat_b_low 101, 4
  pat_b_low 102, 4
  pat_b_low 103, 4
  pat_b_low 104, 4
  pat_b_low 105, 4
  pat_b_low 106, 4
  pat_b_low 107, 4
  pat_b_low 108, 4
  pat_b_low 109, 4
  pat_b_low 110, 4
  pat_b_low 111, 4
  pat_b_low 112, 4
  pat_b_low 113, 4
  pat_b_low 114, 4
  pat_b_low 115, 4
  pat_b_low 116, 4
  pat_b_low 117, 4
  pat_b_low 118, 4
  pat_b_low 119, 4
  pat_b_low 120, 4
  pat_b_low 121, 4
  pat_b_low 122, 4
  pat_b_low 123, 4
  pat_b_low 124, 4
  pat_b_low 125, 4
  pat_b_low 126, 4
  pat_b_low 127, 4
  pat_b_low 128, 4
  pat_b_low 129, 4
  pat_b_low 130, 4
  pat_b_low 131, 4
  pat_b_low 132, 4
  pat_b_low 133, 4
  pat_b_low 134, 4
  pat_b_low 135, 4
  pat_b_low 136, 4
  pat_b_low 137, 4
  pat_b_low 138, 4
  pat_b_low 139, 4
  pat_b_low 140, 4
  pat_b_low 141, 4
  pat_b_low 142, 4
  pat_b_low 143, 4
  pat_b_low 144, 4
  pat_b_low 145, 4
  pat_b_low 146, 4
  pat_b_low 147, 4
  pat_b_low 148, 4
  pat_b_low 149, 4
  pat_b_low 150, 4
  pat_b_low 151, 4
  pat_b_low 152, 4
  pat_b_low 153, 4
  pat_b_low 154, 4
  pat_b_low 155, 4
  pat_b_low 156, 4
  pat_b_low 157, 4
  pat_b_low 158, 4
  pat_b_low 159, 4
  pat_b_low 160, 4
  pat_b_low 161, 4
  pat_b_low 162, 4
  pat_b_low 163, 4
  pat_b_low 164, 4
  pat_b_low 165, 4
  pat_b_low 166, 4
  pat_b_low 167, 4
  pat_b_low 168, 4
  pat_b_low 169, 4
  pat_b_low 170, 4
  pat_b_low 171, 4
  pat_b_low 172, 4
  pat_b_low 173, 4
  pat_b_low 174, 4
  pat_b_low 175, 4
  pat_b_low 176, 4
  pat_b_low 177, 4
  pat_b_low 178, 4
  pat_b_low 179, 4
  pat_b_low 180, 4
  pat_b_low 181, 4
  pat_b_low 182, 4
  pat_b_low 183, 4
  pat_b_low 184, 4
  pat_b_low 185, 4
  pat_b_low 186, 4
  pat_b_low 187, 4
  pat_b_low 188, 4
  pat_b_low 189, 4
  pat_b_low 190, 4
  pat_b_low 191, 4
  pat_b_low 192, 4
  pat_b_low 193, 4
  pat_b_low 194, 4
  pat_b_low 195, 4
  pat_b_low 196, 4
  pat_b_low 197, 4
  pat_b_low 198, 4
  pat_b_low 199, 4
  pat_b_low 200, 4
  pat_b_low 201, 4
  pat_b_low 202, 4
  pat_b_low 203, 4
  pat_b_low 204, 4
  pat_b_low 205, 4
  pat_b_low 206, 4
  pat_b_low 207, 4
  pat_b_low 208, 4
  pat_b_low 209, 4
  pat_b_low 210, 4
  pat_b_low 211, 4
  pat_b_low 212, 4
  pat_b_low 213, 4
  pat_b_low 214, 4
  pat_b_low 215, 4
  pat_b_low 216, 4
  pat_b_low 217, 4
  pat_b_low 218, 4
  pat_b_low 219, 4
  pat_b_low 220, 4
  pat_b_low 221, 4
  pat_b_low 222, 4

; byte 4 of pattern high address 
pat_b4_high:

  pat_b_high 0, 4
  pat_b_high 1, 4
  pat_b_high 2, 4
  pat_b_high 3, 4
  pat_b_high 4, 4
  pat_b_high 5, 4
  pat_b_high 6, 4
  pat_b_high 7, 4
  pat_b_high 8, 4
  pat_b_high 9, 4
  pat_b_high 10, 4
  pat_b_high 11, 4
  pat_b_high 12, 4
  pat_b_high 13, 4
  pat_b_high 14, 4
  pat_b_high 15, 4
  pat_b_high 16, 4
  pat_b_high 17, 4
  pat_b_high 18, 4
  pat_b_high 19, 4
  pat_b_high 20, 4
  pat_b_high 21, 4
  pat_b_high 22, 4
  pat_b_high 23, 4
  pat_b_high 24, 4
  pat_b_high 25, 4
  pat_b_high 26, 4
  pat_b_high 27, 4
  pat_b_high 28, 4
  pat_b_high 29, 4
  pat_b_high 30, 4
  pat_b_high 31, 4
  pat_b_high 32, 4
  pat_b_high 33, 4
  pat_b_high 34, 4
  pat_b_high 35, 4
  pat_b_high 36, 4
  pat_b_high 37, 4
  pat_b_high 38, 4
  pat_b_high 39, 4
  pat_b_high 40, 4
  pat_b_high 41, 4
  pat_b_high 42, 4
  pat_b_high 43, 4
  pat_b_high 44, 4
  pat_b_high 45, 4
  pat_b_high 46, 4
  pat_b_high 47, 4
  pat_b_high 48, 4
  pat_b_high 49, 4
  pat_b_high 50, 4
  pat_b_high 51, 4
  pat_b_high 52, 4
  pat_b_high 53, 4
  pat_b_high 54, 4
  pat_b_high 55, 4
  pat_b_high 56, 4
  pat_b_high 57, 4
  pat_b_high 58, 4
  pat_b_high 59, 4
  pat_b_high 60, 4
  pat_b_high 61, 4
  pat_b_high 62, 4
  pat_b_high 63, 4
  pat_b_high 64, 4
  pat_b_high 65, 4
  pat_b_high 66, 4
  pat_b_high 67, 4
  pat_b_high 68, 4
  pat_b_high 69, 4
  pat_b_high 70, 4
  pat_b_high 71, 4
  pat_b_high 72, 4
  pat_b_high 73, 4
  pat_b_high 74, 4
  pat_b_high 75, 4
  pat_b_high 76, 4
  pat_b_high 77, 4
  pat_b_high 78, 4
  pat_b_high 79, 4
  pat_b_high 80, 4
  pat_b_high 81, 4
  pat_b_high 82, 4
  pat_b_high 83, 4
  pat_b_high 84, 4
  pat_b_high 85, 4
  pat_b_high 86, 4
  pat_b_high 87, 4
  pat_b_high 88, 4
  pat_b_high 89, 4
  pat_b_high 90, 4
  pat_b_high 91, 4
  pat_b_high 92, 4
  pat_b_high 93, 4
  pat_b_high 94, 4
  pat_b_high 95, 4
  pat_b_high 96, 4
  pat_b_high 97, 4
  pat_b_high 98, 4
  pat_b_high 99, 4
  pat_b_high 100, 4
  pat_b_high 101, 4
  pat_b_high 102, 4
  pat_b_high 103, 4
  pat_b_high 104, 4
  pat_b_high 105, 4
  pat_b_high 106, 4
  pat_b_high 107, 4
  pat_b_high 108, 4
  pat_b_high 109, 4
  pat_b_high 110, 4
  pat_b_high 111, 4
  pat_b_high 112, 4
  pat_b_high 113, 4
  pat_b_high 114, 4
  pat_b_high 115, 4
  pat_b_high 116, 4
  pat_b_high 117, 4
  pat_b_high 118, 4
  pat_b_high 119, 4
  pat_b_high 120, 4
  pat_b_high 121, 4
  pat_b_high 122, 4
  pat_b_high 123, 4
  pat_b_high 124, 4
  pat_b_high 125, 4
  pat_b_high 126, 4
  pat_b_high 127, 4
  pat_b_high 128, 4
  pat_b_high 129, 4
  pat_b_high 130, 4
  pat_b_high 131, 4
  pat_b_high 132, 4
  pat_b_high 133, 4
  pat_b_high 134, 4
  pat_b_high 135, 4
  pat_b_high 136, 4
  pat_b_high 137, 4
  pat_b_high 138, 4
  pat_b_high 139, 4
  pat_b_high 140, 4
  pat_b_high 141, 4
  pat_b_high 142, 4
  pat_b_high 143, 4
  pat_b_high 144, 4
  pat_b_high 145, 4
  pat_b_high 146, 4
  pat_b_high 147, 4
  pat_b_high 148, 4
  pat_b_high 149, 4
  pat_b_high 150, 4
  pat_b_high 151, 4
  pat_b_high 152, 4
  pat_b_high 153, 4
  pat_b_high 154, 4
  pat_b_high 155, 4
  pat_b_high 156, 4
  pat_b_high 157, 4
  pat_b_high 158, 4
  pat_b_high 159, 4
  pat_b_high 160, 4
  pat_b_high 161, 4
  pat_b_high 162, 4
  pat_b_high 163, 4
  pat_b_high 164, 4
  pat_b_high 165, 4
  pat_b_high 166, 4
  pat_b_high 167, 4
  pat_b_high 168, 4
  pat_b_high 169, 4
  pat_b_high 170, 4
  pat_b_high 171, 4
  pat_b_high 172, 4
  pat_b_high 173, 4
  pat_b_high 174, 4
  pat_b_high 175, 4
  pat_b_high 176, 4
  pat_b_high 177, 4
  pat_b_high 178, 4
  pat_b_high 179, 4
  pat_b_high 180, 4
  pat_b_high 181, 4
  pat_b_high 182, 4
  pat_b_high 183, 4
  pat_b_high 184, 4
  pat_b_high 185, 4
  pat_b_high 186, 4
  pat_b_high 187, 4
  pat_b_high 188, 4
  pat_b_high 189, 4
  pat_b_high 190, 4
  pat_b_high 191, 4
  pat_b_high 192, 4
  pat_b_high 193, 4
  pat_b_high 194, 4
  pat_b_high 195, 4
  pat_b_high 196, 4
  pat_b_high 197, 4
  pat_b_high 198, 4
  pat_b_high 199, 4
  pat_b_high 200, 4
  pat_b_high 201, 4
  pat_b_high 202, 4
  pat_b_high 203, 4
  pat_b_high 204, 4
  pat_b_high 205, 4
  pat_b_high 206, 4
  pat_b_high 207, 4
  pat_b_high 208, 4
  pat_b_high 209, 4
  pat_b_high 210, 4
  pat_b_high 211, 4
  pat_b_high 212, 4
  pat_b_high 213, 4
  pat_b_high 214, 4
  pat_b_high 215, 4
  pat_b_high 216, 4
  pat_b_high 217, 4
  pat_b_high 218, 4
  pat_b_high 219, 4
  pat_b_high 220, 4
  pat_b_high 221, 4
  pat_b_high 222, 4

; below this are inserted at runtime

